// //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This class is produced by AST. Check homepage when you need any help.
// Mail Address.    ast@freedom.ne.jp
// Official HP URL. http://www.freedom.ne.jp/ast/
// Refarence URL.   http://www.freedom.ne.jp/ast/library/scritical.html


#ifndef __SCritical_H__
#define __SCritical_H__

#define	USESDL	0

#if USESDL
	#include "sdl/sdl.h"
#else
	#include <windows.h>
#endif

class SCritical
{
public:

	// ....................................................................................................................................... //
	SCritical();
	~SCritical();

	void Lock();
	void UnLock();
	// ....................................................................................................................................... //


private:
	// ======================================================================================================================================= //
#if USESDL
	SDL_mutex *mut;
//	SDL_sem *sem;
#else
	CRITICAL_SECTION	m_CriticalSection;
#endif
	// ======================================================================================================================================= //
};


// ....................................................................................................................................... //

inline SCritical::SCritical()
{
#if USESDL
	this->mut = SDL_CreateMutex();
//	this->sem = SDL_CreateSemaphore( 1 );
#else
	::InitializeCriticalSection( &(this->m_CriticalSection) );
#endif
}

inline SCritical::~SCritical()
{
#if USESDL
	SDL_DestroyMutex( this->mut );
//	SDL_DestroySemaphore( this->sem );

#else
	::DeleteCriticalSection( &(this->m_CriticalSection) );
#endif
}

inline void SCritical::Lock()
{
#if USESDL
	SDL_LockMutex( this->mut );
//	SDL_SemWait( this->sem );
#else
	::EnterCriticalSection( &(this->m_CriticalSection) );
#endif
}

inline void SCritical::UnLock()
{
#if USESDL
	SDL_UnlockMutex( this->mut );
//	SDL_SemPost( this->sem );
#else
	::LeaveCriticalSection( &(this->m_CriticalSection) );
#endif
}

// ....................................................................................................................................... //


#endif //__SCritical_H__
