#ifndef AY8910_H_INCLUDED
#define AY8910_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "sound.h"
#include "ticker.h"



////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cJoy {
protected:
	SDL_Joystick *joy;
	int Buttons;					// ܥ
	
public:
	cJoy();							// 󥹥ȥ饯
	virtual ~cJoy();				// ǥȥ饯
	
	BYTE GetJoyState();				// 祤ƥåξּ
};


class cAY8910 {
protected:
	int RegisterLatch;
	BYTE Regs[16];
	int UpdateStep;
	int PeriodA, PeriodB, PeriodC, PeriodN, PeriodE;
	int CountA, CountB, CountC, CountN, CountE;
	int VolA, VolB, VolC, VolE;
	BYTE EnvelopeA, EnvelopeB, EnvelopeC;
	BYTE OutputA, OutputB, OutputC, OutputN;
	signed char CountEnv;
	BYTE Hold,Alternate,Attack,Holding;
	int RNG;
	Uint16 VolTable[32];
	
	void _AYWriteReg( BYTE, BYTE );	// 쥸ߥ
	void AYWriteReg( BYTE, BYTE );	// 쥸
	BYTE AYReadReg( BYTE );			// 쥸ɹ
	
	void SetStream( cRing *, cRing *, cRing * );	// ȥ꡼ݥ
	void SetClock( int, int );		// PSGå
	
	virtual BYTE PortAread(){ return 0xff; }
	virtual BYTE PortBread(){ return 0xff; }
	virtual void PortAwrite( BYTE ){}
	virtual void PortBwrite( BYTE ){}
	
	cRing *Buf[3];					// ȥ꡼ݥ
	
	virtual int GetUpdateSamples(){ return 0; }	// ץ
	
public:
	cAY8910();						// 󥹥ȥ饯
	virtual ~cAY8910();				// ǥȥ饯
	
	void Reset( void );				// PSG ꥻå
	
	void SetVolume( int );			// PSG ܥ塼ơ֥
	
	void Update( int );				// ȥ꡼๹
};


class cP6psg : public Device, public cAY8910, public cJoy, public IDoko {
private:
	cP6sche *lpP6sche;			// 塼饪֥ȤؤΥݥ
	
	int SampleRate;				// ץ󥰥졼
	
	BYTE PortAread(){ return cJoy::GetJoyState(); }
	BYTE PortBread(){ return cJoy::GetJoyState(); }
//	void PortAwrite( BYTE ){}
//	void PortBwrite( BYTE ){}
	
	int GetUpdateSamples(){ return lpP6sche->PsgUpdateSamples( SampleRate ); }	// ץ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutA0H( DWORD, BYTE data ){ cAY8910::RegisterLatch = data & 0x0f; }					// PSG쥸ɥ쥹å
	inline void OutA1H( DWORD, BYTE data ){ cAY8910::AYWriteReg( cAY8910::RegisterLatch, data ); }	// PSG饤ȥǡ
	inline void OutA3H( DWORD, BYTE data ){}														// PSG󥢥ƥ
	inline BYTE InA2H( DWORD ){ return cAY8910::AYReadReg( cAY8910::RegisterLatch ); }				// PSG꡼ɥǡ
	
public:
	cP6psg( const ID& id );			// 󥹥ȥ饯
	~cP6psg();						// ǥȥ饯
	
	BOOL Init( cP6sche *, cRing *, cRing *, cRing *, int );	// 
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ outA0H=0, outA1H, outA3H };
	// INǥХID
	enum IDIn{ inA2H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// AY8910_H_INCLUDED
