#include "console.h"

#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <ctype.h>

#define BUFSIZE 256

SDL_Surface *cBDF::zFont = NULL;	// ѥեȥǡեؤΥݥ
SDL_Surface *cBDF::hFont = NULL;	// ȾѥեȥǡեؤΥݥ
int cBDF::zWidth  = 0;				// ʸ
int cBDF::zHeight = 0;				//           ⤵
int cBDF::zOrgX   = 0;				// ʸθ Xɸ
int cBDF::zOrgY   = 0;				//                Yɸ
int cBDF::hWidth  = 0;				// Ⱦʸ
int cBDF::hHeight = 0;				//           ⤵
int cBDF::hOrgX   = 0;				// Ⱦʸθ Xɸ
int cBDF::hOrgY   = 0;				//                Yɸ


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cBDF::cBDF()
{
}

////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cBDF::~cBDF()
{
}


////////////////////////////////////////////////////////////////
// EUC -> JIS
////////////////////////////////////////////////////////////////
void cBDF::Euc2Jis( Uint8 *c1, Uint8 *c2 )
{
	*c1 &= 0x7f;
	*c2 &= 0x7f;
}


////////////////////////////////////////////////////////////////
// SJIS -> JIS
////////////////////////////////////////////////////////////////
void cBDF::Sjis2Jis( Uint8 *c1, Uint8 *c2 )
{
	if( *c2 < 0x9f ){
		if( *c1 < 0xa0 ){
			*c1 -= 0x81;
			*c1 *= 2;
			*c1 += 0x21;
		}else{
			*c1 -= 0xe0;
			*c1 *= 2;
			*c1 += 0x5f;
		}
		if( *c2 > 0x7f ) --*c2;
		*c2 -= 0x1f;
	}else{
		if( *c1 < 0xa0 ){
			*c1 -= 0x81;
			*c1 *= 2;
			*c1 += 0x22;
		}else{
			*c1 -= 0xe0;
			*c1 *= 2;
			*c1 += 0x60;
		}
		*c2 -= 0x7e;
	}
}


////////////////////////////////////////////////////////////////
// ɷѴ
////////////////////////////////////////////////////////////////
void cBDF::ConvertCodingSystem( Uint8 *c1, Uint8 *c2 )
{
	// ShiftJIS?
	if( (*c1 >= 0x81 && *c1 <= 0x9f || *c1 >= 0xe0 && *c1 <= 0xfc) && (*c2 >= 0x40 && *c2 <= 0xfc && *c2 != 0x7f) )
		Sjis2Jis( c1, c2 );
	// EUC?
	else if( (*c1 >= 0xa1 && *c1 <= 0xfe) && (*c2 >= 0xa1 && *c1 <= 0xfe) )
		Euc2Jis( c1, c2 );
}





////////////////////////////////////////////////////////////////
// BDFե뤫°ͤɤ
////////////////////////////////////////////////////////////////
char *cBDF::GetBDFAttr( FILE *fp, char *attr, char **a1=NULL, char **a2=NULL, char **a3=NULL, char **a4=NULL )
{
	static char buf[BUFSIZE];
	static char NullStr = '\0';	// ߡʸ
	
	if( !fp ) return NULL;
	
	while( fgets( buf, sizeof(buf), fp ) ){
		// Ե
		*strchr( buf, '\n' ) = '\0';
		
		// Ū°õ
		// ȡʬ䤷
		char *p = strtok( buf, BDFSEP );
		if( !stricmp( p, attr ) ){
			if( !(p=strtok( NULL, BDFSEP )) ) p = &NullStr;
			if( a1 ) *a1 = p;
			if( a2 ) if( !( *a2=strtok( NULL, BDFSEP ) ) ) *a2 = &NullStr;
			if( a3 ) if( !( *a3=strtok( NULL, BDFSEP ) ) ) *a3 = &NullStr;
			if( a4 ) if( !( *a4=strtok( NULL, BDFSEP ) ) ) *a4 = &NullStr;
			return p;
		}
	}
	
	return NULL;
}


////////////////////////////////////////////////////////////////
// BDFե򳫤
////////////////////////////////////////////////////////////////
BOOL cBDF::OpenFont( char *zfilename, char *hfilename )
{
	char *a1,*a2,*a3,*a4;
	FILE *fp;
	
	// ʸ
	if( zfilename ){
		fp = fopen( zfilename, "rt" );
		if( !fp ) return FALSE;
		
		// եȤΥץѥƥɹ
		GetBDFAttr( fp, "FONTBOUNDINGBOX", &a1, &a2, &a3, &a4 );
		zWidth  =  strtol( a1, 0, 10 );	// 
		zHeight =  strtol( a2, 0, 10 );	// ⤵
		zOrgX   = -strtol( a3, 0, 10 );	// Xɸ
		zOrgY   = -strtol( a4, 0, 10 );	// Yɸ
		
		// եȥե
		zFont = SDL_CreateRGBSurface( SDL_SWSURFACE | SDL_SRCCOLORKEY, zWidth * ZMOJI, zHeight * ZMOJI, 8, 0, 0, 0, 0 );
		
		// եɲ
		AddFont( fp );
		
		fclose( fp );
	}
	
	// Ⱦʸ
	if( hfilename ){
		fp = fopen( hfilename, "rt" );
		if( !fp ) return FALSE;
		
		// եȤΥץѥƥɹ
		GetBDFAttr( fp, "FONTBOUNDINGBOX", &a1, &a2, &a3, &a4 );
		hWidth  =  strtol( a1, 0, 10 );	// 
		hHeight =  strtol( a2, 0, 10 );	// ⤵
		hOrgX   = -strtol( a3, 0, 10 );	// Xɸ
		hOrgY   = -strtol( a4, 0, 10 );	// Yɸ
		
		// եȥե
		hFont = SDL_CreateRGBSurface( SDL_SWSURFACE | SDL_SRCCOLORKEY, hWidth * HMOJI, hHeight * HMOJI, 8, 0, 0, 0, 0 );
		
		// եɲ
		AddFont( fp );
		
		fclose( fp );
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// եȤ˴
////////////////////////////////////////////////////////////////
void cBDF::CloseFont( void )
{
	if( zFont ){
		SDL_FreeSurface( zFont );
		zFont = NULL;
	}
	if( hFont ){
		SDL_FreeSurface( hFont );
		hFont = NULL;
	}
}


void cBDF::ParseChar( FILE *fp, SDL_Surface *surf, int index, int height, int width )
{
	char buf[BUFSIZE];
	
	if( !surf ) return;
	
	Uint32 mask = 0x80<<(((width-1)>>3)*8);
	
	// "BBX" õ
	SDL_Rect bbx;
	char *bx,*by,*dx,*dy;
	GetBDFAttr( fp, "BBX", &bx, &by, &dx, &dy );
	bbx.x = -strtol( dx, 0, 10 );
	bbx.y = -strtol( dy, 0, 10 );
	bbx.w =  strtol( bx, 0, 10 );
	bbx.h =  strtol( by, 0, 10 );
	
	// "BITMAP" ޤǶɤ
	if( GetBDFAttr( fp, "BITMAP" ) ){
		// ox,oy:եȤΥХܥåκ
		int MojiNum = surf->w / width;
		int ox = ( index - (index/MojiNum) * MojiNum ) * width;
		int oy = (index/MojiNum) * height;
		
		int minx = max( 0, ox );
		int miny = max( 0, oy );
		int maxx = min( surf->w, bbx.w + ox );
		int maxy = min( surf->h, bbx.h + oy );
		
		if( SDL_MUSTLOCK( surf ) ) SDL_LockSurface( surf );
		for( int y=miny; y < maxy; y++ ){
			fgets( buf, sizeof(buf), fp );
			Uint16 data = strtol( buf, 0, 16 );
			for( int x=minx; x < maxx; x++ ){
				PutPixel( surf, x, y, data&mask ? 0xff : 0 );
				data <<= 1;
			}
		}
		if( SDL_MUSTLOCK( surf ) ) SDL_UnlockSurface( surf );
	}
}


////////////////////////////////////////////////////////////////
// եɲ
////////////////////////////////////////////////////////////////
void cBDF::AddFont( FILE *fp )
{
	// "ENCODING" õ
	while( char *p = GetBDFAttr( fp, "ENCODING" ) ){
		// ʸɼ
		int index = strtol( p, 0, 10 );
		
		if( index > 255 ){
			// ξ祳Ѵ
			index = (((index & 0xff00) >> 8) - 0x20) * 96 + (index & 0xff) - 0x20;
			ParseChar( fp, zFont, index, zHeight, zWidth );
		}else{
			ParseChar( fp, hFont, index, hHeight, hWidth );
		}
	}
	
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cBDF::PutPixel( SDL_Surface *surface, int x, int y, Uint8 pixel )
{
	SDL_Rect *cr = &surface->clip_rect;
	if( x >= cr->x && x < cr->x + cr->w && y >= cr->y && y < cr->y + cr->h ){
		Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x;
		*p = pixel;
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
Uint8 cBDF::GetPixel( SDL_Surface *surface, int x, int y )
{
	SDL_Rect *cr = &surface->clip_rect;
	if( x >= cr->x && x < cr->x + cr->w && y >= cr->y && y < cr->y + cr->h ){
		Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x;
		return *p;
	}else
		return 0;
}


////////////////////////////////////////////////////////////////
// Ⱦʸ
////////////////////////////////////////////////////////////////
void cBDF::PutCharh( SDL_Surface* dst, int dx, int dy, Uint8 txt, Uint8 fg, Uint8 bg )
{
	int index = txt;
	
	// åԥ
	SDL_Rect sr,dr;
	sr.x = ( index - (index/HMOJI) * HMOJI ) * hWidth;
	sr.y = (index/HMOJI) * hHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = hWidth;
	sr.h = dr.h = hHeight;
	
	// ž
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			PutPixel( dst, dr.x + x, dr.y + y, (Uint8)( GetPixel( hFont, sr.x + x, sr.y + y ) ? fg : bg ) );
}


////////////////////////////////////////////////////////////////
// ʸ
////////////////////////////////////////////////////////////////
void cBDF::PutCharz( SDL_Surface* dst, int dx, int dy, Uint16 txt, Uint8 fg, Uint8 bg )
{
	Uint8 high = (txt>>8) & 0xff;
	Uint8 low  =  txt     & 0xff;
	
	ConvertCodingSystem( &high, &low );
	int index = ( high - 0x20 ) * 96 + low - 0x20;
	
	// åԥ
	SDL_Rect sr,dr;
	sr.x = ( index - (index/ZMOJI) * ZMOJI ) * zWidth;
	sr.y = (index/ZMOJI) * zHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = zWidth;
	sr.h = dr.h = zHeight;
	
	// ž
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			PutPixel( dst, dr.x + x, dr.y + y, (Uint8)( GetPixel( zFont, sr.x + x, sr.y + y ) ? fg : bg ) );
}







////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cZCons::cZCons()
{
	Surf = NULL;
	Xmax = Ymax = x = y = 0;
	fgc = FC_WHITE;
	bgc = FC_BLACK;
	
	pos.x = pos.y = pos.w = pos.h = 0;
}

////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cZCons::~cZCons()
{
}


////////////////////////////////////////////////////////////////
// 󥽡
////////////////////////////////////////////////////////////////
SDL_Surface *cZCons::Create( int winx, int winy, char *title )
{
	// Ѥߤʤ餤ä
	if( Surf ) SDL_FreeSurface( Surf );
	
	// ե
	Surf = SDL_CreateRGBSurface( SDL_SWSURFACE, winx*hWidth, winy*hHeight, 8, 0, 0, 0, 0 );
	if( !Surf ) return NULL;
	
	// ѥåȺ(Ȥꤢ16)
	SDL_Color col[16];
	for( int i=0; i<16; i++ ){
		col[i].r = (i&4 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
		col[i].g = (i&2 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
		col[i].b = (i&1 ? 0xff : 0) >> (!(i&8) ? 1 : 0);
	}
	if( !SDL_SetColors( Surf, col, 0, 16 ) ){
		SDL_FreeSurface( Surf );
		Surf = NULL;
		return NULL;
	}
	
	pos.w = Surf->w;
	pos.h = Surf->h;
	
	if( title ){
		// 
		Xmax = Surf->w / hWidth;
		Ymax = Surf->h / hHeight;
		con.x = con.y = 0;
		con.w = Xmax * hWidth;
		con.h = Ymax * hHeight;
		
		Locate(      0,      0 );	PutCharH( 0x18 );	// 
		Locate( Xmax-1,      0 );	PutCharH( 0x19 );	// 
		Locate(      0, Ymax-1 );	PutCharH( 0x1a );	// 
		Locate( Xmax-1, Ymax-1 );	PutCharH( 0x1b );	// 
		for( int i=1; i<Xmax-1; i++ ){	// 
			Locate( i,      0 );	PutCharH( 0x17 );
			Locate( i, Ymax-1 );	PutCharH( 0x17 );
		}
		for( int i=1; i<Ymax-1; i++ ){	// 
			Locate( 0,      i );	PutCharH( 0x16 );
			Locate( Xmax-1, i );	PutCharH( 0x16 );
		}
		
		// ȥ
		char str[128];
		strncpy( str, title, Xmax-2 );
		Locate( 1, 0 );
		Print( " %s ", str );
		
		// Ĳʸ
		Xmax = Surf->w / hWidth - 2;
		Ymax = Surf->h / hHeight - 2;
		
		// ϰ
		con.x = hWidth;
		con.y = hHeight;
		con.w = Xmax * hWidth;
		con.h = Ymax * hHeight;
		
	}else{
		
		// Ĳʸ
		Xmax = Surf->w / hWidth;
		Ymax = Surf->h / hHeight;
		
		// ϰ
		con.x = con.y = 0;
		con.w = Xmax * hWidth;
		con.h = Ymax * hHeight;
	}
	
	x = y = 0;
	
	return Surf;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cZCons::Locate( int xx, int yy )
{
	// üüå
	// ä鱦üü
	if( ( xx >= 0 )&&( xx < Xmax ) ) x = xx;
	else if( ( xx < 0 )&&( (Xmax-xx)>=0 ) ) x = Xmax + xx;
	
	if( ( yy >= 0 )&&( yy < Ymax ) ) y = yy;
	else if( ( yy < 0 )&&( (Ymax-yy)>=0 ) ) y = Ymax + yy;
}


////////////////////////////////////////////////////////////////
// (ܺɸ)
////////////////////////////////////////////////////////////////
void cZCons::LocateR( int xx, int yy )
{
	x += xx;
	if( x < 0 ) x = 0;
	if( x >= Xmax ) x = Xmax;
	
	y += yy;
	if( y < 0 ) y = 0;
	if( y >= Ymax ) y = Ymax;
}


////////////////////////////////////////////////////////////////
// 迧
////////////////////////////////////////////////////////////////
void cZCons::SetColor( Uint8 fg, Uint8 bg )
{
	fgc = fg;
	bgc = bg;
}

void cZCons::SetColor( Uint8 fg )
{
	fgc = fg;
}


////////////////////////////////////////////////////////////////
// ̾õ
////////////////////////////////////////////////////////////////
void cZCons::Cls( void )
{
	// ϰϤطʿɤĤ֤
	if( Surf ) SDL_FillRect( Surf, &con, bgc );
	// ᤹ۡ
	x = y = 0;
}


////////////////////////////////////////////////////////////////
// Ⱦ1ʸ
////////////////////////////////////////////////////////////////
void cZCons::PutCharH( Uint8 c )
{
	cBDF::PutCharh( Surf, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// Υ
	x++;
}


////////////////////////////////////////////////////////////////
// 1ʸ
////////////////////////////////////////////////////////////////
void cZCons::PutCharZ( Uint16 c )
{
	cBDF::PutCharz( Surf, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// Υ
	x += 2;
}


////////////////////////////////////////////////////////////////
// ʸ(ʸб)
////////////////////////////////////////////////////////////////
void cZCons::Print( char *text, ... )
{
	Uint8 buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ĹŸʸѴ
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// ʸ(ʸб)
////////////////////////////////////////////////////////////////
void cZCons::Printf( char *text, ... )
{
	Uint8 buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ĹŸʸѴ
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		switch( buf[i] ){
		case '\n':	// 
			x = 0;
			y++;
			break;
			
		default:	// ̤ʸ
			if( isprint( buf[i] ) )
				PutCharH( buf[i] );
			else{
				PutCharZ( buf[i]<<8 | buf[i+1] );
				i++;
			}
			
			// Υ
			if( x >= Xmax ){
				x = 0;
				y++;
			}
		}
		
		// ?
		if( y == Ymax){
			y--;
			ScrollUp();
		}
	}
}


////////////////////////////////////////////////////////////////
// ʸ(ͤ)
////////////////////////////////////////////////////////////////
void cZCons::Printfr( char *text, ... )
{
	char buf[1024];
	int num = 0;
	va_list ap;
	
	if( !Surf ) return;
	
	// ĹŸʸѴ
	va_start( ap, text );
	num = vsprintf( buf, text, ap );
	
	if( num > Xmax ) num = Xmax;
	Locate( -num, y );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// 륢å
////////////////////////////////////////////////////////////////
void cZCons::ScrollUp( void )
{
	SDL_Rect SPos,DPos;
	
	// ž
	SPos.x = con.x;
	SPos.y = con.y + hHeight;
	SPos.w = con.w;
	SPos.h = con.h - hHeight;
	
	// ž
	DPos.x = con.x;
	DPos.y = con.y;
	
	// 
	SDL_BlitSurface( Surf, &SPos, Surf, &DPos );
	
	// ϰϤطʿɤĤ֤
	DPos.x = con.x;
	DPos.y = con.y + con.h - hHeight;
	DPos.w = con.w;
	DPos.h = hHeight;
	SDL_FillRect( Surf, &DPos, bgc );
}


////////////////////////////////////////////////////////////////
// ꡼ɽ
////////////////////////////////////////////////////////////////
void cZCons::Show( void )
{
	SDL_BlitSurface( Surf, NULL, SDL_GetVideoSurface(), &pos );
}
