#include <stdlib.h>
#include <string.h>

#include "debug.h"


#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
//------------------------------------------------------
//  ץɥ饹
//------------------------------------------------------
////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cWndMem::cWndMem( void )
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cWndMem::~cWndMem( void )
{
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
SDL_Surface *cWndMem::Init( cP6memory *mem )
{
	// ֥ȤؤΥݥ󥿤¸
	lpcP6memory = mem;
	
	// ɽɥ쥹
	Addr = 0;
	
	return cZCons::Create( MEMWINW, MEMWINH, "MEMORY" );
}


////////////////////////////////////////////////////////////////
// ɥ
////////////////////////////////////////////////////////////////
void cWndMem::Update( void )
{
	WORD addr = Addr;
	static Uint8 TexCol[] = { FC_GRAY, FC_BLUE, FC_GREEN, FC_CYAN, FC_RED, FC_MAGENTA, FC_YELLOW, FC_WHITE };
	char mb[32];
	int i,j;
	
	cZCons::Locate( 0, 0 );
	
	// Read ֥å̾ɽ
	cZCons::Printf( "R" );
	for( i=0; i<4; i++ ){
		cZCons::SetColor( TexCol[i] );
		cZCons::Printf( " %-8s", lpcP6memory->GetReadMemBlk( i, mb ) );
	}
	cZCons::Printf( "\n " );
	for( i=4; i<8; i++ ){
		cZCons::SetColor( TexCol[i] );
		cZCons::Printf( " %-8s", lpcP6memory->GetReadMemBlk( i, mb ) );
	}
	cZCons::Printf( "\nW" );
	
	// Write ֥å̾ɽ
	for( i=0; i<4; i++ ){
		cZCons::SetColor( TexCol[i] );
		cZCons::Printf( " %-8s", lpcP6memory->GetWriteMemBlk( i, mb ) );
	}
	cZCons::Printf( "\n " );
	for( i=4; i<8; i++ ){
		cZCons::SetColor( TexCol[i] );
		cZCons::Printf( " %-8s", lpcP6memory->GetWriteMemBlk( i, mb ) );
	}
	cZCons::Printf( "\n" );
	
	// ɽ
	for( i=0; i<cZCons::GetYline()-5; i++ ){
		cZCons::Printf( "\n" );
		cZCons::SetColor( TexCol[ addr>>13 ] );
		cZCons::Printf( "%04X:", addr );
		cZCons::SetColor( FC_WHITE );
		for( j=0; j<8; j++)
			cZCons::Printf( "%02X ", lpcP6memory->Read(addr+j) );
		for( j=0; j<8; j++)
			cZCons::PutCharH( lpcP6memory->Read(addr+j) );
		addr += 8;
	}
}


//------------------------------------------------------
//  쥸ɥ饹
//------------------------------------------------------
////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cWndReg::cWndReg( void )
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cWndReg::~cWndReg( void )
{
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
SDL_Surface *cWndReg::Init( cP6z80 *cpu )
{
	// ֥ȤؤΥݥ󥿤¸
	lpcZ80 = cpu;
	
	return cZCons::Create( REGWINW, REGWINH, "REGISTER" );
}


////////////////////////////////////////////////////////////////
// ɥ
////////////////////////////////////////////////////////////////
void cWndReg::Update( void )
{
	const char flags[9] = "SZ.H.PNC";
	char fbuf[9];
	Register reg;
	char DisCode[128];
	int i,j;
	
	// 쥸ͼ
	lpcZ80->GetRegister( &reg );
	
	// ե饰ξּ
	for( j=0,i=reg.AF.B.l; j<8; j++,i<<=1 ) fbuf[j] = i&0x80 ? flags[j] : '.';
	fbuf[8]='\0';
	
	// 1饤ե֥
	lpcZ80->Disasm( DisCode, reg.PC.W );
	
	cZCons::Locate( 0, 0 ); cZCons::Print( "AF :%04X  BC :%04X  DE :%04X  HL :%04X", reg.AF.W, reg.BC.W, reg.DE.W, reg.HL.W );
	cZCons::Locate( 0, 1 ); cZCons::Print( "AF':%04X  BC':%04X  DE':%04X  HL':%04X", reg.AF1.W, reg.BC1.W, reg.DE1.W, reg.HL1.W );
	cZCons::Locate( 0, 2 ); cZCons::Print( "IX :%04X  IY :%04X  PC :%04X  SP :%04X", reg.IX.W, reg.IY.W, reg.PC.W, reg.SP.W );
	cZCons::Locate( 0, 3 ); cZCons::Print( "FLAG:[%s] I:%02X IFF:%d IM:%1d HALT:%1d",  fbuf, reg.I, reg.IFF, reg.IM, reg.Halt );
	cZCons::Locate( 0, 4 ); cZCons::Print( "--------------------------------------" );
	cZCons::Locate( 0, 5 ); cZCons::Print( " %-36s", DisCode );
}


//------------------------------------------------------
//  ˥ɥ饹
//------------------------------------------------------

////////////////////////////////////////////////////////////////
// ̿μȽơ֥
////////////////////////////////////////////////////////////////
enum MonitorJob	// 
{
	MONITOR_NONE = 0,
	
	MONITOR_HELP,
	
	MONITOR_GO,
	MONITOR_TRACE,
	MONITOR_STEP,
	MONITOR_STEPALL,
	MONITOR_BREAK,
	
	MONITOR_READ,
	MONITOR_WRITE,
	MONITOR_FILL,
	MONITOR_MOVE,
	MONITOR_SEARCH,
	MONITOR_OUT,
	MONITOR_LOADMEM,
	MONITOR_SAVEMEM,
	
	MONITOR_RESET,
	MONITOR_REG,
	MONITOR_DISASM,
	
	EndofMONITOR
};

struct{
	int Step;
	char *cmd;
	char *HelpMes;
}MonitorCmd[]=
	{
	{ MONITOR_HELP,		"help",		"إפɽ" },
	{ MONITOR_HELP,		"?",		"    " },
	{ MONITOR_GO,		"go",		"¹" },
	{ MONITOR_GO,		"g",		"    " },
	{ MONITOR_TRACE,	"trace",	"ȥ졼¹" },
	{ MONITOR_TRACE,	"t",		"    " },
	{ MONITOR_STEP,		"step",		"ƥå׼¹" },
	{ MONITOR_STEP,		"s",		"    " },
	{ MONITOR_STEPALL,	"S",		"    " },
	{ MONITOR_BREAK,	"break",	"֥졼ݥ" },
	{ MONITOR_BREAK,	"b",		"    " },
	{ MONITOR_READ,		"read",		"ɹ" },
	{ MONITOR_WRITE,	"write",	"˽" },
	{ MONITOR_FILL,		"fill",		"" },
	{ MONITOR_MOVE,		"move",		"ư" },
	{ MONITOR_SEARCH,	"search",	"򸡺" },
	{ MONITOR_OUT,		"out",		"ݡȽ" },
	{ MONITOR_LOADMEM,	"loadmem",	"ե뤫ɹ" },
	{ MONITOR_SAVEMEM,	"savemem",	"꤫ե˽" },
	{ MONITOR_RESET,	"reset",	"PC6001Vꥻå" },
	{ MONITOR_REG,		"reg",		"CPU쥸򻲾/" },
	{ MONITOR_DISASM,	"disasm",	"ե֥" },

};


////////////////////////////////////////////////////////////////
// μȽơ֥
////////////////////////////////////////////////////////////////
enum ArgvType{
	ARGV_END	= 0x00000,
	ARGV_STR	= 0x00001,	// strings
	ARGV_PORT	= 0x00002,	// 00xff
	ARGV_ADDR	= 0x00004,	// 00xffff
	ARGV_NUM	= 0x00008,	// 00x7fffffff
	ARGV_INT	= 0x00010,	// -0x7fffffff0x7fffffff
	ARGV_SIZE	= 0x00080,	// #1#0x7fffffff
	ARGV_REG	= 0x00400,	// RegisterName
	ARGV_BREAK	= 0x00800,	// BreakAction
	ARGV_STEP	= 0x04000,	// StepCommand
	
	EndofArgvType
};


enum ArgvName{
	// <reg>
	ARG_AF,		ARG_BC,		ARG_DE,		ARG_HL,
	ARG_IX,		ARG_IY,		ARG_SP,		ARG_PC,
	ARG_AF1,	ARG_BC1,	ARG_DE1,	ARG_HL1,
	ARG_I,		ARG_R,
	ARG_IFF,	ARG_IM,		ARG_HALT,
	
	// <action>
	//ARG_PC,
	ARG_READ,	ARG_WRITE,	ARG_IN,
	ARG_OUT,	ARG_CLEAR,
	
	// step <cmd>
	//ARG_ALL
	ARG_CALL,	ARG_JP,		ARG_REP,
	
	// reg all
	ARG_ALL,
	
	EndofArgName
};


struct{
	char *StrL;
	char *StrU;
	int Type;
	int Val;
}MonitorArgv[]=
{
	// <reg>
	{ "af",		"AF",		ARGV_REG,	ARG_AF,		},
	{ "bc",		"BC",		ARGV_REG,	ARG_BC,		},
	{ "de",		"DE",		ARGV_REG,	ARG_DE,		},
	{ "hl",		"HL",		ARGV_REG,	ARG_HL,		},
	{ "ix",		"IX",		ARGV_REG,	ARG_IX,		},
	{ "iy",		"IY",		ARGV_REG,	ARG_IY,		},
	{ "sp",		"SP",		ARGV_REG,	ARG_SP,		},
	{ "pc",		"PC",		ARGV_REG,	ARG_PC,		},
	{ "af'",	"AF'",		ARGV_REG,	ARG_AF1,	},
	{ "bc'",	"BC'",		ARGV_REG,	ARG_BC1,	},
	{ "de'",	"DE'",		ARGV_REG,	ARG_DE1,	},
	{ "hl'",	"HL'",		ARGV_REG,	ARG_HL1,	},
	{ "i",		"I",		ARGV_REG,	ARG_I,		},
	{ "r",		"R",		ARGV_REG,	ARG_R,		},
	{ "iff",	"IFF",		ARGV_REG,	ARG_IFF,	},
	{ "im",		"IM",		ARGV_REG,	ARG_IM,		},
	{ "halt",	"HALT",		ARGV_REG,	ARG_HALT,	},
	
	//<action>
	{ "pc",		"PC",		ARGV_BREAK,	ARG_PC,		},
	{ "read",	"READ",		ARGV_BREAK,	ARG_READ,	},
	{ "write",	"WRITE",	ARGV_BREAK,	ARG_WRITE,	},
	{ "in",		"IN",		ARGV_BREAK,	ARG_IN,		},
	{ "out",	"OUT",		ARGV_BREAK,	ARG_OUT,	},
	{ "clear",	"CLEAR",	ARGV_BREAK,	ARG_CLEAR,	},
	
	// step
	{ "call",	"CALL",		ARGV_STEP,	ARG_CALL,	},
	{ "jp",		"JP",		ARGV_STEP,	ARG_JP,		},
	{ "rep",	"REP",		ARGV_STEP,	ARG_REP,	},
	{ "all",	"ALL",		ARGV_STEP,	ARG_ALL,	},
};


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cWndMon::cWndMon( void )
{
	ZeroMemory( KeyBuf, sizeof(KeyBuf) );
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cWndMon::~cWndMon( void )
{
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
SDL_Surface *cWndMon::Init( cP6z80 *cpu, cP6memory *mem )
{
	// ֥ȤؤΥݥ󥿤¸
	lpcZ80 = cpu;
	lpcP6memory = mem;
	
	SDL_Surface *surf = cZCons::Create( MONWINW, MONWINH, "MONITOR" );
	if( surf ){
		// ǽåɽ
		cZCons::Printf( "************************************\n" );
		cZCons::Printf( "* PC6001V  - monitor mode -        *\n" );
		cZCons::Printf( "*  Enter help or ? : Display help  *\n" );
		cZCons::Printf( "************************************\n\n" );
		cZCons::Printf( PROMPT );
	}
	
	return surf;
}


////////////////////////////////////////////////////////////////
// ɥ
////////////////////////////////////////////////////////////////
void cWndMon::Update( void )
{
}


////////////////////////////////////////////////////////////////
// Ͻ
////////////////////////////////////////////////////////////////
void cWndMon::KeyIn( SDL_Event *event )
{
	if( event->type == SDL_KEYDOWN ){
		int KeyCode = event->key.keysym.sym;	// SDL Υ
		
		// ڻܸ֡쥭ܡб(ATߴ)
		switch( event->key.keysym.scancode ){	// ϡɥͭΥ󥳡
		case 0x2b:	// _  SDLK_UNDERSCORE;
			event->key.keysym.unicode = event->key.keysym.mod & KMOD_SHIFT ? '_' : '\\';
			break;
		case 0x90:	// ^  SDLK_CARET;
			event->key.keysym.unicode = event->key.keysym.mod & KMOD_SHIFT ? '~' : '^';
			break;
		case 0x91:	// @  SDLK_AT;
			event->key.keysym.unicode = event->key.keysym.mod & KMOD_SHIFT ? '`' : '@';
			break;
		case 0x92:	// :  SDLK_COLON;
			event->key.keysym.unicode = event->key.keysym.mod & KMOD_SHIFT ? '*' : ':';
			break;
		case 0x1a:	// [  SDLK_LEFTBRACKET;
			event->key.keysym.unicode = event->key.keysym.mod & KMOD_SHIFT ? '{' : '[';
			break;
		case 0x1b:	// ]  SDLK_RIGHTBRACKET;
			event->key.keysym.unicode = event->key.keysym.mod & KMOD_SHIFT ? '}' : ']';
			break;
		}
		
		switch( KeyCode ){	// 
		case SDLK_F6:		// ǥХå⡼ѹ
			SENDEVENT( SDL_DEBUGMODE )
			break;
			
		case SDLK_RETURN:		// Enter
		case SDLK_KP_ENTER:		// Enter(ƥ󥭡)
			cZCons::Printf( "\n" );
			// ǰϽ
			Exec( GetArg() );
			
			*KeyBuf = '\0';	// Хåեꥢ
			cZCons::Printf( PROMPT );
			break;
			
		case SDLK_BACKSPACE:	// BackSpace
			if( strlen(KeyBuf) > 0 ){
				cZCons::LocateR( -1, 0 );
				cZCons::PutCharH( ' ' );
				cZCons::LocateR( -1, 0 );
				KeyBuf[strlen(KeyBuf)-1] = (Uint8)'\0';
			}
			break;
			
		default:
			// ͭʸɤĥХåեդƤʤ
			if( ( event->key.keysym.unicode > 0x1f ) && ( event->key.keysym.unicode < 0x80 ) ){
				if( strlen(KeyBuf) < (MAX_CHRS-1) ){
					char *p = &KeyBuf[strlen(KeyBuf)];
					*p++ = (Uint8)event->key.keysym.unicode;
					*p   = (Uint8)'\0';
					cZCons::PutCharH( event->key.keysym.unicode );
				}
			}
		}
	}
	
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
int cWndMon::GetArg( void )
{
	char *p = KeyBuf;
	
	ArgvCounter = 1;	// Shift()ѥ󥿽
	Argc = 0;			// θĿ
	
	// ʬ
	while( (*p!='\0') && (Argc<=MAX_ARGS) ){
		if( *p==' ' )
			p++;
		else{
			Argv[Argc++] = p;
			while( (*p!='\0') && (*p!=' ') )
				p++;
			if( *p==' ' ) *p++ = '\0';
		}
	}
	
	int JobNo;
	if( !Argc )	// ?
		JobNo = MONITOR_NONE;
	else{		// ͭ̿?
		int i;
		for( i=0; i < COUNTOF(MonitorCmd); i++ )
				if( !strcmp( Argv[0], MonitorCmd[i].cmd ) ) break;
		
		if( i == COUNTOF( MonitorCmd ) ){	// ̵̿ξ
			cZCons::SetColor( FC_RED );
			cZCons::Printf( "̵ʥޥɤǤ : %s\n", Argv[0] );
			cZCons::SetColor( FC_WHITE );
			JobNo = MONITOR_NONE;
		}else{								//  ? ξ
			if( Argc==2 && !strcmp( Argv[1], "?" ) ){
				Help( MonitorCmd[i].Step );
				JobNo = MONITOR_NONE;
			}else{							// ̾̿ξ
				JobNo = MonitorCmd[i].Step;
				Shift();
			}
		}
	}
	
	return JobNo;
}


////////////////////////////////////////////////////////////////
// 󥷥ե
////////////////////////////////////////////////////////////////
void cWndMon::Shift( void )
{
	int i;
	BOOL size = FALSE;
	char *p, *chk;
	
	// ʾ̵
	if( ArgvCounter > MAX_ARGS || ArgvCounter >= Argc )
		argv.Type = ARGV_END;
	// ޤΤǲ
	else{
		p = Argv[ ArgvCounter ];
		if( *p == '#' ){ size = TRUE; p++; }
		
		argv.Type = 0;
		argv.Val  = strtol( p, &chk, 0 );
		argv.Str  = Argv[ ArgvCounter ];
		
		// ͤξ
		if( p!=chk && *chk=='\0' ){
			if( size ){		// #ǻϤޤ
				if( argv.Val <= 0 ) argv.Type = ARGV_STR;
				else                argv.Type = ARGV_SIZE;
			}else{			// ǻϤޤ
				argv.Type |= ARGV_INT;
				if( argv.Val >= 0 )      argv.Type |= ARGV_NUM;
				if( argv.Val <= 0xff )   argv.Type |= ARGV_PORT;
				if( argv.Val <= 0xffff ) argv.Type |= ARGV_ADDR;
			}
		// ʸξ
		}else{
			if( size ){		// #ǻϤޤ
				argv.Type = ARGV_STR;
			}else{			// ǻϤޤ
				for( i=0; i<COUNTOF( MonitorArgv ); i++ ){
					if( !strcmp( p, MonitorArgv[i].StrL ) || !strcmp( p, MonitorArgv[i].StrU ) ){
						argv.Type |= MonitorArgv[i].Type;
						argv.Val   = MonitorArgv[i].Val;
					}
				}
				if( !argv.Type ) argv.Type = ARGV_STR;
			}
		}
		ArgvCounter++;
	}
}


////////////////////////////////////////////////////////////////
// 顼å
////////////////////////////////////////////////////////////////
#define ErrorMes()												\
	do{															\
		cZCons::SetColor( FC_RED );							\
		cZCons::Printf( "̵Ǥ (arg %d)\n", ArgvCounter );	\
		cZCons::SetColor( FC_WHITE );							\
		return;													\
	}while(0)


////////////////////////////////////////////////////////////////
// ޥɼ¹
////////////////////////////////////////////////////////////////
void cWndMon::Exec( int cmd )
{
// 줿μå
#define	ArgvIs( x )	(argv.Type & (x))

	switch( cmd ){
	case MONITOR_HELP:
	//--------------------------------------------------------------
	// help [<cmd>]
	//	إפɽ
	//--------------------------------------------------------------
	{
		int i;
		char *cmd = NULL;
		
		if( argv.Type ){				// [cmd]
			cmd = argv.Str;
			Shift();
		}
		if( argv.Type ) ErrorMes();		// ;פʰХ顼
		
		if( !cmd ){	// ʤإɽ
			cZCons::Printf( "help\n" );
			for( i=0; i < COUNTOF(MonitorCmd); i++ )
				cZCons::Printf( "  %-7s %s\n", MonitorCmd[i].cmd, MonitorCmd[i].HelpMes );
			cZCons::Printf( "     : \"help <ޥ̾>\" Ϥ ˾ܺ٤ʥإפɽޤ\n" );
		}else{		// ΥޥɤΥإɽ
			for( i=0; i < COUNTOF(MonitorCmd); i++ )
				if( !strcmp( cmd, MonitorCmd[i].cmd ) ) break;
			if( i==COUNTOF(MonitorCmd) ) ErrorMes();
			Help( MonitorCmd[i].Step );
		}
		
		break;
	}
	case MONITOR_GO:
	//--------------------------------------------------------------
	//  go
	//	 ¹
	//--------------------------------------------------------------
	{
		if( argv.Type ) ErrorMes();
		
		SENDEVENT( SDL_DEBUGMODE )
		
		break;
	}
	
	case MONITOR_TRACE:
	//--------------------------------------------------------------
	//  trace <step>
	//  trace #<step>
	//  ꤷƥåʬѤޤǼ¹
	//--------------------------------------------------------------
	{
		int step = 1;
		
		if( argv.Type ){
			if     ( ArgvIs( ARGV_SIZE ) ) step = argv.Val;	// [<step>]
			else if( ArgvIs( ARGV_NUM )  ) step = argv.Val;	// [#<step>]
			else                            ErrorMes();
			Shift();
		}
		
		if( argv.Type ) ErrorMes();
		
		
		while( step-- ) lpcZ80->Exec();
		
//		if( CheckBreakPointPC() ) set_emumode( TRACE_BP );
//		else                      set_emumode( M_TRACE );
		
		break;
	}
	
	case MONITOR_STEP:
	//--------------------------------------------------------------
	//  step
	//  step [call] [jp] [rep] [all]
	//  1ƥå,¹
	//  CALL,DJNZ,LDIR etc Υåפ
	//--------------------------------------------------------------
	{
		BOOL call = FALSE, jp = FALSE, rep = FALSE;
		BOOL flag = FALSE;
		BYTE code;
		WORD addr;
		char DisCode[128];
		Register reg;
		
		while( argv.Type ){
			if( ArgvIs( ARGV_STEP ) ){
				if( argv.Val == ARG_CALL )	call = TRUE;
				if( argv.Val == ARG_JP )	jp   = TRUE;
				if( argv.Val == ARG_REP )	rep  = TRUE;
				if( argv.Val == ARG_ALL )	call = jp = rep = TRUE;
				Shift();
			}else
				ErrorMes();
		}
		
		if( argv.Type ) ErrorMes();
		
		lpcZ80->GetRegister( &reg );
		
		addr = reg.PC.W;
		code = lpcP6memory->Read( addr );
		
		if( call ){
			if( code		== 0xcd ||	// CALL nn    = 11001101B
			  ( code&0xc7 ) == 0xc4 ){	// CALL cc,nn = 11ccc100B
				addr += 3;
				flag = TRUE;
			}
		}
		
		if( jp ){
			if( code == 0x10 ){			// DJNZ e     = 00010000B
				addr += 2;
				flag = TRUE;
			}
		}
		
	    if( rep ){
			if( code == 0xed ){			// LDIR/LDDR/CPIR/CPDR etc
				code = lpcP6memory->Read( addr+1 );
				if( (code&0xf4) == 0xb0 ){
					addr += 2;
					flag = TRUE;
				}
			}
		}
		
		lpcZ80->Disasm( DisCode, addr );
		cZCons::Printf( "%s\n", DisCode );
		
		lpcZ80->Exec();
		
//		if( flag ){
//			BP[BP_NUM_FOR_SYSTEM].Type = BP_PC;
//			BP[BP_NUM_FOR_SYSTEM].Addr   = addr;
//			set_emumode( STEP_BP );
//		}else{
//			BP[BP_NUM_FOR_SYSTEM].Type = BP_NONE;
//			set_emumode( STEP );
//		}
		
		
		break;
	}	
	case MONITOR_STEPALL:
	//--------------------------------------------------------------
	//  S
	//  step all Ʊ
	//--------------------------------------------------------------
	{
		BOOL flag = FALSE;
		BYTE code;
		WORD addr;
		char DisCode[128];
		Register reg;
		
		if( argv.Type ) ErrorMes();
		
		lpcZ80->GetRegister( &reg );
		
		addr = reg.PC.W;
		code = lpcP6memory->Read( addr );
		
		if( code		== 0xcd ||	// CALL nn    = 11001101B
		  ( code&0xc7 ) == 0xc4 ){	// CALL cc,nn = 11ccc100B
			addr += 3;
			flag = TRUE;
		}
		
		if( code == 0x10 ){			// DJNZ e     = 00010000B
			addr += 2;
			flag = TRUE;
		}
		
		if( code == 0xed ){			// LDIR/LDDR/CPIR/CPDR etc
			code = lpcP6memory->Read( addr+1 );
			if( (code&0xf4) == 0xb0 ){
				addr += 2;
				flag = TRUE;
			}
		}
		
		lpcZ80->Disasm( DisCode, addr );
		cZCons::Printf( "%s\n", DisCode );
		
		lpcZ80->Exec();
		
//		if( flag ){
//			BP[BP_NUM_FOR_SYSTEM].Type = BP_PC;
//			BP[BP_NUM_FOR_SYSTEM].Addr   = addr;
//			set_emumode( STEP_BP );
//		}else{
//			BP[BP_NUM_FOR_SYSTEM].Type = BP_NONE;
//			set_emumode( STEP );
//		}
		
		break;
	}	
	case MONITOR_BREAK:
	//--------------------------------------------------------------
	//  break [PC|READ|WRITE|IN|OUT] <addr|port> [#<No>]
	//  break CLEAR [#<No>]
	//  break
	//  ֥졼ݥȤ꡿ɽ
	//--------------------------------------------------------------
	{
		BOOL show = FALSE;
		int action = ARG_PC;
		WORD addr = 0;
		int number = 0;
		
		if( argv.Type ){
			// <action>
			if( ArgvIs( ARGV_BREAK ) ){
				action = argv.Val;
				Shift();
			}
			
			// <addr|port>
			switch( action ){
			case ARG_IN:
			case ARG_OUT:
				if( !ArgvIs( ARGV_PORT ) ) ErrorMes();
				addr = argv.Val;
				Shift();
				break;
			case ARG_PC:
			case ARG_READ:
			case ARG_WRITE:
				if( !ArgvIs( ARGV_ADDR ) ) ErrorMes();
				addr = argv.Val;
				Shift();
				break;
			}
			
			// [#<No>]
			if( argv.Type ){
				if( !ArgvIs( ARGV_SIZE ) ) ErrorMes();
				if( argv.Val < 1 || argv.Val > NR_BP ) ErrorMes();
				number = argv.Val - 1;
				Shift();
			}
		}else{
			show = TRUE;
		}
		
		if( argv.Type ) ErrorMes();
		
		
		if( show ){
			for( int i=0; i<NR_BP; i++ ){
				cZCons::Printf( "    #%02d  ", i+1 );
				addr = BP.GetAddr( i );
				switch( BP.GetType( i ) ){
				case cBreakPoint::BP_NONE:
					cZCons::Printf( "-- ʤ --\n" );
					break;
				case cBreakPoint::BP_PC:
					cZCons::Printf( "PC   reach %04XH\n", addr&0xffff );
					break;
				case cBreakPoint::BP_READ:
					cZCons::Printf( "READ  from %04XH\n", addr&0xffff );
					break;
				case cBreakPoint::BP_WRITE:
					cZCons::Printf( "WRITE   to %04XH\n", addr&0xffff );
					break;
				case cBreakPoint::BP_IN:
					cZCons::Printf( "INPUT from %02XH\n", addr&0xff );
					break;
				case cBreakPoint::BP_OUT:
					cZCons::Printf( "OUTPUT  to %04XH\n", addr&0xff) ;
					break;
				default:
					break;
				}
			}
		}else{
			if( action == ARG_CLEAR ){
				BP.SetType( number, cBreakPoint::BP_NONE );
				cZCons::Printf( "֥졼ݥ #%02d õޤ\n", number+1 );
			}else{
				char *s = NULL;
				
				switch( action ){
				case ARG_PC:
					BP.SetType( number, cBreakPoint::BP_PC );
					s = "PC : %04XH";
					break;
				case ARG_READ:
					BP.SetType( number, cBreakPoint::BP_READ );
					s = "READ : %04XH";
					break;
				case ARG_WRITE:
					BP.SetType( number, cBreakPoint::BP_WRITE );
					s = "WRITE : %04XH";
					break;
				case ARG_IN:
					BP.SetType( number, cBreakPoint::BP_IN );
					s = "IN : %02XH";
					break;
				case ARG_OUT:
					BP.SetType( number, cBreakPoint::BP_OUT );
					s = "OUT : %02XH";
					break;
				}
				BP.SetAddr( number, addr );
				cZCons::Printf( "֥졼ݥ #%02d ꤷޤ[ ",number+1 );
				cZCons::Printf( s, addr );
				cZCons::Printf( " ]\n" );
			}
		}
		break;
	}
	case MONITOR_READ:
	//--------------------------------------------------------------
	//  read <addr>
	//  Υɥ쥹꡼
	//--------------------------------------------------------------
		break;
		
	case MONITOR_WRITE:
	//--------------------------------------------------------------
	//  write <addr> <data>
	//  Υɥ쥹˥饤
	//--------------------------------------------------------------
	{
		if( !argv.Type ) ErrorMes();
		
		// <addr>
		if( !ArgvIs( ARGV_ADDR )) ErrorMes();
		WORD addr = argv.Val;
		Shift();
		
		// <data>
		if( !ArgvIs( ARGV_INT )) ErrorMes();
		BYTE data = argv.Val;
		Shift();
		
		if( argv.Type ) ErrorMes();
		
		lpcP6memory->Write( addr, data );
		
		cZCons::Printf( "WRITE memory [ %04XH ] <- %02X  (= %d | %+d | ", addr, (Uint8)data, (Uint8)data, (Sint8)data );
		int i,j;
		for( i=0, j=0x80; i<8; i++, j>>=1 ) cZCons::Printf( "%d", (data & j) ? 1 : 0 );
		cZCons::Printf( "B )\n");
		
		break;
	}
	
	case MONITOR_FILL:
	//--------------------------------------------------------------
	//  fill <start-addr> <end-addr> <value>
	//  fill <start-addr> #<size> <value>
	//  
	//--------------------------------------------------------------
	{
		int start, size, value;
		
		if( !argv.Type ) ErrorMes();
		
		// <addr>
		if( !ArgvIs( ARGV_ADDR ) ) ErrorMes();
		start = argv.Val;
		Shift();						
		
		// [<addr|#size>]
		if     ( ArgvIs( ARGV_SIZE ) ) size = argv.Val;
		else if( ArgvIs( ARGV_ADDR ) ) size = argv.Val - start +1;
		else                           ErrorMes();
		Shift();
		
		// <data>
		if( !ArgvIs( ARGV_INT )) ErrorMes();
		value = argv.Val;
		Shift();
		
		if( argv.Type ) ErrorMes();
		
		for( int i=0; i<size; i++ ) lpcP6memory->Write( start+i, value );
		
		break;
	}
	
	case MONITOR_MOVE:
	//--------------------------------------------------------------
	//  move <src-addr> <end-addr> <dist-addr>
	//  move <src-addr> #size      <dist-addr>
	//  ž
	//--------------------------------------------------------------
	{
		int start, size, dist;
		
		if( !argv.Type ) ErrorMes();
		
		// <addr>
		if( !ArgvIs( ARGV_ADDR ) ) ErrorMes();
		start = argv.Val;
		Shift();
		
		// [<addr|#size>]
		if     ( ArgvIs( ARGV_SIZE ) ) size = argv.Val;
		else if( ArgvIs( ARGV_ADDR ) ) size = argv.Val - start +1;
		else                           ErrorMes();
		Shift();
		
		// <addr>
		if( !ArgvIs( ARGV_ADDR ) ) ErrorMes();
		dist = argv.Val;
		Shift();
		
		if( argv.Type ) ErrorMes();
		
		// ž-ž褬 Ťʤʤ
		if( start+size <= dist ) for( int i=0; i<size; i++ )    lpcP6memory->Write( dist+i, lpcP6memory->Read( start+i ) );
		// ž-ž褬 Ťʤ
		else                     for( int i=size-1; i>=0; i-- ) lpcP6memory->Write( dist+i, lpcP6memory->Read( start+i ) );
		
		break;
	}
	
	case MONITOR_SEARCH:
	//--------------------------------------------------------------
	//  search [<value> [<start-addr> <end-addr>]]
	//  search [<value> [<start-addr> #<size>]]
	//   (1Х) 򥵡
	//--------------------------------------------------------------
		break;
		
	case MONITOR_OUT:
	//--------------------------------------------------------------
	//  out <port> <data>
	//  ΥݡȤ˽
	//--------------------------------------------------------------
		break;
		
	case MONITOR_LOADMEM:
	//--------------------------------------------------------------
	// loadmem <filename> <start-addr> <end-addr>
	// loadmem <filename> <start-addr> #<size>
	// ե뤫˥
	//--------------------------------------------------------------
		break;
		
	case MONITOR_SAVEMEM:
	//--------------------------------------------------------------
	//  savemem <filename> <start-addr> <end-addr>
	//  savemem <filename> <start-addr> #<size>
	//  ե˥
	//--------------------------------------------------------------
		break;
		
	case MONITOR_RESET:
	//--------------------------------------------------------------
	//  reset
	//	ꥻå
	//--------------------------------------------------------------
		if( argv.Type ) ErrorMes();
		SENDEVENT( SDL_RESET )
		
		break;
		
	case MONITOR_REG:
	//--------------------------------------------------------------
	//  reg <name> <value>
	//  쥸Ƥѹ
	//--------------------------------------------------------------
	{	int re = -1, val=0, i;
		char *str;
		Register reg;
		
		if( argv.Type ){
			if( !ArgvIs( ARGV_REG )) ErrorMes();		// <name>
			re = argv.Val;
			Shift();
			if( !ArgvIs( ARGV_INT )) ErrorMes();		// <value>
			val = argv.Val;
			Shift();
		}
		if( argv.Type ) ErrorMes();
		
		lpcZ80->GetRegister( &reg );
		
		switch( re ){
		case ARG_AF:	reg.AF.W = val;		break;
		case ARG_BC:	reg.BC.W = val;		break;
		case ARG_DE:	reg.DE.W = val;		break;
		case ARG_HL:	reg.HL.W = val;		break;
		case ARG_IX:	reg.IX.W = val;		break;
		case ARG_IY:	reg.IY.W = val;		break;
		case ARG_SP:	reg.SP.W = val;		break;
		case ARG_PC:	reg.PC.W = val;		break;
		case ARG_AF1:	reg.AF1.W = val;	break;
		case ARG_BC1:	reg.BC1.W = val;	break;
		case ARG_DE1:	reg.DE1.W = val;	break;
		case ARG_HL1:	reg.HL1.W = val;	break;
		case ARG_I:		val &= 0xff; reg.I = val;		break;
		case ARG_R:		val &= 0xff; reg.R = val;		break;
		case ARG_IFF:	if(val)   val=1; reg.IFF  = val;	break;
		case ARG_IM:	if(val>3) val=2; reg.IM   = val;	break;
		case ARG_HALT:	if(val)   val=1; reg.Halt = val;	break;
		}
		
		lpcZ80->SetRegister( &reg );
		
		for( i=0; i<COUNTOF( MonitorArgv ); i++ )
			if( re == MonitorArgv[i].Val ) break;
		if( i == COUNTOF( MonitorArgv ) ) str = "";
		else                              str = MonitorArgv[i].StrU;
		cZCons::Printf( "reg %s <- %04X\n", str, val );
		
		break;
	}
		
	case MONITOR_DISASM:
	//--------------------------------------------------------------
	//  disasm [[<start-addr>][#<steps>]]
	//  ե֥
	//--------------------------------------------------------------
	{	static int SaveDisasmAddr = -1;
		int i, pc;
		int addr = SaveDisasmAddr;
		int step = 16;
		char DisCode[128];
		Register reg;
		
		if( argv.Type ){
			if( ArgvIs( ARGV_ADDR )){		// [<addr>]
				addr = argv.Val;
				Shift();
			}
			if( ArgvIs( ARGV_SIZE )){		// [#<step>]
				step = argv.Val;
				Shift();
			}
		}
		if( argv.Type ) ErrorMes();
		
		lpcZ80->GetRegister( &reg );
		if( addr == -1 ) addr = reg.PC.W;	// ADDR ̤
		
		pc = 0;
		for( i=0; i<step; i++ ){
			pc += lpcZ80->Disasm( DisCode, (WORD)(addr+pc) );
			cZCons::Printf( "%s\n", DisCode );
		}
		SaveDisasmAddr = ( addr + pc ) & 0xffff;
		break;
	}
	
	}
}


////////////////////////////////////////////////////////////////
// إɽ
////////////////////////////////////////////////////////////////
void cWndMon::Help( int cmd )
{
	switch( cmd ){
	case MONITOR_HELP:
		cZCons::Printf(
			"  help [<cmd>]\n"
			"    إפɽޤ\n"
			"    <cmd> ... إפɽޥ\n"
			"              [omit]... ޥɤδñʥإפɽޤ\n"
		);
		break;
		
	case MONITOR_GO:
		cZCons::Printf(
			"  go\n"
			"    ץ¹Ԥޤ\n"
		);
		break;
		
	case MONITOR_TRACE:
		cZCons::Printf(
			"  trace [#<steps>|<steps>]\n"
			"    execute program specityes times\n"
			"    [all omit]        ... trace some steps (previous steps)\n"
			"    #<steps>, <steps> ... step counts of trace  ( you can omit '#' )\n"
		);
		break;
		
	case MONITOR_STEP:
		cZCons::Printf(
			"  step [call][jp][rep]\n"
			"    execute program 1 time\n"
			"    [all omit] ... execute 1 step\n"
			"    call       ... not trace CALL instruction\n"
			"    jp         ... not trace DJNZ instruction\n"
			"    rep        ... not trace LD*R/CP*R/IN*R/OT*R instruction\n"
			"    CAUTION)\n"
			"         call/jp/rep are use break-point #10.\n"
		);
		break;
		
	case MONITOR_STEPALL:
		cZCons::Printf(
			"  S\n"
			"    mean 'step all'   (see. step)\n"
		);
		break;
		
	case MONITOR_BREAK:
		cZCons::Printf(
			"  break [<action>] <addr|port> [#<No>]\n"
			"  break CLEAR [#<No>]\n"
			"  break\n"
			"    ֥졼ݥȤꤷޤ\n"
			"    [all omit]  ... ƤΥ֥졼ݥȤɽ\n"
			"    <action>    ... set action of conditon PC|READ|WRITE|IN|OUT or CLEAR\n"
			"                    PC    ... break if PC reach addr\n"
			"                    READ  ... break if data is read\n"
			"                    WRITE ... break if data is written\n"
			"                    IN    ... break if data is input\n"
			"                    OUT   ... break if data is output\n"
			"                    CLEAR ... clear all break point\n"
			"                    [omit]... select PC\n"
			"    <addr|port> ... specify address or port\n"
			"                    if <action> is CLEAR, this argument is invalid\n"
			"    #<No>       ... number of break point. (#1..#10)\n"
			"                    [omit]... select #1\n"
			"                    CAUTION).. #10 is used by system\n"
		);
		break;
		
	case MONITOR_READ:
		cZCons::Printf(
			"  read <addr>\n"
			"    read memory.\n"
			"    <addr> ... specify address\n"
		);
		break;
		
	case MONITOR_WRITE:
		cZCons::Printf(
			"  write <addr> <data>\n"
			"    ˽ߤޤ\n"
			"    <addr> ... ꥢɥ쥹\n"
			"    <data> ... ǡ\n"
		);
		break;
		
	case MONITOR_FILL:
		cZCons::Printf(
			"  fill <start-addr> <end-addr> <value>\n"
			"  fill <start-addr> #<size>    <value>\n"
			"    ͤޤ\n"
			"    <start-addr> ... ϥɥ쥹\n"
			"    <end-addr>   ... λɥ쥹\n"
			"    #<size>      ... \n"
			"    <value>      ... \n"
		);
		break;
		
	case MONITOR_MOVE:
		cZCons::Printf(
			"  move <src-addr> <end-addr> <dist-addr>\n"
			"  move <src-addr> #<size>    <dist-addr>\n"
			"    žޤ\n"
			"    <src-addr>  ... žϥɥ쥹\n"
			"    <end-addr>  ... žλɥ쥹\n"
			"    #<size>     ... ž\n"
			"    <dist-addr> ... ž襢ɥ쥹\n"
		);
		break;
		
	case MONITOR_SEARCH:
		cZCons::Printf(
			"  search [<value> [<start-addr> <end-addr>]]\n"
			"  search [<value> [<start-addr> #<size>]]\n"
			"    search memory. \n"
			"    <value>      ... search value\n"
			"    <start-addr> ... search start address\n"
			"    <end-addr>   ... search end address\n"
			"    #<size>      ... search size\n"
			"    [omit-all]   ... search previous value or strings\n"
		);
		break;
		
	case MONITOR_OUT:
		cZCons::Printf(
			"  out <port> <data>\n"
			"    output I/O port.\n"
			"    <port> ... out port address\n"
			"    <data> ... output data\n"
		);
		break;
		
	case MONITOR_LOADMEM:
		cZCons::Printf(
			"  loadmem <filename> <start-addr> <end-addr>\n"
			"  loadmem <filename> <start-addr> #<size>\n"
			"    load memory from binary file.\n"
			"    <filename>   ... binary filename.\n"
			"    <start-addr> ... load start addr\n"
			"    <end-addr>   ... load end addr\n"
			"    #<size>      ... load size\n"
		);
		break;
		
	case MONITOR_SAVEMEM:
		cZCons::Printf(
			"  savemem <filename> <start-addr> <end-addr>\n"
			"  savemem <filename> <start-addr> #<size>\n"
			"    save memory image to file.\n"
			"    <filename>   ... filename.\n"
			"    <start-addr> ... save start addr\n"
			"    <end-addr>   ... save end addr\n"
			"    #<size>      ... save size\n"
		);
		break;
		
	case MONITOR_RESET:
		cZCons::Printf(
			"  reset\n"
			"    PC6001VꥻåȤɥ쥹 0000H ¹Ԥޤ\n"
		);
		break;
		
	case MONITOR_REG:
		cZCons::Printf(
			"  reg <name> <value>\n"
			"    show & set register.\n"
			"    <name>     ... specity register name.\n"
			"                   AF|BC|DE|HL|AF'|BC'|DE'|HL'|IX|IY|SP|PC|I|R|IFF|IM\n"
			"    <value>    ... set value\n"
		);
		break;
		
	case MONITOR_DISASM:
		cZCons::Printf(
			"  disasm [[<start-addr>][#<steps>]]\n"
			"    ե֥뤷ޤ\n"
			"    [all omit]   ... PC쥸ɥ쥹16ƥåʬե֥뤷ޤ\n"
			"    <start-addr> ... start-addr ե֥뤷ޤ\n"
			"                     [omit]... PC쥸ɥ쥹\n"
			"    #<steps>     ... ե֥뤹륹ƥå׿\n"
			"                     [omit]... 16ƥå\n"
		);
		break;
		
	}
}
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
