#include <stdlib.h>
#include <string.h>
#include <new>

#include "disk.h"
#include "error.h"


////////////////////////////////////////////////////////////////
// ǥ 쥯饹
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cdisk::cdisk( int num )
{
	DrvNum = max( min( num, MAXDRV ) , 0 );
	
	for( int i=0; i<MAXDRV; i++ )
		d88[i] = NULL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cdisk::~cdisk( void )
{
	for( int i=0; i<DrvNum; i++ )
		if( d88[i] ) Unmount( i );
}


////////////////////////////////////////////////////////////////
// DISK ޥ
////////////////////////////////////////////////////////////////
BOOL cdisk::Mount( int drvno, char *filename )
{
	PRINTD1( DISK_LOG, "[DISK][Mount] Drive : %d\n", drvno );
	
	if( drvno >= DrvNum ) return FALSE;
	
	// ⤷ޥȺѤߤǤХޥȤ
	if( d88[drvno] ) Unmount( drvno );
	
	// D88֥Ȥ
	try{
		d88[drvno] = new cD88;
		if( !d88[drvno]->Init( filename ) ) throw Error::DiskMountFailed;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		
		Unmount( drvno );
		return FALSE;
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// DISK ޥ
////////////////////////////////////////////////////////////////
void cdisk::Unmount( int drvno )
{
	PRINTD1( DISK_LOG, "[DISK][Unmount] Drive : %d\n", drvno );
	
	if( drvno >= DrvNum ) return;
	
	if( d88[drvno] ){
		// D88֥Ȥ
		delete d88[drvno];
		d88[drvno] = NULL;
	}
}


////////////////////////////////////////////////////////////////
// ǥäƤ?
////////////////////////////////////////////////////////////////
BOOL cdisk::IsMount( int drvno )
{
	if( drvno < DrvNum ) return d88[drvno] ? TRUE : FALSE;
	else                 return FALSE;
}


////////////////////////////////////////////////////////////////
// ƥǥ?
////////////////////////////////////////////////////////////////
BOOL cdisk::IsSystem( int drvno )
{
	if( drvno < DrvNum ){
		d88[drvno]->Seek88( 0, 1 );
		if( d88[drvno]->Getc88() == 'S' &&
			d88[drvno]->Getc88() == 'Y' &&
			d88[drvno]->Getc88() == 'S' )
				return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ץƥ?
////////////////////////////////////////////////////////////////
BOOL cdisk::IsProtect( int drvno )
{
	if( drvno < DrvNum ) return d88[drvno]->IsProtect();
	else                 return FALSE;
}


////////////////////////////////////////////////////////////////
// DISK̾
////////////////////////////////////////////////////////////////
char *cdisk::GetDiskName( int drvno )
{
	if( drvno < DrvNum ) return d88[drvno]->GetDiskImgName();
	else                 return NULL;
}




////////////////////////////////////////////////////////////////
// ߥ˥եåԡǥ饹
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6disk::cP6disk( const ID& id, int num ) : cdisk(num), Device(id)
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6disk::~cP6disk( void )
{
}


////////////////////////////////////////////////////////////////
// DISK 
////////////////////////////////////////////////////////////////
BOOL cP6disk::Init( void )
{
	PRINTD( DISK_LOG, "[DISK][Init]\n" );
	
	ZeroMemory( &mdisk, sizeof( DISK60 ) );
	
	mdisk.command = WAIT;		// äޥ
	mdisk.retdat  = 0xff;		// port D0H ֤
	
	io_D1H = 0;
	io_D2H = 0xf0 | 0x08 | (mdisk.DAC<<2) | (mdisk.RFD<<1) | mdisk.DAV;
	io_D3H = 0;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// DISK˥åȤΥǡ (port D0H)
////////////////////////////////////////////////////////////////
BYTE cP6disk::FddIn( void )
{
	PRINTD( DISK_LOG, "[DISK][FddIn]  <- " );
	
	if( mdisk.DAV ){		// ǡͭʾ
		if( mdisk.step == 6 ){
		if( d88[mdisk.drv] ) 
			mdisk.retdat = d88[mdisk.drv]->Getc88();
		else
			mdisk.retdat = 0xff;
		if( --mdisk.size == 0 ) mdisk.step = 0;
		}
		
		mdisk.DAC = 1;
		
		PRINTD1( DISK_LOG, "%02X\n", mdisk.retdat );
		
		return mdisk.retdat;
	}
	else{			// ǡ̵ʾ
		
		PRINTD( DISK_LOG, "FF\n" );
		
		return 0xff;
	}
}


////////////////////////////////////////////////////////////////
// DISK˥åȤؤΥޥɡǡ (port D1H)
////////////////////////////////////////////////////////////////
void cP6disk::FddOut( BYTE dat )
{
	PRINTD1( DISK_LOG, "[DISK][FddOut] -> %02X\n", dat );
	
	if( mdisk.command == WAIT ){	// ޥɤξ
		mdisk.command = dat;
		switch( mdisk.command ){
		case INIT:					// 00h ˥饤
			break;
		case WRITE_DATA:			// 01h 饤 ǡ
			mdisk.step = 1;
			break;
		case READ_DATA:				// 02h ꡼ ǡ
			mdisk.step = 1;
			break;
		case SEND_DATA:				// 03h  ǡ
			mdisk.step = 6;
			break;
		case COPY:					// 04h ԡ
		case FORMAT:				// 05h եޥå
			break;
		case SEND_RESULT_STATUS:	// 06h  ꥶ ơ
			mdisk.retdat = 0x40;
			break;
		case SEND_DRIVE_STATUS:		// 07h  ɥ饤 ơ
			mdisk.retdat = 0;
			for( int i=DrvNum; i>0; i-- )
				mdisk.retdat |= 1<<(4+i);
			break;
		case TRANSMIT:				// 11h ȥ󥹥ߥå
		case RECEIVE:				// 12h 쥷
		case LOAD:					// 14h 
		case SAVE:					// 15h 
			break;
		}
	}else{					// ǡξ
		switch( mdisk.command ){
		case WRITE_DATA:			// 01h 饤 ǡ
			switch( mdisk.step ){
			case 1:	// 01h:ž֥å
				mdisk.blk = dat;
				mdisk.size = mdisk.blk*256;
				mdisk.step++;
				break;
			case 2:	// 02h:ɥ饤ֹ-1
				mdisk.drv = dat;
				mdisk.step++;
				break;
			case 3:	// 03h:ȥåֹ
				mdisk.trk = dat;
				mdisk.step++;
				break;
			case 4:	// 04h:ֹ
				mdisk.sct = dat;
				// ȥåNo2(1D->2D)
				if( d88[mdisk.drv] ) d88[mdisk.drv]->Seek88( mdisk.trk*2, mdisk.sct );
				mdisk.step++;
				break;
			case 5:	// 05h:ǡ񤭹
				if( d88[mdisk.drv] ) d88[mdisk.drv]->Putc88( dat );
				if( --mdisk.size == 0 ){
					mdisk.step = 0;
				}
				break;
			}
			break;
		case READ_DATA:				// 02h ꡼ ǡ
			switch( mdisk.step ){
			case 1:	// 01h:ž֥å
				mdisk.blk = dat;
				mdisk.size = mdisk.blk*256;
				mdisk.step++;
				break;
			case 2:	// 02h:ɥ饤ֹ-1
				mdisk.drv = dat;
				mdisk.step++;
				break;
			case 3:	// 03h:ȥåֹ
				mdisk.trk = dat;
				mdisk.step++;
				break;
			case 4:	// 04h:ֹ
				mdisk.sct = dat;
				// ȥåNo2(1D->2D)
				if( d88[mdisk.drv] ) d88[mdisk.drv]->Seek88( mdisk.trk*2, mdisk.sct );
				mdisk.step = 0;
				break;
			}
		}
	}
}


////////////////////////////////////////////////////////////////
// DISK˥åȤ濮 (port D2H)
////////////////////////////////////////////////////////////////
BYTE cP6disk::FddCntIn( void )
{
	PRINTD1( DISK_LOG, "[DISK][FddCntIn]  <- %02X\n", (io_D2H&0xf0) | 0x08 | (mdisk.DAC<<2) | (mdisk.RFD<<1) | mdisk.DAV );
	
	return( (io_D2H&0xf0) | 0x08 | (mdisk.DAC<<2) | (mdisk.RFD<<1) | mdisk.DAV );
}


////////////////////////////////////////////////////////////////
// DISK˥åȤؤ濮 (port D3H)
////////////////////////////////////////////////////////////////
void cP6disk::FddCntOut( BYTE dat )
{
	PRINTD1( DISK_LOG, "[DISK][FddCntOut] -> %02X\n", dat );
	
	if( !(dat&0x80) ){		// Ǿbitå
							// 1ξ8255Υ⡼ʤΤ̵(ɬ⡼0Ȳꤹ)
		switch( (dat>>1)&0x07 ){
		case 7:	// bit7 ATN
			mdisk.ATN = dat&1;
			if( mdisk.ATN ){
				mdisk.RFD = 1;
				mdisk.command = WAIT;
			}
			break;
		case 6:	// bit6 DAC
			mdisk.DAC = dat&1;
			if( mdisk.DAC ) mdisk.DAV = 0;
			break;
		case 5:	// bit5 RFD
			mdisk.RFD = dat&1;
			if( mdisk.RFD ) mdisk.DAV = 1;
			break;
		case 4:	// bit4 DAV
			mdisk.DAV = dat&1;
			mdisk.DAC = mdisk.DAV;
			break;
		}
		io_D2H = (io_D2H&0xf0) | 0x08 | (mdisk.DAC<<2) | (mdisk.RFD<<1) | mdisk.DAV;
	}
}



////////////////////////////////////////////////////////////////
// 66ǥ饹
////////////////////////////////////////////////////////////////

// ǡХåե
////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cFDCbuf::cFDCbuf( void )
{
	for( int i=0; i<4; i++ ) Index[i] = 0;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cFDCbuf::~cFDCbuf( void )
{
}


////////////////////////////////////////////////////////////////
// ǡХåե˥ǡ
////////////////////////////////////////////////////////////////
void cFDCbuf::Push( int part, BYTE data )
{
	if( part > 3 ) return;
	
	if( Index[part] < 256 ) Data[part][Index[part]++] = data;
}

////////////////////////////////////////////////////////////////
// ǡХåեǡФ
////////////////////////////////////////////////////////////////
BYTE cFDCbuf::Pop( int part )
{
	if( part > 3 ) return 0xff;
	
	if( Index[part] > 0 ) return Data[part][--Index[part]];
	else                  return 0xff;
}


//************ FDC Status *******************
#define FDC_BUSY			(0x10)
#define FDC_READY			(0x00)
#define FDC_NON_DMA			(0x20)
#define FDC_FD2PC			(0x40)
#define FDC_PC2FD			(0x00)
#define FDC_DATA_READY		(0x80)

//************* Result Status 0 *************
#define ST0_NOT_READY		(0x08)
#define ST0_EQUIP_CHK		(0x10)
#define ST0_SEEK_END		(0x20)
#define ST0_IC_NT			(0x00)
#define ST0_IC_AT			(0x40)
#define ST0_IC_IC			(0x80)
#define ST0_IC_AI			(0xc0)

//************* Result Status 1 *************
#define ST1_NOT_WRITABLE	(0x02)

//************* Result Status 2 *************

//************* Result Status 3 *************
#define ST3_TRACK0			(0x10)
#define ST3_READY			(0x20)
#define ST3_WRITE_PROTECT	(0x40)
#define ST3_FAULT			(0x80)


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP66disk::cP66disk( const ID& id, int num ) : cdisk(num), Device(id)
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP66disk::~cP66disk( void )
{
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP66disk::Init( void )
{
	ZeroMemory( &CmdIn,  sizeof( CmdBuffer ) );
	ZeroMemory( &CmdOut, sizeof( CmdBuffer ) );
	for( int i=0; i < 4; i++ ){
		SeekST0[i] = 0;
		LastCylinder[i] = 0;
		SeekEnd[i] = FALSE;
	}
	SendSectors  = 0;
	Status = FDC_DATA_READY | FDC_READY | FDC_PC2FD;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ơХåե˥ǡ
////////////////////////////////////////////////////////////////
void cP66disk::PushStatus( int data )
{
	PRINTD2( DISK_LOG, "[cP66disk][PushStatus] Index:%d ->%02X\n", CmdOut.Index, data );
	
	CmdOut.Data[CmdOut.Index++] = data;
}

////////////////////////////////////////////////////////////////
// ơХåեǡФ
////////////////////////////////////////////////////////////////
BYTE cP66disk::PopStatus( void )
{
	PRINTD1( DISK_LOG, "%02X\n", (BYTE)CmdOut.Data[CmdOut.Index-1] );
	
	return CmdOut.Data[--CmdOut.Index];
}


////////////////////////////////////////////////////////////////
// FDC ˽
////////////////////////////////////////////////////////////////
void cP66disk::OutFDC( BYTE data )
{
	PRINTD2( DISK_LOG, "[cP66disk][OutFDC] Index:%d ->%02X\n", CmdIn.Index, data );
	
	const int CmdLength[] = { 0,0,0,3,2,9,9,2,1,0,0,0,0,6,0,3 };
	
	CmdIn.Data[CmdIn.Index++] = data;
	// ޥĹΥޥɤ褿 ޥɼ¹
	if( CmdLength[CmdIn.Data[0]&0xf] == CmdIn.Index ) Exec();
}

////////////////////////////////////////////////////////////////
// FDC ɹ
////////////////////////////////////////////////////////////////
BYTE cP66disk::InFDC( void )
{
	PRINTD1( DISK_LOG, "[cP66disk][InFDC] Index:%d ->", CmdOut.Index-1 );
	
	// PC¦Ƽ顢PC2FD ˤ롣
	if( CmdOut.Index == 1 ) Status = FDC_DATA_READY | FDC_PC2FD;
	return PopStatus();
}

////////////////////////////////////////////////////////////////
// FDC ޥɼ¹
////////////////////////////////////////////////////////////////
void cP66disk::Exec( void )
{
	PRINTD1( DISK_LOG, "[cP66disk][Exec] Command:%02X", CmdIn.Data[0]&0xf );
	
	CmdOut.Index = 0;
	
	switch( CmdIn.Data[0] & 0xf ){
	case 0x03:	// Specify
		PRINTD( DISK_LOG, " Specify\n" );
		break;
		
	case 0x05:	// Write Data
		PRINTD( DISK_LOG, " Write Data\n" );
		Write();
		break;
		
	case 0x06:	// Read Data
		PRINTD( DISK_LOG, " Read Data\n" );
		Read();
		break;
		
	case 0x08:	// Sense Interrupt Status
		PRINTD( DISK_LOG, " Sense Interrupt Status\n" );
		SenseInterruptStatus();
		break;
		
	case 0x0d:	// Write ID
		PRINTD( DISK_LOG, " Write ID\n" );
		// Format is Not Implimented
		break;
		
	case 0x07:	// Recalibrate
		PRINTD( DISK_LOG, " Recalibrate ->" );
		CmdIn.Data[2] = 0;	// Seek to TRACK0
		
	case 0x0f:	// Seek
		PRINTD( DISK_LOG, " Seek\n" );
		Seek();
		break;
		
	default:	// Invalid
		PRINTD( DISK_LOG, " Invalid!!\n" );
	}
	CmdIn.Index = 0;
}


////////////////////////////////////////////////////////////////
// Read
////////////////////////////////////////////////////////////////
void cP66disk::Read( void )
{
	PRINTD5( DISK_LOG, "[cP66disk][Read] Drv:%d C:%d H:%d R:%d N:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2], CmdIn.Data[3], CmdIn.Data[4], CmdIn.Data[5] );
	
	int Drv,C,H,R,N;
	int i,j;
	
	Drv = CmdIn.Data[1]&3;		// ɥ饤No.(0-3) 0-1¤Ƥ?
	C   = CmdIn.Data[2];		// 
//	C   = LastCylinder[Drv];	// 
	H   = CmdIn.Data[3];		// إåɥɥ쥹
	R   = CmdIn.Data[4];		// No.
	N   = CmdIn.Data[5] ? CmdIn.Data[5]*256 : 256;	// 
	
//	C = ( !is1DD() && isSYS() && P6Version==4 ) ? c / 2: c;   // if 1D and sys-disk and PC-6601SR then c= c/2
	
	if( IsMount( Drv ) ){
		// 
		// ȥåNo2(1D->2D)
		d88[Drv]->Seek88( C*2, R );
		for( i=0; i<SendSectors; i++ ){
			cFDCbuf::Clear( i );
			for( j=0; j<N; j++ )
//			for( j=0; j<0x100; j++ )
				cFDCbuf::Push( i, d88[Drv]->Getc88() );
		}
	}
	
	PushStatus( N );	// N
	PushStatus( R );	// R
	PushStatus( H );	// H
	PushStatus( C );	// C
	PushStatus( 0 );	// st2
	PushStatus( 0 );	// st1
	
	PushStatus( IsMount( Drv ) ? 0 : ST0_NOT_READY );	// st0  bit3 : media not ready
	
	Status = FDC_DATA_READY | FDC_FD2PC;
}


////////////////////////////////////////////////////////////////
// Write
////////////////////////////////////////////////////////////////
void cP66disk::Write( void )
{
	PRINTD5( DISK_LOG, "[cP66disk][Write] Drv:%d C:%d H:%d R:%d N:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2], CmdIn.Data[3], CmdIn.Data[4], CmdIn.Data[5] );
	
	int Drv,C,H,R,N;
	int i,j;
	
	Drv = CmdIn.Data[1]&3;		// ɥ饤No.(0-3) 0-1¤Ƥ?
	C   = CmdIn.Data[2];		// 
//	C   = LastCylinder[Drv];	// 
	H   = CmdIn.Data[3];		// إåɥɥ쥹
	R   = CmdIn.Data[4];		// No.
	N   = CmdIn.Data[5] ? CmdIn.Data[5]*256 : 256;	// 
	
	if( IsMount( Drv ) ){
		// 
		// ȥåNo2(1D->2D)
		d88[Drv]->Seek88( C*2, R );
		for( i=0; i<SendSectors; i++ ){
//			for( j=0; j<N; j++ )
			for( j=0; j<0x100; j++ )
				d88[Drv]->Putc88( cFDCbuf::Pop( i ) );	// write data
		}
	}
	
	PushStatus( N );	// N
	PushStatus( R );	// R
	PushStatus( H );	// H
	PushStatus( C );	// C
	PushStatus( 0 );	// st2
	PushStatus( 0 );	// st1
	
	PushStatus( IsMount( Drv ) ? 0 : ST0_NOT_READY );	// st0  bit3 : media not ready
	
	Status = FDC_DATA_READY | FDC_FD2PC;
}


////////////////////////////////////////////////////////////////
// Seek
////////////////////////////////////////////////////////////////
void cP66disk::Seek( void )
{
	PRINTD2( DISK_LOG, "[cP66disk][Seek] Drv:%d C:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2] );
	
	int Drv,C;
	
	Drv = CmdIn.Data[1]&3;		// ɥ饤No.(0-3) 0-1¤Ƥ?
	C   = CmdIn.Data[2];		// 
	
	if( ( Drv > DrvNum ) || !IsMount( Drv ) ){	// ̵ɥ饤 or ǥޥȤƤʤ?
		SeekST0[Drv]      = ST0_IC_AT | ST0_SEEK_END | ST0_NOT_READY | Drv;
		SeekEnd[Drv]      = FALSE;
		LastCylinder[Drv] = 0;
	}else{										// ¹
		// ȥåNo2(1D->2D)
		d88[Drv]->Seek88( C*2, 1 );
		SeekST0[Drv]      = ST0_IC_NT | ST0_SEEK_END | Drv;
		SeekEnd[Drv]      = TRUE;
		LastCylinder[Drv] = C;
	}
}


////////////////////////////////////////////////////////////////
// Sense Interrupt Status
////////////////////////////////////////////////////////////////
void cP66disk::SenseInterruptStatus( void )
{
	PRINTD( DISK_LOG, "[cP66disk][SenseInterruptStatus]" );
	
	int Drv;
	
	// λɥ饤֤õ
	for( Drv=0; Drv<DrvNum; Drv++ )
		if( SeekEnd[Drv] ) break;
	
	if( Drv < DrvNum ){	// λɥ饤֤
		SeekEnd[Drv] = FALSE;
		PushStatus( LastCylinder[Drv] );
		PushStatus( SeekST0[Drv] );
	}else{				// λɥ饤֤ʤ
		PushStatus( 0 );
		PushStatus( ST0_IC_IC );
	}
	
	Status = FDC_DATA_READY | FDC_FD2PC;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6disk::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	// cdisk
	Ini->PutEntry( "P6DISK", NULL, "DrvNum", "%d", DrvNum );
	
	// d88
	for( int i=0; i<DrvNum; i++ ){
		if( d88[i] ){
			char stren[16];
			sprintf( stren, "D88_%d", i );
			Ini->PutEntry( stren, NULL, "FileName", "%s", d88[i]->GetFileName() );
		}
	}
	
	// cP6disk
	Ini->PutEntry( "P6DISK", NULL, "mdisk_ATN",		"%d",		mdisk.ATN );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_DAC",		"%d",		mdisk.DAC );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_RFD",		"%d",		mdisk.RFD );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_DAV",		"%d",		mdisk.DAV );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_command",	"%d",		mdisk.command );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_step",	"%d",		mdisk.step );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_blk",		"%d",		mdisk.blk );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_drv",		"%d",		mdisk.drv );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_trk",		"%d",		mdisk.trk );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_sct",		"%d",		mdisk.sct );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_size",	"%d",		mdisk.size );
	Ini->PutEntry( "P6DISK", NULL, "mdisk_retdat",	"0x%02X",	mdisk.retdat );
	Ini->PutEntry( "P6DISK", NULL, "io_D1H",		"0x%02X",	io_D1H );
	Ini->PutEntry( "P6DISK", NULL, "io_D2H",		"0x%02X",	io_D1H );
	Ini->PutEntry( "P6DISK", NULL, "io_D3H",		"0x%02X",	io_D1H );
	
	return TRUE;
}

BOOL cP66disk::DokoSave( cIni *Ini )
{
	char stren[16],strva[256];
	
	if( !Ini ) return FALSE;
	
	// cdisk
	Ini->PutEntry( "P66DISK", NULL, "DrvNum", "%d", DrvNum );
	
	// d88
	for( int i=0; i<DrvNum; i++ ){
		if( d88[i] ){
			char stren[16];
			sprintf( stren, "D88_%d", i );
			Ini->PutEntry( stren, NULL, "FileName", "%s", d88[i]->GetFileName() );
		}
	}
	
	// cFDCbuf
	for( int i=0; i<4; i++ ){
		// Data
		for( int j=0; j<256; j+=64 ){
			sprintf( stren, "Data_%d_%02X", i, j );
			for( int k=0; k<64; k++ ) sprintf( &strva[k*2], "%02X", Data[i][j+k] );
			Ini->PutEntry( "P66DISK", NULL, stren, "%s", strva );
		}
		// Index
		sprintf( stren, "Index_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "%d", Index[i] );
	}
	
	// cP66disk
	for( int i=0; i<10; i++ ){
		sprintf( stren, "CmdIn_Data_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X", CmdIn.Data[i] );
		sprintf( stren, "CmdOut_Data_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X", CmdOut.Data[i] );
	}
	Ini->PutEntry( "P66DISK", NULL, "CmdIn_Index", "%d", CmdIn.Index );
	Ini->PutEntry( "P66DISK", NULL, "CmdOut_Index", "%d", CmdOut.Index );
	
	for( int i=0; i<DrvNum; i++ ){
		sprintf( stren, "SeekST0_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X",	SeekST0[i] );
		sprintf( stren, "LastCylinder_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X",	LastCylinder[i] );
		sprintf( stren, "SeekEnd_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "%s",		SeekEnd[i] ? "Yes" : "No" );
	}
	
	Ini->PutEntry( "P66DISK", NULL, "SendSectors",	"0x%02X",	SendSectors );
	Ini->PutEntry( "P66DISK", NULL, "DIO",			"%s",		DIO ? "Yes" : "No" );
	Ini->PutEntry( "P66DISK", NULL, "Status",		"0x%02X",	Status );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6disk::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	// Ȥꤢޥ
	for( int i=0; i<DrvNum; i++ ) if( d88[i] ) Unmount( i) ;
	
	// cdisk
	Ini->GetInt( "P6DISK", "DrvNum",	&DrvNum,	DrvNum );
	
	// d88
	for( int i=0; i<DrvNum; i++ ){
		char stren[16], strva[256];
		sprintf( stren, "D88_%d", i );
		if( Ini->GetString( stren, "FileName", strva, "" ) ) Mount( i, strva );
	}
	
	// cP6disk
	Ini->GetInt( "P6DISK", "mdisk_ATN",		&mdisk.ATN,		mdisk.ATN );
	Ini->GetInt( "P6DISK", "mdisk_DAC",		&mdisk.DAC,		mdisk.DAC );
	Ini->GetInt( "P6DISK", "mdisk_RFD",		&mdisk.RFD,		mdisk.RFD );
	Ini->GetInt( "P6DISK", "mdisk_DAV",		&mdisk.DAV,		mdisk.DAV );
	Ini->GetInt( "P6DISK", "mdisk_command",	&mdisk.command,	mdisk.command );
	Ini->GetInt( "P6DISK", "mdisk_step",	&mdisk.step,	mdisk.step );
	Ini->GetInt( "P6DISK", "mdisk_blk",		&mdisk.blk,		mdisk.blk );
	Ini->GetInt( "P6DISK", "mdisk_drv",		&mdisk.drv,		mdisk.drv );
	Ini->GetInt( "P6DISK", "mdisk_trk",		&mdisk.trk,		mdisk.trk );
	Ini->GetInt( "P6DISK", "mdisk_sct",		&mdisk.sct,		mdisk.sct );
	Ini->GetInt( "P6DISK", "mdisk_size",	&mdisk.size,	mdisk.size );
	Ini->GetInt( "P6DISK", "mdisk_retdat",	&st,			mdisk.retdat );	mdisk.retdat = st;
	Ini->GetInt( "P6DISK", "io_D1H",		&st,			io_D1H );		io_D1H = st;
	Ini->GetInt( "P6DISK", "io_D2H",		&st,			io_D2H );		io_D2H = st;
	Ini->GetInt( "P6DISK", "io_D3H",		&st,			io_D3H );		io_D3H = st;
	
	return TRUE;
}

BOOL cP66disk::DokoLoad( cIni *Ini )
{
	int st;
	char stren[16], strva[256];
	
	if( !Ini ) return FALSE;
	
	// Ȥꤢޥ
	for( int i=0; i<DrvNum; i++ ) if( d88[i] ) Unmount( i) ;
	
	// cdisk
	Ini->GetInt( "P66DISK", "DrvNum",	&DrvNum,	DrvNum );
	
	// d88
	for( int i=0; i<DrvNum; i++ ){
		sprintf( stren, "D88_%d", i );
		if( Ini->GetString( stren, "FileName", strva, "" ) ) Mount( i, strva );
	}
	
	// cFDCbuf
	for( int i=0; i<4; i++ ){
		// Data
		for( int j=0; j<256; j+=64 ){
			sprintf( stren, "Data_%d_%02X", i, j );
			memset( strva, '0', 64*2 );
			Ini->GetString( "P66DISK", stren, strva, strva );
			
			for( int k=0; k<64; k++ ){
				char dt[5] = "0x";
				strncpy( dt, &strva[k*2], 2 );
				Data[i][j+k] = strtol( dt, NULL, 16 );
			}
		}
		// Index
		sprintf( stren, "Index_%d", i );
		Ini->GetInt( "P66DISK", stren,	&Index[i],	Index[i] );
	}
	
	// cP66disk
	for( int i=0; i<10; i++ ){
		sprintf( stren, "CmdIn_Data_%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	CmdIn.Data[i] );	CmdIn.Data[i] = st;
		sprintf( stren, "CmdOut_Data_%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	CmdOut.Data[i] );	CmdOut.Data[i] = st;
	}
	Ini->GetInt( "P66DISK", "CmdIn_Index",	&CmdIn.Index,	CmdIn.Index );
	Ini->GetInt( "P66DISK", "CmdOut_Index",	&CmdOut.Index,	CmdOut.Index );
	
	for( int i=0; i<DrvNum; i++ ){
		sprintf( stren, "SeekST0_%d", i );
		Ini->GetInt(   "P66DISK", stren,	&st,			SeekST0[i] ); 		SeekST0[i] = st;
		sprintf( stren, "LastCylinder_%d", i );
		Ini->GetInt(   "P66DISK", stren,	&st,			LastCylinder[i] );	LastCylinder[i] = st;
		sprintf( stren, "SeekEnd_%d", i );
		Ini->GetTruth( "P66DISK", stren,	&SeekEnd[i],	SeekEnd[i] );
	}
	Ini->GetInt(   "P66DISK", "SendSectors",	&st,	SendSectors );	SendSectors = st;
	Ini->GetTruth( "P66DISK", "DIO",			&DIO,	DIO );
	Ini->GetInt(   "P66DISK", "Status",			&st,	Status );		Status = st;
	
	return TRUE;
}





////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor cP6disk::descriptor = {
	cP6disk::indef, cP6disk::outdef
};

const Device::OutFuncPtr cP6disk::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP6disk::OutD1H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6disk::OutD2H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6disk::OutD3H )
};

const Device::InFuncPtr cP6disk::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &cP6disk::InD0H ),
	STATIC_CAST( Device::InFuncPtr, &cP6disk::InD1H ),
	STATIC_CAST( Device::InFuncPtr, &cP6disk::InD2H ),
	STATIC_CAST( Device::InFuncPtr, &cP6disk::InD3H )
};


const Device::Descriptor cP66disk::descriptor = {
	cP66disk::indef, cP66disk::outdef
};

const Device::OutFuncPtr cP66disk::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutB1H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutB2H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutB3H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutD0H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutD1H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutD2H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutD3H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutD6H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutD8H ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutDAH ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutDDH ),
	STATIC_CAST( Device::OutFuncPtr, &cP66disk::OutDEH )
};

const Device::InFuncPtr cP66disk::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InB2H ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InD0H ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InD1H ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InD2H ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InD3H ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InD4H ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InDCH ),
	STATIC_CAST( Device::InFuncPtr, &cP66disk::InDDH )
};
