#ifndef INI_H_INCLUDED
#define INI_H_INCLUDED

#include "pc6001v.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cNode {
public:
	enum NodeType{ NODE_NONE, NODE_COMMENT, NODE_SECTION, NODE_ENTRY };
	
private:
	cNode *PrevNode, *NextNode;
	
public:
	cNode( cNode * );			// 󥹥ȥ饯
	~cNode();					// ǥȥ饯
	
	cNode *AddNode();			// Ρɤɲ
	
	void SetMember( NodeType, char * );
	
	NodeType NodeID;	// Node ID
	char *Comment;		// Comments
	char *Section;		// Sections
	char *Entry;		// Entries
	char *Value;
	
	cNode *GetPrevNode(){ return PrevNode; }
	cNode *GetNextNode(){ return NextNode; }
	void SetPrevNode( cNode *node ){ PrevNode = node; }
	void SetNextNode( cNode *node ){ NextNode = node; }
	
};

class cIni {
protected:
	cNode *IniNode;				// ƬΡɤؤΥݥ
	char FileName[PATH_MAX];	// ե̾
	
	BOOL Ready;
	
public:
	cIni();						// 󥹥ȥ饯
	virtual ~cIni();			// ǥȥ饯
	
	BOOL Init( char * );		// 
	
	BOOL IsReady(){ return Ready; }
	
	BOOL Write();											// 
	BOOL GetString( char *, char *, char *, char * );		// ʸɹ
	BOOL GetInt( char *, char *, int *, int );				// ɹ
	BOOL GetTruth( char *, char *, BOOL *, BOOL );			// YesNoɹ
	BOOL PutEntry( char *, char *, char *, char *, ... );	// ȥɲ
	
};



// ɤǤSAVEѥ󥿡ե
struct IDoko
{
	virtual BOOL DokoLoad( cIni * ) = 0;
	virtual BOOL DokoSave( cIni * ) = 0;
};

#endif	// INI_H_INCLUDED
