#ifndef INTR_H_INCLUDED
#define INTR_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cP6intr : public IDoko {
protected:
	BOOL TimerIntrEnable;	// ޳ߵĥե饰
	
	// Ƽȯե饰
	BOOL IntrKEY1;
	BOOL IntrKEY2;
	BOOL IntrKEY3;
	BOOL IntrTIMER;
	BOOL IntrCMT_R;
	BOOL IntrCMT_E;
	BOOL IntrJOY;
	
	BYTE TimerAddr;			// ޳ߥɥ쥹
	BOOL IntrReserved;		// ͽե饰
	BYTE IntrPortA;			// PortA˽
	
	// PortA ͽ
//	BYTE ResKey;
//	BYTE ResJoy;
	BYTE ResCmt;
	
	BOOL SetIntrReserved( BYTE );			// ͽ
	virtual BOOL IsTimerIntrEnable() = 0;	// ޳ߵĥå
	
public:
	cP6intr();								// 󥹥ȥ饯
	virtual ~cP6intr();						// ǥȥ饯
	
	BOOL Init();							// 
	
	virtual void Reset() = 0;				// ꥻå
	
	int	IntrCheck();						// ߥå
	
	void SetTimerIntr( BOOL );				// ޳ȯ
	void SetCmtIntr( BYTE );				// CMTȯ
	void SetKeyIntr( int, BYTE );			// ȯ
	void SetJoyIntr( BYTE );				// ѥȯ
	
	BYTE GetIntrReserved( BYTE );			// ͽPortAåͼ
	
//	BOOL IsCmtIntrReady(){ return !IntrReserved;  }	// CMTȯ?
	BOOL IsCmtIntrReady(){ return !IntrCMT_R;  }	// CMTȯ?
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	Uint32 TimerCount;						// 1ô֤Υ޳߲
	Uint32 CmtCount;						// 1ô֤CMT߲
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class cP6intr60 : public Device, public cP6intr {
private:
	BOOL IsTimerIntrEnable(){ return TimerIntrEnable; }	// ޳ߵĥå
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( DWORD , BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutB0H] %02X\n", data );
										     TimerIntrEnable = (data&1 ? FALSE : TRUE); }
	
public:
	cP6intr60( const ID& id );		// 󥹥ȥ饯
	~cP6intr60();					// ǥȥ饯
	
	void Reset();					// ꥻå
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ outB0H=0 };
	// INǥХID
	enum IDIn{};
};


class cP6intr62 : public Device, public cP6intr {
private:
	BOOL TimerIntrEnable2;	// ޳ߵĥե饰(mk2ʹ)
	BYTE Int1Addr;			// INT1ߥɥ쥹
	BYTE Int2Addr;			// INT2ߥɥ쥹
	
	BOOL IsTimerIntrEnable(){ return TimerIntrEnable && TimerIntrEnable2; }	// ޳ߵĥå
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( DWORD, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutB0H] %02X\n", data );
										    TimerIntrEnable = (data&1 ? FALSE : TRUE); }
	inline void OutF3H( DWORD, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF3H] %02X\n", data );
										    TimerIntrEnable2 = (data&4 ? FALSE : TRUE); }
	inline void OutF4H( DWORD, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF4H] %02X\n", data>>1 );
										    Int1Addr = data>>1; }
	inline void OutF5H( DWORD, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF5H] %02X\n", data>>1 );
										    Int2Addr = data>>1; }
	inline void OutF7H( DWORD, BYTE data ){ PRINTD1( INTR_LOG, "[INTR][OutF7H] %02X\n", data>>1 );
										    TimerAddr = data>>1; }
	inline BYTE InF7H( DWORD ){ PRINTD1( INTR_LOG, "[INTR][InF7H] %02X\n", TimerAddr );
							    return TimerAddr; }
	
public:
	cP6intr62( const ID& id );		// 󥹥ȥ饯
	~cP6intr62();					// ǥȥ饯
	
	void Reset();					// ꥻå
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ outB0H=0, outF3H, outF4H, outF5H, outF7H };
	// INǥХID
	enum IDIn{ inF7H=0 };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// INTR_H_INCLUDED
