#include <new>

#include "io.h"
#include "error.h"

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6io::cP6io()
{
	PRINTD( CONST_LOG, "cP6io\n" );
	
	io = NULL;
	dl = NULL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6io::~cP6io()
{
	PRINTD( CONST_LOG, "~cP6io\n" );
	
	if( dl ) delete dl;
	if( io ) delete io;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6io::Init( void )
{
	// ֥ȳ
	try{
		dl = new DeviceList;	// ǥХꥹ
		io = new IOBus;			// I/O
		
		if( !io->Init( dl ) ) throw Error::InitFailed;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		if( dl ){ delete dl; dl = NULL; }
		return FALSE;
	}
	// 㳰ȯ
	catch( Error::Errno i ){
		Error::SetError( i );
		return FALSE;
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǥХ³
////////////////////////////////////////////////////////////////
BOOL cP6io::Connect( IDevice* device, const IOBus::Connector* connector )
{
	return io->Connect( device, connector );
}


////////////////////////////////////////////////////////////////
// ǥХ
////////////////////////////////////////////////////////////////
BOOL cP6io::Disconnect( IDevice* device )
{
	return io->Disconnect( device );
}


////////////////////////////////////////////////////////////////
// INؿ
////////////////////////////////////////////////////////////////
BYTE cP6io::In( BYTE port )
{
	PRINTD1( IO_LOG, "[IO][In] port : %02X", port );
	
	BYTE data = io->In( port );
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( BP.CheckBreakPoint( cBreakPoint::BP_IN, port, data, NULL ) ){
		PRINTD( IO_LOG, " -> Break!" );
		BP.SetBreak();
	}
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	return data;
}


////////////////////////////////////////////////////////////////
// OUTؿ
////////////////////////////////////////////////////////////////
void cP6io::Out( BYTE port, BYTE data )
{
	PRINTD2( IO_LOG, "[IO][Out] port : %02X  data : %02X", port, data );
	
	io->Out( port, data );
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ֥졼ݥȥå
	if( BP.CheckBreakPoint( cBreakPoint::BP_OUT, port, data, NULL ) ){
		PRINTD( IO_LOG, " -> Break!" );
		BP.SetBreak();
	}
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	PRINTD( IO_LOG, "\n" );
}
