#include <shlobj.h>

#include "p6t2.h"


// P6TեޥåVer.2
//  Ūˤϡ֥٥᡼+եå+٥᡼(4byte)פȤ¤
//  եåˤDATA֥å󤬴ޤޤ롣
//  DATA֥å̵ڤȤ1ȿ롣
//  BASICʤɡ֥إåܥǡפȤ¤ξ硤DATA֥å2ĤȤʤ뤬
//  IDֹƱˤ뤳ȤǴϢդƴǤ롣
//
// [եå]
//  header (2byte) : "P6"
//  ver    (1byte) : С
//  dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
//  start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
//  basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
//  page   (1byte) : ڡ
//  askey  (2byte) : ȥȥޥʸ
//  ...ޥɤϤθaskeyʬ³
//  exhead (2byte) : ĥ󥵥(64KBޤ)
//  ...ĥ󤬤Ϥθexheadʬ³
//
// [DATA֥å]
//  header (2byte) : "TI"
//  id     (1byte) : IDֹ(DATA֥åϢդ)
//  name  (16byte) : ǡ̾(15ʸ+'00H')
//  baud   (2byte) : ܡ졼(600/1200)
//  stime  (2byte) : ̵λ(ms)
//  ptime  (2byte) : ԡλ(ms)
//  offset (4byte) : ٥᡼ƬΥեå
//  size   (4byte) : ǡ



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6DATA::cP6DATA( void )
{
//printf( "[cP6DATA] %x\n", (int)this );

	// н
	ZeroMemory( &Info, sizeof(P6TBLKINFO) );
	Data = NULL;
	next = before = NULL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6DATA::~cP6DATA( void )
{
//printf( "[~cP6DATA] %x\n", (int)this );

	if( Data ) delete [] Data;
	if( next ) delete next;
	if( before ) before->next = NULL;
}


////////////////////////////////////////////////////////////////
// Ƭ֥åؤΥݥ󥿤֤
////////////////////////////////////////////////////////////////
cP6DATA *cP6DATA::TopBlock( void )
{
	cP6DATA *top = this;
	while( top->before ) top = top->before;
	
	return top;
}


////////////////////////////////////////////////////////////////
// ֥åؤΥݥ󥿤֤
////////////////////////////////////////////////////////////////
cP6DATA *cP6DATA::LastBlock( void )
{
	cP6DATA *last = this;
	while( last->next ) last = last->next;
	
	return last;
}


////////////////////////////////////////////////////////////////
// DATA֥åɲ
////////////////////////////////////////////////////////////////
cP6DATA *cP6DATA::New( void )
{
	LastBlock()->next = new cP6DATA;
	LastBlock()->before = this;
	
	return LastBlock();
}


////////////////////////////////////////////////////////////////
// ԡ
////////////////////////////////////////////////////////////////
cP6DATA *cP6DATA::Clone( void )
{
	cP6DATA *newb = new cP6DATA;
	*newb = *this;
	newb->next = newb->before = NULL;
	
	if( this->Data ){
		newb->Data = new BYTE[Info.DNum];
		memcpy( newb->Data, this->Data, Info.DNum );
	}
	
	return newb;
}


////////////////////////////////////////////////////////////////
// ԡ
////////////////////////////////////////////////////////////////
cP6DATA *cP6DATA::Clones( void )
{
	cP6DATA *oldb = TopBlock();
	cP6DATA *newb = TopBlock()->Clone();
	
	while( oldb->next ){
		oldb = oldb->next;
		newb->next         = oldb->Clone();
		newb->next->before = newb;
		newb = newb->LastBlock();
	}
	
	return newb->TopBlock();
}


////////////////////////////////////////////////////////////////
// ǡå
////////////////////////////////////////////////////////////////
int cP6DATA::SetData( FILE *fp, int num )
{
	// åȺѤߤʤ鳫
	if( Data ) delete Data;
	
	// 
	Data = new BYTE[num];
	if( Data ) Info.DNum = num;
	else       return 0;
	
	Info.Offset = ftell( fp );
	
	if( fp ) fread( Data, sizeof(BYTE), num, fp );
	else     ZeroMemory( Data, num );
	
	return Info.DNum;
}


////////////////////////////////////////////////////////////////
// ̵,ԡ֥å
////////////////////////////////////////////////////////////////
void cP6DATA::SetPeriod( int stime, int ptime )
{
	PRINTD2( P6T2_LOG, "[cP6DATA][SetPeriod] s:%d p:%d\n", stime, ptime );
	
	Info.STime = stime;	// ̵λ(ms)å
	Info.PTime = ptime;	// ԡλ(ms)å
}


////////////////////////////////////////////////////////////////
// P6T ֥å
////////////////////////////////////////////////////////////////
void cP6DATA::GetInfo( P6TBLKINFO *info )
{
	info->STime  = Info.STime;	// ̵λ(ms)
	info->PTime  = Info.PTime;	// ԡλ(ms)
	info->Offset = Info.Offset;	// ٥᡼ƬΥեå
	info->DNum   = Info.DNum;	// ǡ
}


////////////////////////////////////////////////////////////////
// 1Byteɹ
////////////////////////////////////////////////////////////////
BYTE cP6DATA::Read( int num )
{
	if( !Data || num > Info.DNum ) return 0;
	return Data[num];
}


////////////////////////////////////////////////////////////////
// ե˽(ǡ)
////////////////////////////////////////////////////////////////
int cP6DATA::Writefd( FILE *fp )
{
	Info.Offset = ftell( fp );
	
	return fwrite( Data, sizeof(BYTE), Info.DNum, fp );
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6PART::cP6PART( void )
{
//printf( "[cP6PART] %x\n", (int)this );

	// н
	ID = 0;
	*Name = '\0';
	Baud  = 1200;
	
	Data = NULL;
	
	next = before = NULL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6PART::~cP6PART( void )
{
//printf( "[~cP6PART] %x\n", (int)this );

	if( Data ) delete Data;
	if( next ) delete next;
	if( before ) before->next = NULL;
}


////////////////////////////////////////////////////////////////
// ƬPARTؤΥݥ󥿤֤
////////////////////////////////////////////////////////////////
cP6PART *cP6PART::TopPart( void )
{
	cP6PART *top = this;
	while( top->before ) top = top->before;
	
	return top;
}


////////////////////////////////////////////////////////////////
// PARTؤΥݥ󥿤֤
////////////////////////////////////////////////////////////////
cP6PART *cP6PART::LastPart( void )
{
	cP6PART *last = this;
	while( last->next ) last = last->next;
	
	return last;
}


////////////////////////////////////////////////////////////////
// ǤդPARTؤΥݥ󥿤֤
////////////////////////////////////////////////////////////////
cP6PART *cP6PART::Part( int num )
{
	cP6PART *part = TopPart();
	
	for( int i=0; i< num; i++ ){
		if( part->next ) part = part->next;
		else             break;
	}
	
	return part;
}


////////////////////////////////////////////////////////////////
// IDֹʥС
////////////////////////////////////////////////////////////////
BYTE cP6PART::Renumber( void )
{
	cP6PART *part = TopPart();
	
	part->ID = 0;
	while( part->next ){
		part->next->ID = part->ID + 1;
		part = part->next;
	}
	
	return LastPart()->ID;
}


////////////////////////////////////////////////////////////////
// PARTɲ
////////////////////////////////////////////////////////////////
cP6PART *cP6PART::New( void )
{
	LastPart()->next = new cP6PART;
	LastPart()->before = this;
	
	return LastPart();
}


////////////////////////////////////////////////////////////////
// ԡ
////////////////////////////////////////////////////////////////
cP6PART *cP6PART::Clone( void )
{
	cP6PART *newp = new cP6PART;
	*newp = *this;
	newp->next = newp->before = NULL;
	
	if( this->Data ) newp->Data = this->Data->Clones();
	
	return newp;
}


////////////////////////////////////////////////////////////////
// PARTϢ
////////////////////////////////////////////////////////////////
cP6PART *cP6PART::Link( cP6PART *src )
{
	cP6PART *last = LastPart();
	
	last->next  = src;
	src->before = last;
	
	Renumber();
	
	return src;
}


////////////////////////////////////////////////////////////////
// DATA֥åɲ
////////////////////////////////////////////////////////////////
cP6DATA *cP6PART::NewBlock( void )
{
	if( Data ) return Data->New();
	else       return Data = new cP6DATA;
}


////////////////////////////////////////////////////////////////
// DATA֥å
////////////////////////////////////////////////////////////////
int cP6PART::GetBlocks( void )
{
	int num = 0;
	cP6DATA *data = Data;
	
	do{
		num ++;
		data = data->Next();
	}while( data );
	
	return num;
}


////////////////////////////////////////////////////////////////
// PART
////////////////////////////////////////////////////////////////
int cP6PART::GetSize( void )
{
	int size = 0;
	
	cP6DATA *data = Data;
	while( data ){
		size += data->GetSize();
		data  = data->Next();
	}
	
	return size;
}

////////////////////////////////////////////////////////////////
// ǡ̾
////////////////////////////////////////////////////////////////
int cP6PART::SetName( char *name )
{
	ZeroMemory( Name, sizeof(Name) );
	strncpy( Name, name, sizeof(Name)-1 );
	
	return strlen( Name );
}


////////////////////////////////////////////////////////////////
// ե뤫PARTɹ
////////////////////////////////////////////////////////////////
BOOL cP6PART::Readf( FILE *fp )
{
	PRINTD( P6T2_LOG, "[cP6PART][Readf]\n" );
	
	// եݥ󥿤ͭ?
	if( !fp ) return FALSE;
	
	// ̻ "TI"(0x4954) ?
	while( ( GETWORD( fp ) ) == 0x4954 ){
		
		BYTE NextID = fgetc( fp );	// IDֹ
		
		// DATA֥å,IDۤʤʤ鿷PARTɲ
		if( LastPart()->Data && ( LastPart()->ID != NextID ) ){
			New();
			LastPart()->ID = NextID;
		}
		
		// DATA֥å?
		if( LastPart()->Data )
			// ³PARTʤǡ̾ȥܡ졼ȤɤФ
			fseek( fp, sizeof(Name)+sizeof(Baud)-1, SEEK_CUR );
		else{
			fread( LastPart()->Name, sizeof(BYTE), sizeof(Name)-1, fp );	// ǡ̾
			LastPart()->Baud = GETWORD( fp );								// ܡ졼
		}
		// DATA֥åɲ
		cP6DATA *NewBlk = LastPart()->NewBlock();
		
		WORD stime = GETWORD( fp );		// ̵λ(ms)
		WORD ptime = GETWORD( fp );		// ԡλ(ms)
		DWORD doff = GETDWORD( fp );	// ٥᡼ƬΥեå
		DWORD dnum = GETDWORD( fp );	// ǡ
		
		// ǡɹ
		DWORD fps = ftell( fp );
		fseek( fp, doff, SEEK_SET );
		NewBlk->SetData( fp, dnum );
		NewBlk->SetPeriod( stime, ptime );
		fseek( fp, fps, SEEK_SET );	// եݥ󥿤򼡤PART᤹
	}
	
	Renumber();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ե˽(ǡ)
////////////////////////////////////////////////////////////////
int cP6PART::Writefd( FILE *fp )
{
	cP6DATA *data = Data;
	int size = 0;
	
	do{
		size += data->Writefd( fp );
		data = data->Next();
	}while( data );
	
	return size;
}


////////////////////////////////////////////////////////////////
// ե˽(եå)
////////////////////////////////////////////////////////////////
BOOL cP6PART::Writeff( FILE *fp )
{
// [DATA֥å]
//  header (2byte) : "TI"
//  id     (1byte) : IDֹ(DATA֥åϢդ)
//  name  (16byte) : ǡ̾(15ʸ+'00H')
//  baud   (2byte) : ܡ졼(600/1200)
//  stime  (2byte) : ̵λ(ms)
//  ptime  (2byte) : ԡλ(ms)
//  offset (4byte) : ٥᡼ƬΥեå
//  size   (4byte) : ǡ
	
	cP6DATA *data = Data;
	
	do{
		fputc( 'T', fp );
		fputc( 'I', fp );
		fputc( ID, fp );
		fwrite( Name, sizeof(BYTE), 16, fp );
		PUTWORD( Baud, fp )
		
		P6TBLKINFO info;
		data->GetInfo( &info );
		PUTWORD( info.STime, fp );
		PUTWORD( info.PTime, fp );
		PUTDWORD( info.Offset, fp );
		PUTDWORD( info.DNum, fp );
		
		data = data->Next();
	}while( data );
	
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6T::cP6T( void )
{
	// н
	*Name     = '\0';
	Version   = 0;
	Start     = FALSE;
	BASIC     = 1;
	Page      = 1;
	ASKey     = EHead = 0;
	ask       = exh   = NULL;
	Part      = NULL;
	rpart     = NULL;
	rdata     = NULL;
	rpt       = 0;
	swait     = pwait = 0;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6T::~cP6T( void )
{
	if( Part ) delete Part;
	if( ask ) delete [] ask;
	if( exh ) delete [] exh;
}


////////////////////////////////////////////////////////////////
// DATA֥å
////////////////////////////////////////////////////////////////
int cP6T::GetBlocks( void )
{
	int num = 0;
	cP6PART *part = Part;
	
	do{
		num += part->GetBlocks();
		part = part->Next();
	}while( part );
	
	return num;
}


////////////////////////////////////////////////////////////////
// PART
////////////////////////////////////////////////////////////////
int cP6T::GetParts( void )
{
	int num = 0;
	cP6PART *part = Part;
	
	do{
		num ++;
		part = part->Next();
	}while( part );
	
	return num;
}


////////////////////////////////////////////////////////////////
// ٥᡼
////////////////////////////////////////////////////////////////
int cP6T::GetSize( void )
{
	int size = 0;
	cP6PART *part = Part;
	
	while( part ){
		size += part->GetSize();
		part  = part->Next();
	}
	
	return size;
}


////////////////////////////////////////////////////////////////
// ǡ̾
////////////////////////////////////////////////////////////////
int cP6T::SetName( char *name )
{
//	ZeroMemory( Name, sizeof(Name) );
//	strncpy( Name, name, sizeof(Name)-1 );
	ZeroMemory( Name, 16 );
	strncpy( Name, name, 16 );
	
	return strlen( Name );
}


////////////////////////////////////////////////////////////////
// ȥ
////////////////////////////////////////////////////////////////
//int cP6T::SetAutoStart( char *command )
//{
//	PRINTD1( P6T2_LOG, "[cP6T][SetAutoStart] [%s]\n", command );
//	
//	if( ask ) delete [] ask;
//	ask = NULL;
//	ASKey = strlen( command );
//	if( ASKey ){
//		Start = TRUE;
//		ask = new char[ASKey];
//		strcpy( ask, command );
//		return ASKey;
//	}else{
//		Start = FALSE;
//		return 0;
//	}
//}


////////////////////////////////////////////////////////////////
// 1ʸɹ
////////////////////////////////////////////////////////////////
BYTE cP6T::ReadOne( void )
{
	P6TBLKINFO binfo;
	
	BYTE data = rdata->Read( rpt++ );
	
	PRINTD1( P6T2_LOG, "[cP6T][ReadOne] -> %02X\n", data );
	
	// ֥å
	rdata->GetInfo( &binfo );
	if( rpt >= binfo.DNum ){	// ǡǸ?
		rpt = 0;
		if( !( rdata = rdata->Next() ) ){	// DATA֥åǸ?
			if( !( rpart = rpart->Next() ) ){	// PARTǸ?
				rpart = Part;
			}
			rdata = rpart->FirstData();
		}
		// Υ֥å
		rdata->GetInfo( &binfo );
		swait = binfo.STime * DEFAULT_CMT_HZ/1000;
		pwait = binfo.PTime * DEFAULT_CMT_HZ/1000;
	}
	
	return data;
}


////////////////////////////////////////////////////////////////
// ̵Ԥ?
////////////////////////////////////////////////////////////////
BOOL cP6T::IsSWaiting( void )
{
	if( !swait ) return FALSE;
	swait--;
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ԡԤ?
////////////////////////////////////////////////////////////////
BOOL cP6T::IsPWaiting( void )
{
	if( !pwait ) return FALSE;
	pwait--;
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå(ɹߴط)
////////////////////////////////////////////////////////////////
void cP6T::Reset( void )
{
	PRINTD( P6T2_LOG, "[cP6T][Reset]\n" );
	
	// ɹߴط
	rpart = Part;				// ߤɹPART
	rdata = Part->FirstData();	// ߤɹDATA֥å
	rpt   = 0;					// ߤɹߥݥ
	
	P6TBLKINFO binfo;
	
	rdata->GetInfo( &binfo );
	swait = binfo.STime * DEFAULT_CMT_HZ/1000;	// ̵Ԥ
	pwait = binfo.PTime * DEFAULT_CMT_HZ/1000;	// ԡԤ
}


////////////////////////////////////////////////////////////////
// ե뤫ɹ
////////////////////////////////////////////////////////////////
BOOL cP6T::Readf( char *filename )
{
	PRINTD1( P6T2_LOG, "[cP6T][Readf] [%s]\n", filename );
	
	if( !ReadP6T( filename ) ){		// P6Tɹ
		// Ԥ٥ȤߤʤP6TѴɹ
		if( !ConvP6T( filename ) ) return FALSE;
	}
	
	Reset();	// ꥻå(ɹߴط)
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ե˽
////////////////////////////////////////////////////////////////
BOOL cP6T::Writef( char *filename )
{
	PRINTD1( P6T2_LOG, "[cP6T][Writef] [%s]\n", filename );
	
	FILE *fp;
	
	if( !(fp = fopen( filename, "wb" )) ) return FALSE;
	
	// ǡ&٥᡼
	DWORD BetaSize = 0;
	cP6PART *part = Part;
	do{
		BetaSize += part->Writefd( fp );
		part = part->Next();
	}while( part );
	

// [եå]
//  header (2byte) : "P6"
//  ver    (1byte) : С
//  dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
//  start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
//  basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
//  page   (1byte) : ڡ
//  askey  (2byte) : ȥȥޥʸ
//  ...ޥɤϤθaskeyʬ³
//  exhead (2byte) : ĥ󥵥(64KBޤ)
//  ...ĥ󤬤Ϥθexheadʬ³

	// P6T եå
	fputc( 'P', fp );
	fputc( '6', fp );
	fputc( Version, fp );
	fputc( GetBlocks(), fp );
	fputc( Start ? 1 : 0, fp );
	fputc( BASIC, fp );
	fputc( Page, fp );
	PUTWORD( ASKey, fp );
	if( ASKey ) fwrite( ask, sizeof(char), ASKey, fp );
	PUTWORD( EHead, fp );
	if( EHead ) fwrite( exh, sizeof(char), EHead, fp );
	
	// DATA֥åեå
	part = Part;
	do{
		part->Writeff( fp );
		part = part->Next();
	}while( part );
	
	// ٥᡼
	PUTDWORD( BetaSize, fp );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// P6Tɹ
////////////////////////////////////////////////////////////////
BOOL cP6T::ReadP6T( char *filename )
{
	PRINTD1( P6T2_LOG, "[cP6T][ReadP6T] [%s]\n", filename );
	
	FILE *fp;
	
	if( !(fp = fopen( filename, "rb" )) ) return FALSE;
	
	// ٥᡼
	fseek( fp, -4, SEEK_END );
	DWORD BetaSize = GETDWORD( fp );
	// ٥᡼ե륵ĶƤ饨顼
	if( BetaSize > (DWORD)ftell( fp ) ){ fclose( fp ); return FALSE; }
	
	// եåƬ˰ư
	fseek( fp, BetaSize, SEEK_SET );
	
	// ̻ "P6"(0x3650) ǤʤХ顼
	WORD Header = GETWORD( fp );
	if( Header != 0x3650 ){ fclose( fp ); return FALSE; }
	
	Version = fgetc( fp );					// С
	fgetc( fp );							// ޤޤDATA֥å
	Start   = fgetc( fp ) ? TRUE : FALSE;	// ȥȥե饰
	BASIC   = fgetc( fp );					// BASIC⡼
	Page    = fgetc( fp );					// ڡ
	
	// ȥȥޥ
	ASKey = GETWORD( fp );
	if( ASKey ){
		ask = new char[ASKey];
		fread( ask, sizeof(char), ASKey, fp );
	}
	
	// ĥ
	EHead = GETWORD( fp );
	if( EHead ){
		exh = new char[EHead];
		fread( exh, sizeof(char), EHead, fp );
	}
	
	// PARTɹ
	Part = new cP6PART;
	if( !Part->Readf( fp ) ){ fclose( fp ); return FALSE; }
	
	fclose( fp );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ٥P6TѴɹ
////////////////////////////////////////////////////////////////
BOOL cP6T::ConvP6T( char *filename )
{
	PRINTD1( P6T2_LOG, "[cP6T][ConvP6T] [%s]\n", filename );
	
	FILE *fp;
	
	if( !(fp = fopen( filename, "rb" )) ) return FALSE;
	
	// ٥᡼
	fseek( fp, 0, SEEK_END );
	DWORD BetaSize = ftell( fp );
	fseek( fp, 0, SEEK_SET );
	
	// P6T
	SetName( filename );			// ǡ̾(16ʸ+'00H')ϥե̾
	Version = 2;					// С(Ȥꤢ2)
	Start   = FALSE;				// ȥȥե饰(̵)
	BASIC   = 1;					// BASIC⡼(PC-6001ξ̵̣)(Ȥꤢ1̵̣)
	Page    = 1;					// ڡ(Ȥꤢ1̵̣)
	ASKey   = 0;					// ȥȥޥɥ(0:̵)
	EHead   = 0;					// ĥ󥵥(0:ʤ)
	ask     = NULL;					// ȥȥޥɳǼΰؤΥݥ
	exh     = NULL;					// ĥǼΰؤΥݥ
	
	// PART
	Part = new cP6PART;
	Part->SetName( "BetaImage" );	// ǡ̾(16ʸ+'00H')ϤȤꤢ"BetaImage"
	Part->SetBaud( 1200 );			// ܡ졼(1200)
	
	// DATA֥å
	Part->NewBlock();
	Part->FirstData()->SetData( fp, BetaSize );	// ǡå
	Part->FirstData()->SetPeriod( 3400, 6800 );	// ̵(3400ms),ԡ(6800ms)֥å
	
	fclose( fp );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPE󥿼
////////////////////////////////////////////////////////////////
int cP6T::GetCount( void )
{
	if( !rdata ) return 0;
	
	P6TBLKINFO info;
	rdata->GetInfo( &info );
	
	return info.Offset + rpt;
}


////////////////////////////////////////////////////////////////
// TAPE
////////////////////////////////////////////////////////////////
void cP6T::SetCount( int cnt )
{
	if( GetSize() <= cnt ) return;
	
	int off = 0;
	
	// ޤPARTå
	rpart = Part;
	while( off+rpart->GetSize() <= cnt ){
		off   += rpart->GetSize();
		rpart  = rpart->Next();
	}
	// DATAå
	rdata = rpart->FirstData();
	while( off+rdata->GetSize() <= cnt ){
		off   += rdata->GetSize();
		rdata  = rdata->Next();
	}
	
	P6TBLKINFO info;
	rdata->GetInfo( &info );
	
	rpt = cnt - info.Offset;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6T::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "P6T", NULL, "Counter",	"%d",	GetCount() );
	Ini->PutEntry( "P6T", NULL, "swait",	"%d",	swait );
	Ini->PutEntry( "P6T", NULL, "pwait",	"%d",	pwait );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6T::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt( "P6T",	"Counter",	&st,	0 );
	SetCount( st );
	Ini->GetInt( "P6T",	"swait",	&swait,	swait );
	Ini->GetInt( "P6T",	"pwait",	&pwait,	pwait );
	
	return TRUE;
}
