#include <new>

#include "pc60.h"
#include "error.h"

#include "ini.h"

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cPC60::cPC60( void )
{
	PRINTD( CONST_LOG, "cPC60\n" );
	
	UDCount		= 0;		// ̹ޡ󥿽
	UDFPSCount	= 0;		// FPSޡ󥿽
	
	io		= NULL;
	tick	= NULL;
	snd		= NULL;
	psg		= NULL;
	mem		= NULL;
	graph	= NULL;
	intr	= NULL;
	cpu		= NULL;
	disk	= NULL;
	cmt		= NULL;
	cmts	= NULL;
	subcpu	= NULL;
	ppt		= NULL;
	key		= NULL;
	
	UpDateFPSID	= NULL;
	UpDateID	= NULL;
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	regw	= NULL;
	memw	= NULL;
	monw	= NULL;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	Ready	= FALSE;
}

cPC62::cPC62( void )
{
	PRINTD( CONST_LOG, "cPC62\n" );
	
	voice = NULL;
}

cPC66::cPC66( void )
{
	PRINTD( CONST_LOG, "cPC66\n" );
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cPC60::~cPC60()
{
	PRINTD( CONST_LOG, "~cPC60\n" );
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( monw )   delete monw;
	if( memw )   delete memw;
	if( regw )   delete regw;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	if( UpDateID ) SDL_RemoveTimer( UpDateID );
	if( UpDateFPSID ) SDL_RemoveTimer( UpDateFPSID );
	
	if( key )    delete key;
	if( ppt )    delete ppt;
	if( subcpu ) delete subcpu;
	if( cmts )   delete cmts;
	if( cmt )    delete cmt;
	if( disk )   delete disk;
	if( cpu )    delete cpu;
	if( intr )   delete intr;
	if( graph )  delete graph;
	if( mem )    delete mem;
	if( psg )    delete psg;
	if( snd )    delete snd;
	if( tick )   delete tick;
	if( io )     delete io;
}

cPC62::~cPC62()
{
	PRINTD( CONST_LOG, "~cPC62\n" );
	
	if( voice )  delete voice;
}

cPC66::~cPC66()
{
	PRINTD( CONST_LOG, "~cPC66\n" );
}



////////////////////////////////////////////////////////////////
// åɴؿ(С饤)
////////////////////////////////////////////////////////////////
void cPC60::OnThread( void *inst )
{
	cPC60 *p6;
	
	p6 = (cPC60 *)inst;	// ʬȤΥ֥ȥݥ󥿼
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( !BP.ExistBreakPoint() ){
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		// ̾¹
		while( !this->SThread::IsCancel() )
			p6->Emu();
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	}else{
		// ֥졼ݥȤ
		while( !this->SThread::IsCancel() ){
			p6->Emu();		// 1̿¹
			
			if( BP.CheckBreakPoint( cBreakPoint::BP_PC, cpu->GetPC(), 0, NULL ) || BP.IsReqBreak() ){
				this->SThread::Cancel();	// åɽλե饰ΩƤ
				BP.ResetBreak();
				SENDEVENT( SDL_DEBUGMODEBP )
				break;
			}
		}
	}
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}


////////////////////////////////////////////////////////////////
// 1̿¹
////////////////////////////////////////////////////////////////
int cPC60::Emu( void )
{
	int state;
	
	state = cpu->Exec();							// CPU 1̿¹
	tick->IntrCtrl( state );						// ơȿûȳȯ
	subcpu->Exec( tick->IsCmtIntrReq() );			// CPU¹
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	intr->SetTimerIntr( tick->IsTimerIntrReq() && cGlobal::GetTimerIntr() );	// ޳ȯ
	#else
	intr->SetTimerIntr( tick->IsTimerIntrReq() );	// ޳ȯ
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
													// 
	tick->WaitZ80( cGlobal::WaitEnable && (!cGlobal::TurboTAPE || (subcpu->GetCmtStatus() == CMTCLOSE)) );
	
	return state;
}


#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
////////////////////////////////////////////////////////////////
// ꥹơȿ¹
////////////////////////////////////////////////////////////////
void cPC60::Exec( int st )
{
	int State = st;
	
	while( State > 0 ) State -= Emu();
}
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cPC60::Init( void )
{
	// 顼å
	Error::SetError( Error::InitFailed );
	
	// Ƽ索֥ȳݤȥǥХ³
	
	// I/O-----
	io = new cP6io;
	if( !io ) return FALSE;
	if( !io->Init() ) return FALSE;
	
	// 塼 -----
	const static IOBus::Connector c_tick[] = {
		{ 0x92, IOBus::portout, cP60sche::out92H },
//		{ 0xc1, IOBus::portout, cP60sche::outC1H },
//		{ 0xf6, IOBus::portout, cP60sche::outF6H },
		{ 0, 0, 0 }	};
	tick = new cP60sche( DEV_ID('T', 'I', 'C', 'K') );
	if( !tick || !io->Connect( (cP60sche*)tick, c_tick ) ) return FALSE;
	if( !tick->Init( cGlobal::SoundBuffer ) ) return FALSE;
	tick->SetCpuClock( DEFAULT_CPU_CLOCK * cGlobal::OverClock / 100 );
	
	//  -----
	snd = new cSound;
	if( !snd ) return FALSE;
	if( !snd->Init( this, SoundUpdate, cGlobal::SampleRate, cGlobal::SoundBuffer ) ) return FALSE;
	snd->SetVolume( cGlobal::MasterVol );
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, cP6psg::outA0H },
		{ 0xa1, IOBus::portout, cP6psg::outA1H },
		{ 0xa3, IOBus::portout, cP6psg::outA3H },
		{ 0xa2, IOBus::portin,  cP6psg::inA2H },
		{ 0, 0, 0 }	};
	psg = new cP6psg( DEV_ID('P', 'S', 'G', '1') );
	if( !psg || !io->Connect( psg, c_psg ) ) return FALSE;
	if( !psg->Init( (cP60sche*)tick, snd->AddStream(), snd->AddStream(), snd->AddStream(), cGlobal::SampleRate ) ) return FALSE;
	psg->SetVolume( cGlobal::PsgVol );
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0x92, IOBus::portout, cP6mem60::out92H },
		{ 0x93, IOBus::portout, cP6mem60::out93H },
		{ 0, 0, 0 }	};
	mem = new cP6mem60( DEV_ID('M', 'E', 'M', '1'), cGlobal::UseExtRam );
	if( !mem || !io->Connect( (cP6mem60*)mem, c_memory ) ) return FALSE;
	if( !mem->Init( cGlobal::RomPath, cGlobal::ExtRomFile, cGlobal::CheckCRC ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_graph[] = {
		{ 0xb0, IOBus::portout, cP6draw60::outB0H },
		{ 0, 0, 0 } };
	graph = new cP6draw60( DEV_ID('D', 'I', 'S', 'P') );
	if( !graph || !io->Connect( (cP6draw60*)graph, c_graph ) ) return FALSE;
	if( !graph->Init( mem ) ) return FALSE;
	graph->SetMode4Color( cGlobal::Mode4Color );
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, cP6intr60::outB0H },
		{ 0, 0, 0 }	};
	intr = new cP6intr60( DEV_ID('I', 'N', 'T', 'R') );
	if( !intr || !io->Connect( (cP6intr60*)intr, c_intr ) ) return FALSE;
	if( !intr->Init() ) return FALSE;
	
	// CPU -----
	const static IOBus::Connector c_cpu[] = {
		{ 0, 0, 0 }	};
	cpu = new cP6z80( DEV_ID('C', 'P', 'U', '1') );
	if( !cpu || !io->Connect( cpu, c_cpu ) ) return FALSE;
	if( !cpu->Init( mem, io, intr ) ) return FALSE;
	
	// DISK -----
	if( cGlobal::FddNum ){
		const static IOBus::Connector c_disk[] = {
			{ 0xd1, IOBus::portout, cP6disk::outD1H },
			{ 0xd2, IOBus::portout, cP6disk::outD2H },
			{ 0xd3, IOBus::portout, cP6disk::outD3H },
			{ 0xd0, IOBus::portin,  cP6disk::inD0H },
			{ 0xd1, IOBus::portin,  cP6disk::inD1H },
			{ 0xd2, IOBus::portin,  cP6disk::inD2H },
			{ 0xd3, IOBus::portin,  cP6disk::inD3H },
			{ 0, 0, 0 }	};
		disk = new cP6disk( DEV_ID('D', 'I', 'S', 'K'), cGlobal::FddNum );
		if( !disk || !io->Connect( (cP6disk*)disk, c_disk ) ) return FALSE;
		if( !disk->Init() ) return FALSE;
		// ɥ饤1DISK
		if( cGlobal::DiskFile[0] ) DiskInsert( 0, cGlobal::DiskFile[0] );
	}else
		disk = NULL;
	
	// CMT -----
	cmt = new cP6tape;
	if( !cmt ) return FALSE;
	if( !cmt->Init( snd->AddStream() ) ) return FALSE;
	cmt->SetVolume( cGlobal::CmtVol );
	// TAPE
	if( cGlobal::TapeFile ) TapeInsert( cGlobal::TapeFile );
	// ȥȤ
	cmt->Reset();
	
	// CMT(SAVE) -----
	cmts = new cP6csave;
	if( !cmts ) return FALSE;
	if( !cmts->Init( cGlobal::SaveFile ) ) return FALSE;
	
	// SUB CPU -----
	const static IOBus::Connector c_8049[] = {
		{ 0xb0, IOBus::portout, cP6D8049::outB0H },
		{ 0, 0, 0 }	};
	subcpu = new cP6D8049( DEV_ID('8', '0', '4', '9') );
	if( !subcpu || !io->Connect( subcpu, c_8049 ) ) return FALSE;
	if( !subcpu->Init( intr, cmt, cmts ) ) return FALSE;
	
	// 8255 -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, cP6D8255::out90H },
		{ 0x91, IOBus::portout, cP6D8255::out91H },
		{ 0x92, IOBus::portout, cP6D8255::out92H },
		{ 0x93, IOBus::portout, cP6D8255::out93H },
		{ 0x90, IOBus::portin,  cP6D8255::in90H },
		{ 0x92, IOBus::portin,  cP6D8255::in92H },
		{ 0x93, IOBus::portin,  cP6D8255::in93H },
		{ 0, 0, 0 }	};
	ppt = new cP6D8255( DEV_ID('8', '2', '5', '5') );
	if( !ppt || !io->Connect( ppt, c_8255 ) ) return FALSE;
	if( !ppt->Init( subcpu, intr, graph ) ) return FALSE;
	
	//  -----
	key = new cP60key;
	if( !key ) return FALSE;
	if( !key->Init( cGlobal::KeyRepeat ) ) return FALSE;
	
	// ̹ޡ
	if( !SetFPS( cGlobal::FrameRate ) ){
		Stop();
		return FALSE;
	}
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// 쥸ɥ -----
	regw = new cWndReg;
	if( !regw ) return FALSE;
	if( !(cGlobal::RegWin = regw->Init( cpu )) ) return FALSE;
	
	// ꥦɥ -----
	memw = new cWndMem;
	if( !memw ) return FALSE;
	if( !(cGlobal::MemWin = memw->Init( mem )) ) return FALSE;
	
	// ˥ɥ -----
	monw = new cWndMon;
	if( !monw ) return FALSE;
	if( !(cGlobal::MonWin = monw->Init( cpu, mem )) ) return FALSE;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	Ready = TRUE;
	
	// 顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}

BOOL cPC62::Init( void )
{
	// 顼å
	Error::SetError( Error::InitFailed );
	
	// Ƽ索֥ȳݤȥǥХ³
	
	// I/O-----
	io = new cP6io;
	if( !io ) return FALSE;
	if( !io->Init() ) return FALSE;
	
	// 塼 -----
	const static IOBus::Connector c_tick[] = {
		{ 0x92, IOBus::portout, cP62sche::out92H },
		{ 0xc1, IOBus::portout, cP62sche::outC1H },
		{ 0xf6, IOBus::portout, cP62sche::outF6H },
		{ 0, 0, 0 }	};
	tick = new cP62sche( DEV_ID('T', 'I', 'C', 'K') );
	if( !tick || !io->Connect( (cP62sche*)tick, c_tick ) ) return FALSE;
	if( !tick->Init( cGlobal::SoundBuffer ) ) return FALSE;
	tick->SetCpuClock( DEFAULT_CPU_CLOCK * cGlobal::OverClock / 100 );
	
	//  -----
	snd = new cSound;
	if( !snd ) return FALSE;
	if( !snd->Init( this, SoundUpdate, cGlobal::SampleRate, cGlobal::SoundBuffer ) ) return FALSE;
	snd->SetVolume( cGlobal::MasterVol );
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, cP6psg::outA0H },
		{ 0xa1, IOBus::portout, cP6psg::outA1H },
		{ 0xa3, IOBus::portout, cP6psg::outA3H },
		{ 0xa2, IOBus::portin,  cP6psg::inA2H },
		{ 0, 0, 0 }	};
	psg = new cP6psg( DEV_ID('P', 'S', 'G', '1') );
	if( !psg || !io->Connect( psg, c_psg ) ) return FALSE;
	if( !psg->Init( (cP62sche*)tick, snd->AddStream(), snd->AddStream(), snd->AddStream(), cGlobal::SampleRate ) ) return FALSE;
	psg->SetVolume( cGlobal::PsgVol );
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0x92, IOBus::portout, cP6mem62::out92H },
		{ 0x93, IOBus::portout, cP6mem62::out93H },
		{ 0xc1, IOBus::portout, cP6mem62::outC1H },
		{ 0xc2, IOBus::portout, cP6mem62::outC2H },
		{ 0xc3, IOBus::portout, cP6mem62::outC3H },
		{ 0xf0, IOBus::portout, cP6mem62::outF0H },
		{ 0xf1, IOBus::portout, cP6mem62::outF1H },
		{ 0xf2, IOBus::portout, cP6mem62::outF2H },
		{ 0xf0, IOBus::portin,  cP6mem62::inF0H },
		{ 0xf1, IOBus::portin,  cP6mem62::inF1H },
		{ 0xf2, IOBus::portin,  cP6mem62::inF2H },
		{ 0, 0, 0 }	};
	mem = new cP6mem62( DEV_ID('M', 'E', 'M', '1') );
	if( !mem || !io->Connect( (cP6mem62*)mem, c_memory ) ) return FALSE;
	if( !mem->Init( cGlobal::RomPath, cGlobal::ExtRomFile, cGlobal::CheckCRC ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_graph[] = {
		{ 0xb0, IOBus::portout, cP6draw62::outB0H },
		{ 0xc0, IOBus::portout, cP6draw62::outC0H },
		{ 0xc1, IOBus::portout, cP6draw62::outC1H },
		{ 0xc1, IOBus::portin,  cP6draw62::inC1H },
		{ 0, 0, 0 } };
	graph = new cP6draw62( DEV_ID('D', 'I', 'S', 'P') );
	if( !graph || !io->Connect( (cP6draw62*)graph, c_graph ) ) return FALSE;
	if( !graph->Init( mem ) ) return FALSE;
	graph->SetMode4Color( cGlobal::Mode4Color );
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, cP6intr62::outB0H },
		{ 0xf3, IOBus::portout, cP6intr62::outF3H },
		{ 0xf4, IOBus::portout, cP6intr62::outF4H },
		{ 0xf5, IOBus::portout, cP6intr62::outF5H },
		{ 0xf7, IOBus::portout, cP6intr62::outF7H },
		{ 0xf7, IOBus::portin,  cP6intr62::inF7H },
		{ 0, 0, 0 }	};
	intr = new cP6intr62( DEV_ID('I', 'N', 'T', 'R') );
	if( !intr || !io->Connect( (cP6intr62*)intr, c_intr ) ) return FALSE;
	if( !intr->Init() ) return FALSE;
	
	// CPU -----
	const static IOBus::Connector c_cpu[] = {
		{ 0xf3, IOBus::portout, cP6z80::outF3H },
		{ 0, 0, 0 }	};
	cpu = new cP6z80( DEV_ID('C', 'P', 'U', '1') );
	if( !cpu || !io->Connect( cpu, c_cpu ) ) return FALSE;
	if( !cpu->Init( mem, io, intr ) ) return FALSE;
	
	// DISK -----
	if( cGlobal::FddNum ){
		const static IOBus::Connector c_disk[] = {
			{ 0xd1, IOBus::portout, cP6disk::outD1H },
			{ 0xd2, IOBus::portout, cP6disk::outD2H },
			{ 0xd3, IOBus::portout, cP6disk::outD3H },
			{ 0xd0, IOBus::portin,  cP6disk::inD0H },
			{ 0xd1, IOBus::portin,  cP6disk::inD1H },
			{ 0xd2, IOBus::portin,  cP6disk::inD2H },
			{ 0xd3, IOBus::portin,  cP6disk::inD3H },
			{ 0, 0, 0 }	};
		disk = new cP6disk( DEV_ID('D', 'I', 'S', 'K'), cGlobal::FddNum );
		if( !disk || !io->Connect( (cP6disk*)disk, c_disk ) ) return FALSE;
		if( !disk->Init() ) return FALSE;
		// ɥ饤1DISK
		if( cGlobal::DiskFile[0] ) DiskInsert( 0, cGlobal::DiskFile[0] );
	}else
		disk = NULL;
	
	// CMT -----
	cmt = new cP6tape;
	if( !cmt ) return FALSE;
	if( !cmt->Init( snd->AddStream() ) ) return FALSE;
	cmt->SetVolume( cGlobal::CmtVol );
	// TAPE
	if( cGlobal::TapeFile ) TapeInsert( cGlobal::TapeFile );
	// ȥȤ
	cmt->Reset();
	
	// CMT(SAVE) -----
	cmts = new cP6csave;
	if( !cmts ) return FALSE;
	if( !cmts->Init( cGlobal::SaveFile ) ) return FALSE;
	
	// SUB CPU -----
	const static IOBus::Connector c_8049[] = {
		{ 0xb0, IOBus::portout, cP6D8049::outB0H },
		{ 0, 0, 0 }	};
	subcpu = new cP6D8049( DEV_ID('8', '0', '4', '9') );
	if( !subcpu || !io->Connect( subcpu, c_8049 ) ) return FALSE;
	if( !subcpu->Init( intr, cmt, cmts ) ) return FALSE;
	
	// 8255 -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, cP6D8255::out90H },
		{ 0x91, IOBus::portout, cP6D8255::out91H },
		{ 0x92, IOBus::portout, cP6D8255::out92H },
		{ 0x93, IOBus::portout, cP6D8255::out93H },
		{ 0x90, IOBus::portin,  cP6D8255::in90H },
		{ 0x92, IOBus::portin,  cP6D8255::in92H },
		{ 0x93, IOBus::portin,  cP6D8255::in93H },
		{ 0, 0, 0 }	};
	ppt = new cP6D8255( DEV_ID('8', '2', '5', '5') );
	if( !ppt || !io->Connect( ppt, c_8255 ) ) return FALSE;
	if( !ppt->Init( subcpu, intr, graph ) ) return FALSE;
	
	//  -----
	key = new cP6key;
	if( !key ) return FALSE;
	if( !key->Init( cGlobal::KeyRepeat ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_voice[] = {
		{ 0xe0, IOBus::portout, cP6voice::outE0H },
		{ 0xe1, IOBus::portout, cP6voice::outE1H },
		{ 0xe2, IOBus::portout, cP6voice::outE2H },
		{ 0xe3, IOBus::portout, cP6voice::outE3H },
		{ 0xe0, IOBus::portin,  cP6voice::inE0H },
		{ 0xe1, IOBus::portin,  cP6voice::inE1H },
		{ 0xe2, IOBus::portin,  cP6voice::inE2H },
		{ 0xe3, IOBus::portin,  cP6voice::inE3H },
		{ 0, 0, 0 }	};
	voice = new cP6voice( DEV_ID('V', 'O', 'I', 'C') );
	if( !voice || !io->Connect( voice, c_voice ) ) return FALSE;
	if( !voice->Init( snd->AddStream(), cGlobal::SampleRate ) ) return FALSE;
	voice->SetVolume( cGlobal::VoiceVol );
	
	// ̹ޡ
	if( !SetFPS( cGlobal::FrameRate ) ){
		Stop();
		return FALSE;
	}
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// 쥸ɥ -----
	regw = new cWndReg;
	if( !regw ) return FALSE;
	if( !(cGlobal::RegWin = regw->Init( cpu )) ) return FALSE;
	
	// ꥦɥ -----
	memw = new cWndMem;
	if( !memw ) return FALSE;
	if( !(cGlobal::MemWin = memw->Init( mem )) ) return FALSE;
	
	// ˥ɥ -----
	monw = new cWndMon;
	if( !monw ) return FALSE;
	if( !(cGlobal::MonWin = monw->Init( cpu, mem )) ) return FALSE;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	Ready = TRUE;
	
	// 顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}

BOOL cPC66::Init( void )
{
	// 顼å
	Error::SetError( Error::InitFailed );
	
	// Ƽ索֥ȳݤȥǥХ³
	
	// I/O-----
	io = new cP6io;
	if( !io ) return FALSE;
	if( !io->Init() ) return FALSE;
	
	// 塼 -----
	const static IOBus::Connector c_tick[] = {
		{ 0x92, IOBus::portout, cP62sche::out92H },
		{ 0xc1, IOBus::portout, cP62sche::outC1H },
		{ 0xf6, IOBus::portout, cP62sche::outF6H },
		{ 0, 0, 0 }	};
	tick = new cP62sche( DEV_ID('T', 'I', 'C', 'K') );
	if( !tick || !io->Connect( (cP62sche*)tick, c_tick ) ) return FALSE;
	if( !tick->Init( cGlobal::SoundBuffer ) ) return FALSE;
	tick->SetCpuClock( DEFAULT_CPU_CLOCK * cGlobal::OverClock / 100 );
	
	//  -----
	snd = new cSound;
	if( !snd ) return FALSE;
	if( !snd->Init( this, SoundUpdate, cGlobal::SampleRate, cGlobal::SoundBuffer ) ) return FALSE;
	snd->SetVolume( cGlobal::MasterVol );
	
	// PSG -----
	const static IOBus::Connector c_psg[] = {
		{ 0xa0, IOBus::portout, cP6psg::outA0H },
		{ 0xa1, IOBus::portout, cP6psg::outA1H },
		{ 0xa3, IOBus::portout, cP6psg::outA3H },
		{ 0xa2, IOBus::portin,  cP6psg::inA2H },
		{ 0, 0, 0 }	};
	psg = new cP6psg( DEV_ID('P', 'S', 'G', '1') );
	if( !psg || !io->Connect( psg, c_psg ) ) return FALSE;
	if( !psg->Init( (cP62sche*)tick, snd->AddStream(), snd->AddStream(), snd->AddStream(), cGlobal::SampleRate ) ) return FALSE;
	psg->SetVolume( cGlobal::PsgVol );
	
	//  -----
	const static IOBus::Connector c_memory[] = {
		{ 0x92, IOBus::portout, cP6mem62::out92H },
		{ 0x93, IOBus::portout, cP6mem62::out93H },
		{ 0xc1, IOBus::portout, cP6mem62::outC1H },
		{ 0xc2, IOBus::portout, cP6mem62::outC2H },
		{ 0xc3, IOBus::portout, cP6mem62::outC3H },
		{ 0xf0, IOBus::portout, cP6mem62::outF0H },
		{ 0xf1, IOBus::portout, cP6mem62::outF1H },
		{ 0xf2, IOBus::portout, cP6mem62::outF2H },
		{ 0xf0, IOBus::portin,  cP6mem62::inF0H },
		{ 0xf1, IOBus::portin,  cP6mem62::inF1H },
		{ 0xf2, IOBus::portin,  cP6mem62::inF2H },
		{ 0, 0, 0 }	};
	mem = new cP6mem66( DEV_ID('M', 'E', 'M', '1') );
	if( !mem || !io->Connect( (cP6mem66*)mem, c_memory ) ) return FALSE;
	if( !mem->Init( cGlobal::RomPath, cGlobal::ExtRomFile, cGlobal::CheckCRC ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_graph[] = {
		{ 0xb0, IOBus::portout, cP6draw62::outB0H },
		{ 0xc0, IOBus::portout, cP6draw62::outC0H },
		{ 0xc1, IOBus::portout, cP6draw62::outC1H },
		{ 0xc1, IOBus::portin,  cP6draw62::inC1H },
		{ 0, 0, 0 } };
	graph = new cP6draw62( DEV_ID('D', 'I', 'S', 'P') );
	if( !graph || !io->Connect( (cP6draw62*)graph, c_graph ) ) return FALSE;
	if( !graph->Init( mem ) ) return FALSE;
	graph->SetMode4Color( cGlobal::Mode4Color );
	
	//  -----
	const static IOBus::Connector c_intr[] = {
		{ 0xb0, IOBus::portout, cP6intr62::outB0H },
		{ 0xf3, IOBus::portout, cP6intr62::outF3H },
		{ 0xf4, IOBus::portout, cP6intr62::outF4H },
		{ 0xf5, IOBus::portout, cP6intr62::outF5H },
		{ 0xf7, IOBus::portout, cP6intr62::outF7H },
		{ 0xf7, IOBus::portin,  cP6intr62::inF7H },
		{ 0, 0, 0 }	};
	intr = new cP6intr62( DEV_ID('I', 'N', 'T', 'R') );
	if( !intr || !io->Connect( (cP6intr62*)intr, c_intr ) ) return FALSE;
	if( !intr->Init() ) return FALSE;
	
	// CPU -----
	const static IOBus::Connector c_cpu[] = {
		{ 0xf3, IOBus::portout, cP6z80::outF3H },
		{ 0, 0, 0 }	};
	cpu = new cP6z80( DEV_ID('C', 'P', 'U', '1') );
	if( !cpu || !io->Connect( cpu, c_cpu ) ) return FALSE;
	if( !cpu->Init( mem, io, intr ) ) return FALSE;
	
	// DISK -----
	const static IOBus::Connector c_disk[] = {
		{ 0xb1, IOBus::portout, cP66disk::outB1H },
		{ 0xb2, IOBus::portout, cP66disk::outB2H },
		{ 0xb3, IOBus::portout, cP66disk::outB3H },
		{ 0xd0, IOBus::portout, cP66disk::outD0H },
		{ 0xd1, IOBus::portout, cP66disk::outD1H },
		{ 0xd2, IOBus::portout, cP66disk::outD2H },
		{ 0xd3, IOBus::portout, cP66disk::outD3H },
		{ 0xd6, IOBus::portout, cP66disk::outD6H },
		{ 0xd8, IOBus::portout, cP66disk::outD8H },
		{ 0xda, IOBus::portout, cP66disk::outDAH },
		{ 0xdd, IOBus::portout, cP66disk::outDDH },
		{ 0xde, IOBus::portout, cP66disk::outDEH },
		{ 0xb2, IOBus::portin,  cP66disk::inB2H },
		{ 0xd0, IOBus::portin,  cP66disk::inD0H },
		{ 0xd1, IOBus::portin,  cP66disk::inD1H },
		{ 0xd2, IOBus::portin,  cP66disk::inD2H },
		{ 0xd3, IOBus::portin,  cP66disk::inD3H },
		{ 0xd4, IOBus::portin,  cP66disk::inD4H },
		{ 0xdc, IOBus::portin,  cP66disk::inDCH },
		{ 0xdd, IOBus::portin,  cP66disk::inDDH },
		{ 0, 0, 0 }	};
	disk = new cP66disk( DEV_ID('D', 'I', 'S', 'K'), cGlobal::FddNum );
	if( !disk || !io->Connect( (cP66disk*)disk, c_disk ) ) return FALSE;
	if( !disk->Init() ) return FALSE;
	// ɥ饤1DISK
	if( cGlobal::FddNum && cGlobal::DiskFile[0] ) DiskInsert( 0, cGlobal::DiskFile[0] );
	
	// CMT -----
	cmt = new cP6tape;
	if( !cmt ) return FALSE;
	if( !cmt->Init( snd->AddStream() ) ) return FALSE;
	cmt->SetVolume( cGlobal::CmtVol );
	// TAPE
	if( cGlobal::TapeFile ) TapeInsert( cGlobal::TapeFile );
	// ȥȤ
	cmt->Reset();
	
	// CMT(SAVE) -----
	cmts = new cP6csave;
	if( !cmts ) return FALSE;
	if( !cmts->Init( cGlobal::SaveFile ) ) return FALSE;
	
	// SUB CPU -----
	const static IOBus::Connector c_8049[] = {
		{ 0xb0, IOBus::portout, cP6D8049::outB0H },
		{ 0, 0, 0 }	};
	subcpu = new cP6D8049( DEV_ID('8', '0', '4', '9') );
	if( !subcpu || !io->Connect( subcpu, c_8049 ) ) return FALSE;
	if( !subcpu->Init( intr, cmt, cmts ) ) return FALSE;
	
	// 8255 -----
	const static IOBus::Connector c_8255[] = {
		{ 0x90, IOBus::portout, cP6D8255::out90H },
		{ 0x91, IOBus::portout, cP6D8255::out91H },
		{ 0x92, IOBus::portout, cP6D8255::out92H },
		{ 0x93, IOBus::portout, cP6D8255::out93H },
		{ 0x90, IOBus::portin,  cP6D8255::in90H },
		{ 0x92, IOBus::portin,  cP6D8255::in92H },
		{ 0x93, IOBus::portin,  cP6D8255::in93H },
		{ 0, 0, 0 }	};
	ppt = new cP6D8255( DEV_ID('8', '2', '5', '5') );
	if( !ppt || !io->Connect( ppt, c_8255 ) ) return FALSE;
	if( !ppt->Init( subcpu, intr, graph ) ) return FALSE;
	
	//  -----
	key = new cP6key;
	if( !key ) return FALSE;
	if( !key->Init( cGlobal::KeyRepeat ) ) return FALSE;
	
	//  -----
	const static IOBus::Connector c_voice[] = {
		{ 0xe0, IOBus::portout, cP6voice::outE0H },
		{ 0xe1, IOBus::portout, cP6voice::outE1H },
		{ 0xe2, IOBus::portout, cP6voice::outE2H },
		{ 0xe3, IOBus::portout, cP6voice::outE3H },
		{ 0xe0, IOBus::portin,  cP6voice::inE0H },
		{ 0xe1, IOBus::portin,  cP6voice::inE1H },
		{ 0xe2, IOBus::portin,  cP6voice::inE2H },
		{ 0xe3, IOBus::portin,  cP6voice::inE3H },
		{ 0, 0, 0 }	};
	voice = new cP6voice( DEV_ID('V', 'O', 'I', 'C') );
	if( !voice || !io->Connect( voice, c_voice ) ) return FALSE;
	if( !voice->Init( snd->AddStream(), cGlobal::SampleRate ) ) return FALSE;
	voice->SetVolume( cGlobal::VoiceVol );
	
	// ̹ޡ
	if( !SetFPS( cGlobal::FrameRate ) ){
		Stop();
		return FALSE;
	}
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// 쥸ɥ -----
	regw = new cWndReg;
	if( !regw ) return FALSE;
	if( !(cGlobal::RegWin = regw->Init( cpu )) ) return FALSE;
	
	// ꥦɥ -----
	memw = new cWndMem;
	if( !memw ) return FALSE;
	if( !(cGlobal::MemWin = memw->Init( mem )) ) return FALSE;
	
	// ˥ɥ -----
	monw = new cWndMon;
	if( !monw ) return FALSE;
	if( !(cGlobal::MonWin = monw->Init( cpu, mem )) ) return FALSE;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	Ready = TRUE;
	
	// 顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ư
////////////////////////////////////////////////////////////////
BOOL cPC60::Start( void )
{
	// å
	if( !this->SThread::BeginThread( this ) ) return FALSE;
	this->SThread::Start();
	
	tick->Start();
	snd->Play();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cPC60::Stop( void )
{
	this->SThread::Cancel();	// åɽλե饰ΩƤ
	this->SThread::Waiting();	// åɽλޤԤ
	
	snd->Pause();
	tick->Stop();
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void cPC60::Reset( void )
{
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( !DISPMON )
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		Stop();
	
	cpu->Reset();
	intr->Reset();
	mem->Reset();
	subcpu->Reset();
	ppt->Reset();
	psg->Reset();
	if( disk ) disk->Init();
	// ƥǥäƤ饪ȥ̵
	if( !cGlobal::IsSystem[0] ) cmt->Reset();
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( !DISPMON )
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		Start();
}


////////////////////////////////////////////////////////////////
// TAPE 
////////////////////////////////////////////////////////////////
BOOL cPC60::TapeInsert( char *filename )
{
	// TAPEޥ
	if( !cmt->Mount( filename ) ){
		cmt->Unmount();
		return FALSE;
	}
	
	// ɽѤTAPE̾򥳥ԡ
//	strncpy( cGlobal::TapeImgName, cmt->GetTapeName(), 17 );
	// 󥿥ꥻå
	cGlobal::Counter = 0;
	// ٥᡼
	cGlobal::TapeSize = cmt->GetSize();
	// ȥȥå
	cGlobal::IsAutoStart = cmt->IsAutoStart();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPE ӽ
////////////////////////////////////////////////////////////////
void cPC60::TapeEject( void )
{
	cmt->Unmount();
	cGlobal::Counter   = cGlobal::TapeSize     = 0;
//	*cGlobal::TapeFile = *cGlobal::TapeImgName = '\0';
}


////////////////////////////////////////////////////////////////
// DISK 
////////////////////////////////////////////////////////////////
BOOL cPC60::DiskInsert( int drvno, char *filename )
{
	// ɥ饤ֹ椬̵ʤ饨顼
	if( drvno >= cGlobal::FddNum ) return FALSE;
	
	if( disk ){
		// DISKޥ
		if( !disk->Mount( drvno, filename ) ){
			disk->Unmount( drvno );
			return FALSE;
		}
		
		// ɽѤDISK̾򥳥ԡ
		strncpy( cGlobal::DiskImgName[drvno], disk->GetDiskName( drvno ), 17 );
		// ƥǥå
		cGlobal::IsSystem[drvno]  = disk->IsSystem( drvno );
		// ץƥȥå
		cGlobal::IsProtect[drvno] = disk->IsProtect( drvno );
		
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// DISK ӽ
////////////////////////////////////////////////////////////////
void cPC60::DiskEject( int drvno )
{
	if( drvno >= cGlobal::FddNum ) return;
	
	if( disk ){
		// DISK򥢥ޥ
		disk->Unmount( drvno );
		
//		*cGlobal::DiskFile[drvno]    = '\0';
//		*cGlobal::DiskImgName[drvno] = '\0';
//		cGlobal::IsSystem[drvno]     = FALSE;
//		cGlobal::IsProtect[drvno]    = FALSE;
	}
}


////////////////////////////////////////////////////////////////
// ĥROM 
////////////////////////////////////////////////////////////////
BOOL cPC60::ExtRomInsert( char *filename )
{
	// ĥROMޥ
	if( !mem->MountExtRom( filename ) ){
		mem->UnmountExtRom();
		return FALSE;
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ĥROM ӽ
////////////////////////////////////////////////////////////////
void cPC60::ExtRomEject( void )
{
	mem->UnmountExtRom();
}


////////////////////////////////////////////////////////////////
// ٥ȥ롼
////////////////////////////////////////////////////////////////
BOOL cPC60::EventLoop( void )
{
	SDL_Event event;
	
	while( SDL_WaitEvent( &event ) ){
		switch( event.type ){
		case SDL_DRAWSCREEN:	// ̹
			#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			if( DISPREG ) regw->Update();
			if( DISPMEM ) memw->Update();
			if( DISPMON ) monw->Update();
			#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			graph->DrawScreen();
			UDCount = 0;
			break;
			
		case SDL_FPSUPDATE:		// FPS
			{
			char str[256];
			sprintf( str, "%s (%d%%)", cGlobal::GetWCaption(), tick->GetRatio( cP6sche::TRSYNC ) );
			SDL_WM_SetCaption( str, "" );
			}
			UDFPSCount = 0;
			break;
			
		case SDL_KEYDOWN:		// 
		case SDL_KEYUP:
			#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			// ˥⡼?
			if( DISPMON ) monw->KeyIn( &event );
			else
			#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
			{	subcpu->SetKeyJoy( key->GetKeyjoy() );	// 륭ּ
				key->ScanKeyboard( &event );			// ּ̥
			}
			break;
			
		case SDL_TAPEINSERT:	// TAPE 
			if( !TapeInsert( (char *)event.user.data1 ) ) Error::SetError( Error::TapeMountFailed );
			break;
			
		case SDL_TAPEEJECT:		// TAPE ӽ
			TapeEject();
			break;
			
		case SDL_DISKINSERT:	// DISK 
			if( !DiskInsert( 0, (char *)event.user.data1 ) ) Error::SetError( Error::DiskMountFailed );
			break;
			
		case SDL_DISKEJECT:		// DISK ӽ
			DiskEject( 0 );
			break;
			
		case SDL_ROMINSERT:		// ĥROM 
			if( !ExtRomInsert( (char *)event.user.data1 ) ) Error::SetError( Error::ExtRomMountFailed );
			else                                            Reset();
			break;
			
		case SDL_ROMEJECT:		// ĥROM ӽ
			ExtRomEject();
			Reset();
			break;
			
		case SDL_RESET:			// ꥻå
			Reset();
			break;
			
		case SDL_SNAPSHOT:		// ꡼󥷥å
			graph->ScreenShot();
			break;
			
		#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		case SDL_MOUSEMOTION:	// ꥦɥ ɥ쥹ѹ
			if( DISPMEM && event.motion.yrel ){
				// ܥ1ʺܥ)Ƥ?
				if( SDL_GetMouseState( NULL, NULL ) & SDL_BUTTON( 1 ) ){
					if( event.motion.yrel > 0 ) memw->SetAddress( memw->GetAddress() - 16 );
					else                        memw->SetAddress( memw->GetAddress() + 16 );
				}
			}
			break;
			
		case SDL_DEBUGMODEBP:	// ˥⡼ѹ(֥졼ݥã)
			// ǥ֥졼ݥȤξɽ
			
		case SDL_DEBUGMODE:		// ˥⡼ѹ
			BP.ClearStatus();
			
			// ˥ɥɽڴ
			cGlobal::MonDisp = cGlobal::MonDisp ? FALSE : TRUE;
			// 쥸ɥɽڴ
			cGlobal::RegDisp = cGlobal::RegDisp ? FALSE : TRUE;
			// ꥦɥɽڴ
			cGlobal::MemDisp = cGlobal::MemDisp ? FALSE : TRUE;
			
			// ˥⡼ɤʤUnicodeͭ
			if( DISPMON ) SDL_EnableUNICODE( 1 );
			else          SDL_EnableUNICODE( 0 );
			
			// P6 /Ƴ
			if( DISPMON ) Stop();
			else          Start();
			
			// ꡼󥵡ե򥯥ꥢ
			graph->ClearScreen();
			
			break;
			
		#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		
		case SDL_MOUSEBUTTONUP:	// ޥܥ󥯥å
			if( ( event.button.button == SDL_BUTTON_RIGHT ) && ( event.button.state == SDL_RELEASED ) ){
#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
				if( !DISPMON )
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
					Stop();
				// ݥåץåץ˥塼ɽ
				Osd_PopupMenu( event.button.x, event.button.y );
#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
				if( !DISPMON )
#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
					Start();
			}
			break;
			
			
		case SDL_TGLSCREEN:		// ꡼⡼ѹ
			cGlobal::FullScreen = cGlobal::FullScreen ? FALSE : TRUE;
			break;
			
		case SDL_TGLSCANLINE:	// 饤⡼ѹ
			cGlobal::ScanLine = cGlobal::ScanLine ? FALSE : TRUE;
			break;
			
		case SDL_TGLWAIT:		// Wait̵ͭѹ
			cGlobal::WaitEnable = cGlobal::WaitEnable ? FALSE : TRUE;
			break;
			
		case SDL_TGLBOOSTER:	// Turbo TAPEѹ
			cGlobal::TurboTAPE = cGlobal::TurboTAPE ? FALSE : TRUE;
			break;
			
		case SDL_TGLSTATUS:		// ơСɽѹ
			cGlobal::StatDisp = cGlobal::StatDisp ? FALSE : TRUE;
			break;
			
		case SDL_MODE4:			// ⡼4顼ѹ
			// 0-4 ʤľѹ
			if( (event.user.code >= 0) && (event.user.code <= 4) )
				cGlobal::Mode4Color = event.user.code;
			// ʳϥȥ
			else
				if( ++cGlobal::Mode4Color > 4 ) cGlobal::Mode4Color = 0;
			graph->SetMode4Color( cGlobal::Mode4Color );
			break;
			
		case SDL_INDIKANA:		// ʥ󥸥
			cGlobal::IndiKANA = event.user.code;
			break;
			
		case SDL_INDICAPS:		// CAPS󥸥
			cGlobal::IndiCAPS = event.user.code;
			break;
			
		case SDL_REQKEYINTR:	// ׵
			subcpu->SetKeyIntr( (event.user.code>>16)&0xff, event.user.code&0xff );
			break;
			
		case SDL_DOKOSAVE:		// ɤǤSAVE
			DokoDemoSave( (char *)event.user.data1 );
			break;
			
		case SDL_DOKOLOAD:		// ɤǤLOAD
			DokoDemoLoad( (char *)event.user.data1 );
			break;
			
		case SDL_QUIT:			// λ
			return FALSE;
			
		case SDL_RESTART:		// Ƶư
			return TRUE;
			
		}
		
		// 顼
		if( Error::GetError() != Error::NoError ){
			cOsd::Message( (char *)Error::GetErrorText(), MSGE_ERROR, OSDR_OK | OSDM_ICONERROR );
			Error::SetError( Error::NoError );
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ɹ Хåؿ
// len:Хñ
////////////////////////////////////////////////////////////////
void cPC60::SoundUpdate( void *userdata, Uint8 *stream, int len )
{
	cPC60 *p6 = (cPC60 *)userdata;	// ʬȤΥ֥ȥݥ󥿼
	
	// PSG
	p6->psg->Update( -1 );
//	p6->cmt->Update( len );
	
	// ɥХåե
	p6->snd->Update( stream, len );
}


////////////////////////////////////////////////////////////////
// ̹ޡ Хåؿ
////////////////////////////////////////////////////////////////
Uint32 cPC60::UpDate( Uint32 interval, void *obj )
{
	cPC60 *p6 = (cPC60 *)obj;	// ʬȤΥ֥ȥݥ󥿼
	
// åѤʤľǤ⤤롩
//	p6->graph->DrawScreen();

	if( !p6->UDCount ){
		// ̹
		SENDEVENT( SDL_DRAWSCREEN )
		p6->UDCount++;
	}
	return interval;
}


////////////////////////////////////////////////////////////////
// FPSɽޡ Хåؿ
////////////////////////////////////////////////////////////////
Uint32 cPC60::UpDateFPS( Uint32 interval, void *obj )
{
	cPC60 *p6 = (cPC60 *)obj;	// ʬȤΥ֥ȥݥ󥿼
	
	if( !p6->UDFPSCount ){
		// FPS
		SENDEVENT( SDL_FPSUPDATE )
		p6->UDFPSCount++;
	}
	return interval;
}


////////////////////////////////////////////////////////////////
// ե졼졼
////////////////////////////////////////////////////////////////
BOOL cPC60::SetFPS( int fps )
{
	// ޡưʤ
	if( UpDateID )    SDL_RemoveTimer( UpDateID );
	if( UpDateFPSID ) SDL_RemoveTimer( UpDateFPSID );
	
	// ޡ
	UpDateID    = SDL_AddTimer( 1000/fps, cPC60::UpDate,    this );
	UpDateFPSID = SDL_AddTimer( 1000,     cPC60::UpDateFPS, this );
	
	return ( UpDateID && UpDateFPSID ) ? TRUE : FALSE;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cPC60::DokoDemoSave( char *filename )
{
	cIni *Ini = NULL;
	
	// Ȥꤢ顼
	Error::SetError( Error::DokoWriteFailed );
	try{
		FILE *fp = fopen( cGlobal::GetDokodemoName(), "wt" );
		if( !fp ) throw Error::DokoWriteFailed;
		// ȥԤ
		fprintf( fp, MSDOKO_TITLE );
		fclose( fp );
		
		// ɤǤSAVEե򳫤
		Ini = new cIni();
		if( !Ini->Init( cGlobal::GetDokodemoName() ) ) throw Error::DokoWriteFailed;
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		if( Ini ) delete Ini;
		return FALSE;
	}
	
	cGlobal::DokoSave( Ini );
	psg->DokoSave( Ini );
	if( cGlobal::FddNum ) disk->DokoSave( Ini );
	graph->DokoSave( Ini );
	intr->DokoSave( Ini );
	key->DokoSave( Ini );
	subcpu->DokoSave( Ini );
	ppt->DokoSave( Ini );
	tick->DokoSave( Ini );
	cpu->DokoSave( Ini );
	mem->DokoSave( Ini );
	cmt->DokoSave( Ini );
	
	
	Ini->Write();
	
	delete Ini;
	
	// ̵äΤǥ顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cPC60::DokoDemoLoad( char *filename )
{
	cIni *Ini = NULL;
	
	// Ȥꤢ顼
	Error::SetError( Error::DokoReadFailed );
	try{
		// ɤǤLOADե򳫤
		Ini = new cIni();
		if( !Ini->Init( cGlobal::GetDokodemoName() ) ) throw Error::DokoReadFailed;
		
		if( !cGlobal::DokoLoad( Ini ) ) throw Error::GetError();
	
	}
	catch( std::bad_alloc ){	// new ˼Ԥ
		Error::SetError( Error::MemAllocFailed );
		return FALSE;
	}
	catch( Error::Errno i ){	// 㳰ȯ
		Error::SetError( i );
		if( Ini ) delete Ini;
		return FALSE;
	}
	
	psg->DokoLoad( Ini );
	if( cGlobal::FddNum ) disk->DokoLoad( Ini );
	graph->DokoLoad( Ini );
	intr->DokoLoad( Ini );
	key->DokoLoad( Ini );
	subcpu->DokoLoad( Ini );
	ppt->DokoLoad( Ini );
	tick->DokoLoad( Ini );
	cpu->DokoLoad( Ini );
	mem->DokoLoad( Ini );
	cmt->DokoLoad( Ini );
	
	
	
	delete Ini;
	
	// ̵äΤǥ顼ʤ
	Error::SetError( Error::NoError );
	
	return TRUE;
}
