#ifndef PC60_H_INCLUDED
#define PC60_H_INCLUDED

#include "pc6001v.h"
#include "ay8910.h"
#include "debug.h"
#include "disk.h"
#include "global.h"
#include "graph.h"
#include "intr.h"
#include "io.h"
#include "keyboard.h"
#include "memory.h"
#include "osdwin.h"
#include "pd8049.h"
#include "pd8255.h"
#include "sound.h"
#include "SThread.h"
#include "tape.h"
#include "ticker.h"
#include "voice.h"
#include "win.h"
#include "z80.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cPC60 : virtual public cGlobal, public SThread {
protected:
	BOOL Ready;					// λե饰
	
	SDL_TimerID UpDateID;		// ޡID
	SDL_TimerID UpDateFPSID;	// ޡID
	
	// ֥ȥݥ
	cP6z80 *cpu;				// CPU
	cP6D8049 *subcpu;			// SUB CPU
	cP6io *io;					// I/O
	cP6memory *mem;				// 
	cP6draw *graph;				// 
	cP6intr *intr;				// 
	cP6key *key;				// 
	cdisk *disk;				// DISK
	cP6tape	*cmt;				// CMT
	cP6csave *cmts;				// CMT(SAVE)
	cSound *snd;				// 
	cP6psg *psg;				// PSG
	cP6D8255 *ppt;				// 8255
	cP6sche *tick;				// 塼
	cP6voice *voice;			// 
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	cWndReg *regw;				// 쥸ɥ
	cWndMem *memw;				// ꥦɥ
	cWndMon *monw;				// ˥ɥ
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	static void SoundUpdate( void *, Uint8 *, int);	// ɹ Хåؿ
	static Uint32 UpDate( Uint32, void * );			// ̹ޡ Хåؿ
	static Uint32 UpDateFPS( Uint32, void * );		// FPSޡ Хåؿ
	
	int UDCount;				// ̹ޡ
	int UDFPSCount;				// FPSޡ
	
	void OnThread( void * );	// åɴؿ
	
public:
	cPC60();					// 󥹥ȥ饯
	virtual ~cPC60();			// ǥȥ饯
	
	virtual BOOL Init();		// 
	
	BOOL Start();				// ư
	void Stop();				// 
	void Reset();				// ꥻå
	
	int Emu( void );			// 1̿¹
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	void Exec( int );			// ꥹơȿ¹
	void ExecBP( int );			// ꥹơȿ¹(֥졼ݥȤ)
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	BOOL TapeInsert( char * );		// TAPE 
	void TapeEject();				// TAPE ӽ
	BOOL DiskInsert( int, char * );	// DISK 
	void DiskEject( int );			// DISK ӽ
	BOOL ExtRomInsert( char * );	// ĥROM 
	void ExtRomEject();				// ĥROM ӽ
	
	BOOL EventLoop();				// ٥ȥ롼
	
	BOOL IsReady(){ return Ready; }	// λ?
	
	BOOL SetFPS( int );				// ե졼졼
	
	
	// ------------------------------------------
	BOOL DokoDemoSave( char * );	// ɤǤSAVE
	BOOL DokoDemoLoad( char * );	// ɤǤLOAD
	// ------------------------------------------
};

class cPC62 : public cPC60 {
protected:
	// ֥ȥݥ
	cP6voice *voice;			// 
	
public:
	cPC62();					// 󥹥ȥ饯
	~cPC62();					// ǥȥ饯
	
	BOOL Init();				// 
};

class cPC66 : public cPC62 {
public:
	cPC66();					// 󥹥ȥ饯
	~cPC66();					// ǥȥ饯
	
	BOOL Init();				// 
};

#endif		// PC60_H_INCLUDED
