#include "pd8049.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6D8049::cP6D8049( const ID& id ) : Device(id)
{
	PRINTD( CONST_LOG, "cP6D8049\n" );
	
	Reset();
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6D8049::~cP6D8049()
{
	PRINTD( CONST_LOG, "~cP6D8049\n" );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6D8049::Init( cP6intr *intr, cP6tape *cmt, cP6csave *cmts )
{
	// ֥ȤؤΥݥ󥿤¸
	lpcP6intr = intr;
	lpP6tape  = cmt;
	lpP6csave = cmts;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void cP6D8049::Reset( void )
{
	Relay = FALSE;
	cGlobal::SetCmtStatus( CMTCLOSE );
	CmtStatus = CMTCLOSE;
	KeyJoyStat = 0;
}


////////////////////////////////////////////////////////////////
// uPD8049 ߥ졼Ƚ
// :CMT׵
////////////////////////////////////////////////////////////////
void cP6D8049::Exec( BOOL cmtreq )
{
	// CMT å
	if( cmtreq ) CmtIntr();
}


////////////////////////////////////////////////////////////////
// ϥɥ
////////////////////////////////////////////////////////////////
BYTE cP6D8049::HandShake( BYTE data )
{
	BYTE res;
	
	res = data;
	
	// bitб
	switch( (data>>1)&0x07 ){
	case 4: // 8049
		if( data&1 )	// λ(?)
			res &= 0xf7;	// bit3 ꥻå
		else			// Ŀ
			res |= 0x88;	// bit3,7 å(*** 8049α? ***)
		break;
	
	case 6: // 8049
		if( data&1 )	// λ(?)
			res &= 0xf7;	// bit3 ꥻå
		else			// Ŀ
			res |= 0x28;	// bit3,5 å(*** 8049α? ***)
		break;
	}
	
	res |= 0xa8;	// bit3,5,7 å(*** 8049α? ***)
	
	return res;
}


////////////////////////////////////////////////////////////////
// ޥɽ
////////////////////////////////////////////////////////////////
void cP6D8049::Command( BYTE comm )
{
	static BOOL CmtPut = FALSE;
	
	// CMT 1ʸ
	if( CmtPut ){
		lpP6csave->CmtWrite( comm );
		CmtPut = FALSE;
		return;
	}
	
	switch( comm ){
	case 0x0c:	// ------ RS-232C ----------
	case 0x2c:
		break;
		
	case 0x06:	// ------ STICK,STRIG ----------
		lpcP6intr->SetJoyIntr( KeyJoyStat );	// ѥȯ
		break;
		
	case 0x19:	// ------ CMT(LOAD) OPEN ----------
		cGlobal::SetCmtStatus( LOADOPEN );
		CmtStatus = LOADOPEN;
		break;
		
	case 0x1a:	// ------ CMT(LOAD) CLOSE ----------
		cGlobal::SetCmtStatus( CMTCLOSE );
		CmtStatus = CMTCLOSE;
		break;
		
	case 0x1d:	// ------ CMT(LOAD) 600ܡ ----------
//		set_cmt_intr( 600 );
		break;
		
	case 0x1e:	// ------ CMT(LOAD) 1200ܡ ----------
//		set_cmt_intr( 1200 );
		break;
		
	case 0x38:	// ------ CMT 1ʸ ----------
		CmtPut = TRUE;
		break;
		
	case 0x39:	// ------ CMT(SAVE) OPEN ----------
		cGlobal::SetCmtStatus( SAVEOPEN );
		CmtStatus = SAVEOPEN;
//		lpP6csave->Mount( cGlobal::GetSaveFile() );
		break;
		
	case 0x3a:	// ------ CMT(SAVE) CLOSE ----------
		cGlobal::SetCmtStatus( CMTCLOSE );
		CmtStatus = CMTCLOSE;
		lpP6csave->Unmount();
		break;
		
	case 0x3d:	// ------ CMT(SAVE) 600ܡ ----------
		lpP6csave->SetBaud( 600 );
		break;
		
	case 0x3e:	// ------ CMT(SAVE) 1200ܡ ----------
		lpP6csave->SetBaud( 1200 );
		break;
	}
}


////////////////////////////////////////////////////////////////
// ׵
////////////////////////////////////////////////////////////////
void cP6D8049::SetKeyIntr( int flag, BYTE data )
{
	// flag
	// bit 0 : ON_STOP
	// bit 1 : ON_GRAPH
	// bit 2 : ON_FUNC
	
	if( flag&1 ){	// STOP ?
		// CMT OPEN ?
		if( CmtStatus ) lpcP6intr->SetKeyIntr( 1, 0x03 );
		else            lpcP6intr->SetKeyIntr( 2, 0xfa );
	}else{			// STOPʳ
		// GRAPH or FUNCTION KEY ?
		if( flag&6 )                 lpcP6intr->SetKeyIntr( 2, data );
		else                         lpcP6intr->SetKeyIntr( 3, data );
	}
}


////////////////////////////////////////////////////////////////
// CMT(LOAD)ȯ
////////////////////////////////////////////////////////////////
void cP6D8049::CmtIntr( void )
{
	PRINTD( SUB_LOG, "[8049][CmtIntr]\n" );
	
	// 졼ON & CMT LOADOPEN ?
	if( Relay && ( CmtStatus == LOADOPEN ) ){
		if( lpcP6intr->IsCmtIntrReady() ){
			// CMTåץǡ
			WORD rd = lpP6tape->Update();
			// ǡʤCMTȯ
			if( (rd & 0xff00) == PG_D ) lpcP6intr->SetCmtIntr( rd & 0xff );
		}
	}else{
		// ȥȽ
		// CMTߤȥߤƱȯʤ褦
		BYTE key;
		if( (key = lpP6tape->GetAutoKey( Relay )) )
			lpcP6intr->SetKeyIntr( 3, key );
	}
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6D8049::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
//	Ini->PutEntry( "8049", NULL, "KeyJoyStat",	"0x%02X",	KeyJoyStat );
	Ini->PutEntry( "8049", NULL, "Relay",		"%s",		Relay ? "Yes" : "No" );
	Ini->PutEntry( "8049", NULL, "CmtStatus",	"%d",		CmtStatus );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6D8049::DokoLoad( cIni *Ini )
{
//	int st;
	
	if( !Ini ) return FALSE;
	
//	Ini->GetInt(   "8049", "KeyJoyStat",	&st,		KeyJoyStat );	KeyJoyStat = st;
	Ini->GetTruth( "8049", "Relay",			&Relay,		Relay );
	Ini->GetInt(   "8049", "CmtStatus",		&CmtStatus,	CmtStatus );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor cP6D8049::descriptor = {
	cP6D8049::indef, cP6D8049::outdef
};

const Device::OutFuncPtr cP6D8049::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP6D8049::OutB0H )
};

const Device::InFuncPtr cP6D8049::indef[] = {
};
