#ifndef PD8049_H_INCLUDED
#define PD8049_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "global.h"
#include "ini.h"
#include "intr.h"
#include "tape.h"

////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cP6D8049 : public Device, public IDoko {
private:
	cP6intr *lpcP6intr;		// ߽֥ȤؤΥݥ
	cP6tape *lpP6tape;		// CMT֥ȤؤΥݥ
	cP6csave *lpP6csave;	// CMT(SAVE)֥ȤؤΥݥ
	
	BYTE KeyJoyStat;		// 륭
	BOOL Relay;				// CMT졼ξ
	int CmtStatus;			// CMT OPEN ơ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutB0H( DWORD, BYTE data ){ Relay = data&0x08 ? TRUE : FALSE;
										    PRINTD1( SUB_LOG, "[8049][Relay] -> %s\n", Relay ? "TRUE" : "FALSE" );
										  }
	
public:
	cP6D8049( const ID& id );		// 󥹥ȥ饯
	~cP6D8049();					// ǥȥ饯
	
	BOOL Init( cP6intr *, cP6tape *, cP6csave * );	// 
	void Reset();					// ꥻå
	
	void Exec( BOOL );				// 1̿¹
	
	void SetKeyIntr( int, BYTE );	// ׵
	void CmtIntr();					// CMT(LOAD)ȯ
	
	void SetKeyJoy( BYTE data ){ KeyJoyStat = data; }	// 륭
	
	int GetCmtStatus(){ return CmtStatus; }	// CMT OPEN ơ
	
	// 8255ϴϢؿ
	void Command( BYTE );			// ޥɽ
	BYTE HandShake( BYTE );			// Out93H
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ outB0H=0 };
	// INǥХID
	enum IDIn{};
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// PD8049_H_INCLUDED
