#include "pd8255.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
c8255::c8255()
{
	Reset();
}

cP6D8255::cP6D8255( const ID& id ) : Device(id){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
c8255::~c8255(){}

cP6D8255::~cP6D8255(){}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void c8255::Reset( void )
{
	// н
	PortA = PortB = PortC = 0xff;
	PortAdir = PortBdir = PortC1dir = PortC2dir = FALSE;
}


////////////////////////////////////////////////////////////////
// ⡼
////////////////////////////////////////////////////////////////
void c8255::SetMode( BYTE data )
{
	PortAdir  = (data>>4)&1 ? TRUE : FALSE;
	PortC2dir = (data>>3)&1 ? TRUE : FALSE;
	PortBdir  = (data>>1)&1 ? TRUE : FALSE;
	PortC1dir = (data   )&1 ? TRUE : FALSE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6D8255::Init( cP6D8049 *subcpu, cP6intr *intr, cP6draw *graph )
{
	// ֥ȤؤΥݥ󥿤¸
	lpcP6D8049  = subcpu;
	lpcP6intr   = intr;
	lpcP6draw   = graph;
	
	c8255::Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// PartA 饤(8049ؤΥޥ)
////////////////////////////////////////////////////////////////
void cP6D8255::WriteA( BYTE data )
{
	if( !PortAdir ){
		PortA = data;
		lpcP6D8049->Command( data );
	}
}


////////////////////////////////////////////////////////////////
// PartC 饤
////////////////////////////////////////////////////////////////
void cP6D8255::WriteC( BYTE data )
{
	if( !PortC1dir ){
		 PortC = ( PortC & 0xf0 ) | ( data & 0x0f );
		// CRTɽ
		lpcP6draw->SetCrtDisp( data&2 ? TRUE : FALSE );
		// ץ󥿥ȥ
		
	}
	if( !PortC2dir ) PortC = ( PortC & 0x0f ) | ( data & 0xf0 );
}


////////////////////////////////////////////////////////////////
// ȥݡȥ饤
////////////////////////////////////////////////////////////////
void c8255::WriteD( BYTE data )
{
	if( data&0x80 ){	// Ǿ̥ӥåȤ1ʤ
		// ⡼
		c8255::SetMode( data );
	}else{				// Ǿ̥ӥåȤ0ʤ
		// ӥåȥå/ꥻå(λ⡼ɤͭ?Ȥꤢ̵)
		if( data&1 ) PortC |= 1<<((data>>1)&0x07);
		else         PortC &= ~(1<<((data>>1)&0x07));
	}
}

void cP6D8255::WriteD( BYTE data )
{
	if( data&0x80 ){	// Ǿ̥ӥåȤ1ʤ
		// ⡼
		c8255::SetMode( data );
	}else{				// Ǿ̥ӥåȤ0ʤ
		// ӥåȥå/ꥻå(λ⡼ɤͭ?Ȥꤢ̵)
		if( data&1 ) PortC |= 1<<((data>>1)&0x07);
		else         PortC &= ~(1<<((data>>1)&0x07));
		
		// bitб
		switch( (data>>1)&0x07 ){
		case 7: // 8049
		case 6: // 8049
		case 5: // 8049
		case 4: // 8049
		case 3: // 8049
			PortC = lpcP6D8049->HandShake( PortC );
			break;
//		case 2: // CG ROM BANK
		case 1: // CRTɽ
			lpcP6draw->SetCrtDisp( data&1 ? TRUE : FALSE );
			break;
		case 0: // ץ󥿥ȥ
			break;
		}
	}
}


////////////////////////////////////////////////////////////////
// PortA ꡼
////////////////////////////////////////////////////////////////
BYTE cP6D8255::ReadA( void )
{
	// ߤˤߤȯƤͤ򥻥å
	PortA = lpcP6intr->GetIntrReserved( PortA );
	
	PRINTD1( PPI_LOG, "[8255][Read][PortA] %02X\n", PortA );
	
	return PortA;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6D8255::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "8255", NULL, "PortA",		"0x%02X",	PortA );
	Ini->PutEntry( "8255", NULL, "PortB",		"0x%02X",	PortB );
	Ini->PutEntry( "8255", NULL, "PortC",		"0x%02X",	PortC );
	Ini->PutEntry( "8255", NULL, "PortAdir",	"%s",		PortAdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortBdir",	"%s",		PortBdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC1dir",	"%s",		PortC1dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC2dir",	"%s",		PortC2dir ? "Yes" : "No" );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6D8255::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "8255", "PortA",		&st,		PortA );	PortA = st;
	Ini->GetInt(   "8255", "PortB",		&st,		PortB );	PortB = st;
	Ini->GetInt(   "8255", "PortC",		&st,		PortC );	PortC = st;
	Ini->GetTruth( "8255", "PortAdir",	&PortAdir,	PortAdir );
	Ini->GetTruth( "8255", "PortBdir",	&PortBdir,	PortBdir );
	Ini->GetTruth( "8255", "PortC1dir",	&PortC1dir,	PortC1dir );
	Ini->GetTruth( "8255", "PortC2dir",	&PortC2dir,	PortC2dir );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor cP6D8255::descriptor = {
	cP6D8255::indef, cP6D8255::outdef
};

const Device::OutFuncPtr cP6D8255::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP6D8255::Out90H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6D8255::Out91H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6D8255::Out92H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6D8255::Out93H )
};

const Device::InFuncPtr cP6D8255::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &cP6D8255::In90H ),
	STATIC_CAST( Device::InFuncPtr, &cP6D8255::In92H ),
	STATIC_CAST( Device::InFuncPtr, &cP6D8255::In93H )
};
