#ifndef PD8255_H_INCLUDED
#define PD8255_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "graph.h"
#include "intr.h"
#include "pd8049.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class c8255 {
protected:
	BYTE PortA;						// ݡA
	BYTE PortB;						// ݡB
	BYTE PortC;						// ݡC
	
	BOOL PortAdir;					// ݡA (TRUE:(ɤ) FALSE:())
	BOOL PortBdir;					// ݡB (TRUE:(ɤ) FALSE:())
	BOOL PortC1dir;					// ݡC(bit0-3) (TRUE:(ɤ) FALSE:())
	BOOL PortC2dir;					// ݡC(bit4-7) (TRUE:(ɤ) FALSE:())
	
	// ϴؿ
	virtual void WriteA( BYTE data){ if( !PortAdir ) PortA = data; }
	virtual void WriteB( BYTE data){ if( !PortBdir ) PortB = data; }
	virtual void WriteC( BYTE data){ if( !PortC1dir ) PortC = ( PortC & 0xf0 ) | ( data & 0x0f );
									 if( !PortC2dir ) PortC = ( PortC & 0x0f ) | ( data & 0xf0 ); }
	virtual BYTE ReadA(){ return PortA; };
	virtual BYTE ReadB(){ return PortB; };
	virtual BYTE ReadC(){ return PortC; };
	
	virtual void WriteD( BYTE );	// ȥݡȽ
	void SetMode( BYTE );			// ⡼
	
public:
	c8255();						// 󥹥ȥ饯
	virtual ~c8255();				// ǥȥ饯
	
	void Reset();					// ꥻå
};


class cP6D8255 : public c8255, public Device, public IDoko {
private:
	cP6D8049 *lpcP6D8049;	// SUB CPU֥ȤؤΥݥ
	cP6intr *lpcP6intr;		// ߽֥ȤؤΥݥ
	cP6draw *lpcP6draw;		// 襪֥ȤؤΥݥ
	
	// ϴؿ
	void WriteA( BYTE );
	void WriteC( BYTE );
	BYTE ReadA();
	
	void WriteD( BYTE );	// ȥݡȽ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void Out90H( DWORD, BYTE data ){ WriteA( data ); };
	inline void Out91H( DWORD, BYTE data ){ WriteB( data ); };
	inline void Out92H( DWORD, BYTE data ){ WriteC( data ); };
	inline void Out93H( DWORD, BYTE data ){ WriteD( data ); };
	inline BYTE In90H( DWORD ){ return ReadA(); };
	inline BYTE In92H( DWORD ){ return ReadC(); };
	inline BYTE In93H( DWORD ){ return 0xff; };
	
public:
	cP6D8255( const ID& id );	// 󥹥ȥ饯
	~cP6D8255();				// ǥȥ饯
	
	BOOL Init( cP6D8049 *, cP6intr *, cP6draw * );	// 
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ out90H=0, out91H, out92H, out93H };
	// INǥХID
	enum IDIn{ in90H=0, in92H, in93H };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// PD8255_H_INCLUDED
