#include "pngimg.h"

// 󻲾ȡPNGѽѡ http://www5.cds.ne.jp/~kato/png/


////////////////////////////////////////////////////////////////
// PNG SAVE
////////////////////////////////////////////////////////////////
void SavePng( char *filename, SDL_Surface *sur )
{
	PRINTD1( GRP_LOG, "[GRP][SavePng] -> %s\n", filename );
	
	FILE *fp;
	png_structp PngPtr;
	png_infop InfoPtr;
	png_bytepp image;	// image[HEIGHT][WIDTH]η
	png_colorp Palette;
	
	// PngPtr¤Τݡ
	PngPtr  = png_create_write_struct( PNG_LIBPNG_VER_STRING, NULL, NULL, NULL );
	
	// InfoPtr¤Τݡ
	InfoPtr = png_create_info_struct( PngPtr );
	
	// ե륿
	png_set_filter( PngPtr, 0, PNG_ALL_FILTERS );
	
	// Ψ
	png_set_compression_level( PngPtr, Z_BEST_COMPRESSION );
	
	// IHDR󥯾ꤹ
	png_set_IHDR( PngPtr, InfoPtr, sur->w, sur->h, 8, PNG_COLOR_TYPE_PALETTE, PNG_INTERLACE_NONE,
					PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
	
	// ᡼ǡ2֤
	image = new png_bytep[sur->h];
	if( SDL_MUSTLOCK( sur ) ) SDL_LockSurface( sur );
	Uint8 *doff = (Uint8 *)sur->pixels;
	for( int i=0; i<(int)sur->h; i++ ){
		image[i] = new png_byte[sur->w];
		memcpy( image[i], doff, sur->w );
		doff += sur->w;
	}
	if( SDL_MUSTLOCK( sur ) ) SDL_UnlockSurface( sur );
	
	// ѥåȤ
	Palette = ( png_colorp )png_malloc( PngPtr, sur->format->palette->ncolors * sizeof (png_color) );
	// եѥåȤ
	for( int i=0; i<sur->format->palette->ncolors; i++ ){
		Palette[i].red   = sur->format->palette->colors[i].r;
		Palette[i].green = sur->format->palette->colors[i].g;
		Palette[i].blue  = sur->format->palette->colors[i].b;
	}
	png_set_PLTE( PngPtr, InfoPtr, Palette, sur->format->palette->ncolors );
	
	// ե򳫤
	fp = fopen( filename, "wb" );
	
	// libpngfpΤ餻
	png_init_io( PngPtr, fp );
	
	// PNGեΥإå񤭹
	png_write_info( PngPtr, InfoPtr );
	// ǡ񤭹
	png_write_image( PngPtr, image );
	// Ĥξ񤭹
	png_write_end( PngPtr, InfoPtr );
	
	// եĤ
	fclose( fp );
	
	// ѥåȤ
	png_free( PngPtr, Palette );
	
	// ᡼ǡ
	for( int i=0; i<(int)sur->h; i++ ) delete [] image[i];
	delete [] image;
	
	// 2Ĥι¤ΤΥ
	png_destroy_write_struct( &PngPtr, &InfoPtr );
}


/*
////////////////////////////////////////////////////////////////
// PNG LOAD
////////////////////////////////////////////////////////////////
SDL_Surface *LoadPng( char *filename )
{
	PRINTD1( GRP_LOG, "[GRP][LoadPng] <- %s\n", filename );
	
	FILE *fp;
	png_structp PngPtr;
	png_infop InfoPtr;
	png_uint_32 width, height;
	int BitDepth, ColorType, InterlaceType;
	png_bytepp image;	// image[HEIGHT][WIDTH]η
	png_colorp Palette;
	int PaletteCount = 0;
	
	SDL_Surface *sur = NULL;
	SDL_Color PaletteS[256];
	
	// PngPtr¤Τݡ
	PngPtr  = png_create_read_struct( PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	
	// InfoPtr¤Τݡ
	InfoPtr = png_create_info_struct( PngPtr );
	
	// ե򳫤
	fp = fopen( filename, "rb" );
	
	// libpngfpΤ餻
	png_init_io( PngPtr, fp );
	
	// إåɹ
	png_read_info( PngPtr, InfoPtr );
	
	// IHDR󥯾
	png_get_IHDR( PngPtr, InfoPtr, &width, &height, &BitDepth, &ColorType, &InterlaceType, NULL, NULL );
	
	// 2ݤ
	image = new png_bytep[height*sizeof( png_bytep )];
	for( int i=0; i<(int)height; i++ ) image[i] = new png_byte[png_get_rowbytes( PngPtr, InfoPtr )];
	
	// ǡɹ
	png_read_image( PngPtr, image );
	
	// եĤ
	fclose( fp );
	
	
	if( BitDepth == 8 ){	// 8bit顼
		// ե
		sur = SDL_CreateRGBSurface( SDL_SWSURFACE, width, height, 8, 0, 0, 0, 0 );
		
		// ǡ
		if( SDL_MUSTLOCK( sur ) ) SDL_LockSurface( sur );
		Uint8 *doff = (Uint8 *)sur->pixels;
		for( int i=0; i<(int)sur->h; i++ ){
			memcpy( doff, image[i], sur->w );
			doff += sur->w;
		}
		if( SDL_MUSTLOCK( sur ) ) SDL_UnlockSurface( sur );
		
		// ѥåȤ
		png_get_PLTE( PngPtr, InfoPtr, &Palette, &PaletteCount );
		for( int i=0; i<PaletteCount; i++ ){
			PaletteS[i].r = Palette[i].red;
			PaletteS[i].g = Palette[i].green;
			PaletteS[i].b = Palette[i].blue;
		}
		SDL_SetColors( sur, PaletteS, 0, PaletteCount );
	}
	
	
	// ᡼ǡ
	for( int i=0; i<(int)height; i++ ) delete [] image[i];
	delete [] image;
	
	// 2Ĥι¤ΤΥ
	png_destroy_read_struct( &PngPtr, &InfoPtr, (png_infopp)NULL );
	
	return sur;
}
*/
