#include "sound.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cRing::cRing()
{
	Buffer = NULL;
	Size = Wpt = Rpt = Num = 0;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cRing::~cRing()
{
	if( Buffer ) delete[] Buffer;
}


////////////////////////////////////////////////////////////////
// 
// size:ץ
////////////////////////////////////////////////////////////////
BOOL cRing::Init( int size )
{
	PRINTD1( SND_LOG, "[cRing][Init] Size:%d\n", size*sizeof(Sint16) );
	
	if( Buffer ) delete[] Buffer;
	
	Buffer = new Sint16[size*sizeof(Sint16)*MULTI];
	if( !Buffer ) return FALSE;
	
	Size = size*MULTI;
	Wpt = Rpt = Num = 0;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɹ
////////////////////////////////////////////////////////////////
Sint16 cRing::Read( void )
{
	if( Num ){
		SCritical::Lock();
		Sint16 data = Buffer[Rpt++];
		if( Rpt == Size ) Rpt = 0;
		Num--;
		SCritical::UnLock();
		return data;
	}else
		return 0;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cRing::Write( Sint16 data )
{
	if( Num < Size/MULTI ){
		SCritical::Lock();
		Buffer[Wpt++] = data;
		if( Wpt == Size ) Wpt = 0;
		Num++;
		SCritical::UnLock();
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cSound::cSound()
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cSound::~cSound()
{
	Pause();
	// ǥǥХĤ
	SDL_CloseAudio();
}



////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cSound::Init( void *p6, void (*callback)(void *, Uint8 *, int ), int rate, int size )
{
	PRINTD( SND_LOG, "[cSound][Init]\n" );
	
	ASpec.freq     = rate;							// ץ󥰥졼
	ASpec.format   = AUDIO_S16;						// 16ӥå椢
	ASpec.channels = 1;								// Υ
	ASpec.samples  = ( ASpec.freq * size )/1000;	// Хåե(ץ)
	ASpec.callback = callback;						// Хåؿλ
	ASpec.userdata = p6;							// Хåؿ˼ʬȤΥ֥ȥݥ󥿤Ϥ
	
	PRINTD1( SND_LOG, " SampleRate : %d\n", ASpec.freq );
	PRINTD1( SND_LOG, " Format     : 0x%04X\n", ASpec.format );
	PRINTD1( SND_LOG, " Channels   : %d\n", ASpec.channels );
	PRINTD1( SND_LOG, " Samples    : %d\n", ASpec.samples );
	
	for( int i=0; i<MAXSTREAM; i++ ) RB[i] = NULL;
	
	Volume = DEFAULT_MASTERVOL;
	
	// ǥǥХ򳫤
	if( SDL_OpenAudio( &ASpec, NULL ) < 0 ) return FALSE;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɹؿ
// len:Хñ
////////////////////////////////////////////////////////////////
void cSound::Update( Uint8 *stream, int len )
{
	#if SND_LOG
		fprintf( stdout, "[cSound][Update] Stream:%08X Len:%d\n", (int)stream, len/sizeof(Sint16) );
		{ for( int i=0; i<MAXSTREAM; i++ ) if( RB[i] ) fprintf( stdout, "  [%d] Len:%d\n", i, RB[i]->ReadySize() ); }
	#endif
	
	Sint16 *str = (Sint16 *)stream;
	int samples = len/sizeof(Sint16);
	
//	Uint16 dat;
	while( samples-- ){
//		dat = 0;
		Sint32 dat = 0;
		for( int i=0; i<MAXSTREAM; i++ ){
			if( RB[i] ){
//				dat += RB[i]->Read()/MAXSTREAM;
				dat += RB[i]->Read();
			}
		}
		dat = ( dat * Volume ) / 100;
		dat = min( max( dat, (Sint32)-32768 ), (Sint32)32767 );
		*(str++) = (Sint16)dat;
	}
	#if SND_LOG
		{ for( int i=0; i<MAXSTREAM; i++ ) if( RB[i] ) fprintf( stdout, "  [%d] Len:%d\n", i, RB[i]->ReadySize() ); }
	#endif
}


////////////////////////////////////////////////////////////////
// ȥ꡼ɲ
////////////////////////////////////////////////////////////////
cRing *cSound::AddStream( void )
{
	PRINTD( SND_LOG, "[cSound][AddStream]\n" );
	
	int i;
	
	for( i=0; i<MAXSTREAM; i++ ){
		if( !RB[i] ){
			RB[i] = new cRing;
			// Хåեϥץ
			if( !RB[i]->Init( ASpec.samples ) ){
				delete RB[i];
				RB[i] = NULL;
				return RB[i];
			}
			break;
		}
	}
	
	if( i == MAXSTREAM ) return NULL;
	else                 return RB[i];
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cSound::Play( void )
{
	PRINTD( SND_LOG, "[cSound][Play]\n" );
	
	SDL_PauseAudio( 0 );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cSound::Pause( void )
{
	PRINTD( SND_LOG, "[cSound][Pause]\n" );
	
	SDL_PauseAudio( 1 );
}


////////////////////////////////////////////////////////////////
// ޥ
////////////////////////////////////////////////////////////////
void cSound::SetVolume( int vol )
{
	Volume = min( max( vol, 0 ), 100 );
}
