#include "ticker.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6sche::cP6sche( void )
{
	PRINTD( CONST_LOG, "cP6sche\n" );
	
	// ޥե
	Z80Sem = SDL_CreateSemaphore( 0 );
	
	CpuClock = DEFAULT_CPU_CLOCK;
	CrtDisp  = TRUE;
	N60Win   = TRUE;
	
/////////////////////////////////////////////////
	SoundBuffer = SOUND_BUFFER_SIZE;
	Z80PsgState = 0;
	PsgState    = 0;
/////////////////////////////////////////////////

}

cP60sche::cP60sche( const ID& id ) : Device(id)
{
}

cP62sche::cP62sche( const ID& id ) : Device(id)
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6sche::~cP6sche()
{
	PRINTD( CONST_LOG, "~cP6sche\n" );
	
	// ư
	Stop();
	
	// ޥե
	if( Z80Sem ) SDL_DestroySemaphore( Z80Sem );
}

cP60sche::~cP60sche()
{
}

cP62sche::~cP62sche()
{
}


////////////////////////////////////////////////////////////////
// åɴؿ(С饤)
// SDL_Delay()٤˺ΤǤäø
// 49.7ʾϢ³ưOSǤԶ礬뤱ɡǤ
////////////////////////////////////////////////////////////////
void cP6sche::OnThread( void *inst )
{
	cP6sche *ti;
	int timecnt = 0; // ٥ȯΨ¬
	double now,last;
	
	ti = (cP6sche *)inst;	// ʬȤΥ֥ȥݥ󥿼
	
	// ǽԤ֤
	double NextZ80 = SDL_GetTicks() + (double)1000/DEFAULT_Z80_HZ;
	now = (double)SDL_GetTicks();
	last = now;
	
	while( !this->SThread::IsCancel() ){
		now = (double)SDL_GetTicks();
		if( now >= NextZ80 ){
			NextZ80 += (double)1000/DEFAULT_Z80_HZ;
			SDL_SemPost( Z80Sem );
		}else
			SDL_Delay( 1 );
		
		timecnt += (int)(now - last);
		if( timecnt > 1000 ){
			timecnt -= 1000;
			for( int i=0; i<EndofTR; i++ ){
				ev[i].ratio  = ( ev[i].ncount * 100 ) / ev[i].nps;
				ev[i].ncount = 0;
			}
		}
		last = now;
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6sche::Init( int size )
{
	// ޥեå
	if( !Z80Sem ) return FALSE;
	
/////////////////////////////////////////////////
	SoundBuffer = size;
/////////////////////////////////////////////////
	
	// ơȿ
	SetState( CrtDisp, N60Win );
	
	// ٥Ⱦ
	for( int i=0; i<EndofTR; i++ ){
		ev[i].TrState = 0;
		ev[i].State   = 0;
		ev[i].TrReq   = FALSE;
		ev[i].nps     = 0;
		ev[i].ncount  = 0;
		ev[i].ratio   = 0;
	}
	
//	NextState = 0;
	
	return TRUE;
}

BOOL cP62sche::Init( int size )
{
	io_F6H = 3;
	return cP6sche::Init( size );
}

////////////////////////////////////////////////////////////////
// ư
////////////////////////////////////////////////////////////////
BOOL cP6sche::Start( void )
{
	// å
	if( !this->SThread::BeginThread( this ) ) return FALSE;
	this->SThread::Start();
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ư
////////////////////////////////////////////////////////////////
void cP6sche::Stop( void )
{
	this->SThread::Cancel();	// åɽλե饰ΩƤ
	this->SThread::Waiting();	// åɽλޤԤ
}


////////////////////////////////////////////////////////////////
// Z80 Wait
////////////////////////////////////////////////////////////////
void cP6sche::WaitZ80( BOOL enable )
{
	if( ev[TRSYNC].TrReq ){
		ev[TRSYNC].TrReq = FALSE;
		if( enable ) SDL_SemWait( Z80Sem );
	}
}


////////////////////////////////////////////////////////////////
// CPUơȿ
////////////////////////////////////////////////////////////////
// PC-6001mk2SRΥޥ˥奢뤫 (ʤSR? ޤ޼긵ˤ줷ʤä)
// ʿߥ (ñ:usec)
// ɽ⡼ ʿ Хåݡ ɽ եȥݡ
// 32ʸ		4.87	13.74		35.76		9.33
// 40,80ʸ	4.87	 9.27		44.69		4.86

// ľߥ (ñ:msec)
// ɽ⡼ ľ Хåݡ ɽ եȥݡ
// 192H			0.25	 2.49		12.23		1.72
// 200H			0.25	 2.23		12.74		1.47
// 204H			0.25	 2.11		12.99		1.34

// ɽȿ
// ʿ 15.70kHz(63.70usec)
// ľ 59.92 Hz(16.69msec)

// ɽ֡פΤCPUߤȹͤȡƯΨϤʴ
// ºݤΤȤ ХåݡեȥݡäƤɤ衩
// N60  : 58.864%
#define Ref1	(double)( (0.25+2.49+1.72+(4.87+13.74+9.33)*192/1000)/16.69 )
// N60m : 46.435%
#define Ref2	(double)( (0.25+2.23+1.47+(4.87+ 9.27+4.86)*200/1000)/16.69 )
	
void cP60sche::SetState( BOOL disp, BOOL win )
{
	// 1secΥơȿ
	int CpuState;
	////////////////////////////////////////////////////////////////
	// ̩˷׻Ȥʤϥ
	// N60? (2350811)
	if( disp ) CpuState = (int)( Ref1 * CpuClock );
	else       CpuState = (int)CpuClock;
	////////////////////////////////////////////////////////////////
	// BUSREQ̵뤷ƤޤȤʴ
//	CpuState = 1734411;
	////////////////////////////////////////////////////////////////
	
	// ǽΥȥꥬ
//	TrgType tr = GetNextTrigger();
//	NextState = TrState[tr] - State[tr]
	
	// ƥȥꥬơȿ
	ev[TRSYNC].TrState  = CpuState / DEFAULT_Z80_HZ;
	ev[TRTIMER].TrState = CpuState / DEFAULT_TIMER_HZ;
	ev[TRCMT].TrState   = CpuState / DEFAULT_CMT_HZ;
	
/////////////////////////////////////////////////
	PsgState = ( CpuState * SoundBuffer ) / 1000;
/////////////////////////////////////////////////
	
	for( int i=0; i<EndofTR; i++ )
		ev[i].nps = CpuState / ev[i].TrState;
}

void cP62sche::SetState( BOOL disp, BOOL win )
{
	// 1secΥơȿ
	int CpuState;
	////////////////////////////////////////////////////////////////
	// ̩˷׻Ȥʤϥ
	// N60? (2350811)  N60m? (1854428)
	if( disp ) CpuState = (int)( (win ? Ref1 : Ref2) * CpuClock );
	else       CpuState = (int)CpuClock;
	////////////////////////////////////////////////////////////////
	// BUSREQ̵뤷ƤޤȤʴ
//	if( win ) CpuState = 1734411;	// N60?
//	else      CpuState = 1368192;	// N60m?
	////////////////////////////////////////////////////////////////
	
	// ǽΥȥꥬ
//	TrgType tr = GetNextTrigger();
//	NextState = TrState[tr] - State[tr]
	
	// TIMERߴॹơȿ
	int UTimerState = CpuState / UTIMER_HZ;
	
	// ƥȥꥬơȿ
	ev[TRSYNC].TrState  = CpuState / DEFAULT_Z80_HZ;
	ev[TRTIMER].TrState = UTimerState * ( io_F6H + 1 );
	ev[TRCMT].TrState   = CpuState / DEFAULT_CMT_HZ;
	
/////////////////////////////////////////////////
	PsgState = ( CpuState * SoundBuffer ) / 1000;
/////////////////////////////////////////////////
	
	for( int i=0; i<EndofTR; i++ )
		ev[i].nps = CpuState / ev[i].TrState;

}


////////////////////////////////////////////////////////////////
// CPUå
////////////////////////////////////////////////////////////////
void cP6sche::SetCpuClock( int clock )
{
	CpuClock = clock;
	SetState( CrtDisp, N60Win );
}


////////////////////////////////////////////////////////////////
// PSGץ
////////////////////////////////////////////////////////////////
int cP6sche::PsgUpdateSamples( int rate )
{
	int ret;
	int samples = rate * SoundBuffer / 1000;	// 1äΥץ
	
	ret = (int)( (double)samples * (double)Z80PsgState / (double)PsgState );
	Z80PsgState = 0;
	
	return ret;
}


////////////////////////////////////////////////////////////////
// ơȿȳȯ
////////////////////////////////////////////////////////////////
void cP6sche::IntrCtrl( int st )
{
	// CPUơȿ򸺻
	for( int i=0; i<EndofTR; i++ ) ev[i].State -= st;
	
/////////////////////////////////////////////////
// Թˤû
	Z80PsgState += st;
/////////////////////////////////////////////////
	
	// ȥꥬå
	for( int i=0; i<EndofTR; i++ ){
		if( ev[i].State <= 0 ){
			ev[i].State += ev[i].TrState;
			ev[i].TrReq = TRUE;	// ȥꥬON
			ev[i].ncount++;		// 䤹
		}
	}
}


////////////////////////////////////////////////////////////////
// ΥȥꥬΥפ
// (㥹Ȥ? enumλȤְäƤ?)
////////////////////////////////////////////////////////////////
//cP6sche::TrgType cP6sche::GetNextTrigger( void )
//{
//	int tr = 0;
//	int dif1 = (int)TrState[tr] - (int)State[tr];
//	
//	for( int i=tr+1; i<EndofTR; i++ ){
//		int dif2 = (int)TrState[i] - (int)State[i];
//		if( dif1 > dif2 ) tr = i;
//	}
//	return (TrgType)tr;
//}


////////////////////////////////////////////////////////////////
// ޳׵å
////////////////////////////////////////////////////////////////
BOOL cP6sche::IsTimerIntrReq( void )
{
	BOOL req = ev[TRTIMER].TrReq;
	ev[TRTIMER].TrReq = FALSE;
	return req;
}


////////////////////////////////////////////////////////////////
// CMT׵å
////////////////////////////////////////////////////////////////
BOOL cP6sche::IsCmtIntrReq( void )
{
	if( ev[TRCMT].TrReq ){
		ev[TRCMT].TrReq = FALSE;
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6sche::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "SCHEDULE", NULL, "CrtDisp",		"%s",	CrtDisp ? "Yes" : "No" );
	Ini->PutEntry( "SCHEDULE", NULL, "N60Win",		"%s",	N60Win ? "Yes" : "No" );
	Ini->PutEntry( "SCHEDULE", NULL, "CpuClock",	"%d",	CpuClock );
	
	for( int i=0; i<EndofTR; i++ ){
		char stren[16];
		sprintf( stren, "ev_%d_TrState", i );
		Ini->PutEntry( "SCHEDULE", NULL, stren,	"%d",	ev[i].TrState );
		sprintf( stren, "ev_%d_State", i );
		Ini->PutEntry( "SCHEDULE", NULL, stren,	"%d",	ev[i].State );
		sprintf( stren, "ev_%d_TrReq", i );
		Ini->PutEntry( "SCHEDULE", NULL, stren,	"%s",	ev[i].TrReq ? "Yes" : "No" );
	}
	
	return TRUE;
}

BOOL cP62sche::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "SCHEDULE", NULL, "io_F6H",	"%d",	io_F6H );
	
	return cP6sche::DokoSave( Ini );
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6sche::DokoLoad( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "SCHEDULE", "CrtDisp",	&CrtDisp,	CrtDisp );
	Ini->GetTruth( "SCHEDULE", "N60Win",	&N60Win,	N60Win );
	Ini->GetInt(   "SCHEDULE", "CpuClock",	&CpuClock,	CpuClock );
	
	for( int i=0; i<EndofTR; i++ ){
		char stren[16];
		sprintf( stren, "ev_%d_TrState", i );
		Ini->GetInt(   "SCHEDULE", stren,	&ev[i].TrState,	ev[i].TrState );
		sprintf( stren, "ev_%d_State", i );
		Ini->GetInt(   "SCHEDULE", stren,	&ev[i].State,	ev[i].State );
		sprintf( stren, "ev_%d_TrReq", i );
		Ini->GetTruth( "SCHEDULE", stren,	&ev[i].TrReq,	ev[i].TrReq );
	}
	
	return TRUE;
}

BOOL cP62sche::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt( "SCHEDULE", "io_F6H",	&st,	io_F6H );	io_F6H = st;
	
	return cP6sche::DokoLoad( Ini );
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor cP60sche::descriptor = {
	cP60sche::indef, cP60sche::outdef
};

const Device::OutFuncPtr cP60sche::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP60sche::Out92H )
};

const Device::InFuncPtr cP60sche::indef[] = {
};



const Device::Descriptor cP62sche::descriptor = {
	cP62sche::indef, cP62sche::outdef
};

const Device::OutFuncPtr cP62sche::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP62sche::Out92H ),
	STATIC_CAST( Device::OutFuncPtr, &cP62sche::OutC1H ),
	STATIC_CAST( Device::OutFuncPtr, &cP62sche::OutF6H )
};

const Device::InFuncPtr cP62sche::indef[] = {
};
