#ifndef TICKER_H_INCLUDED
#define TICKER_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "SThread.h"

////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cP6sche : public SThread, public IDoko {
public:
	// ٥ȥ
	enum TrgType{ TRSYNC=0, TRTIMER, TRCMT, EndofTR };
	
protected:
	// ٥Ⱦ¤
	typedef struct{
		int TrState;		// ȥꥬơȿ
		int State;			// Ĥꥹơȿ
		BOOL TrReq;			// ٥ȯȥꥬ
		int nps;			// 1äΥ٥ȯ
		int ncount;			// ٥ȯ
		int ratio;			// ٥ȯΨ
	} EVINFO;
	
	SDL_sem *Z80Sem;				// Z80ޥե
	
	BOOL CrtDisp;					// CRTɽ(BUSREQ) TRUE:ɽ FALSE:ɽ
	BOOL N60Win;					// ɥ TRUE:N60 FALSE:N60m
	
	int CpuClock;					// CPUå(Hz)
	
	EVINFO ev[EndofTR];				// ٥Ⱦ
//	int NextState;					// ΥȥꥬޤǤκǾơȿ
	
/////////////////////////////////////////////////
	int SoundBuffer;				// ɥХåեĹ(ms)
	int PsgState;					// PSGơȿ
	int Z80PsgState;				// CPUơȿ(PSG)
/////////////////////////////////////////////////
	
	void OnThread( void * );		// åɴؿ
	virtual void SetState( BOOL, BOOL ) = 0;	// CPUơȿ
	
//	TrgType GetNextTrigger();		// ΥȥꥬΥפ
	
public:
	cP6sche();						// 󥹥ȥ饯
	virtual ~cP6sche();				// ǥȥ饯
	
	virtual BOOL Init( int );		// 
	
	BOOL Start();					// ư
	void Stop();					// ư
	
	void WaitZ80( BOOL );			// Z80 Wait
	
	void SetCpuClock( int );		// CPUå
	
	int GetRatio( TrgType tt ){ return ev[tt].ratio; }	// ٥ȯΨ
	
	// ߴط
	void IntrCtrl( int );			// ơȿȳȯ
	
	BOOL IsTimerIntrReq();			// ޳׵å
	BOOL IsCmtIntrReq();			// CMT׵å

/////////////////////////////////////////////////
	int PsgUpdateSamples( int );	// PSGץ
/////////////////////////////////////////////////

	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class cP60sche : public cP6sche, public Device {
private:
	void SetState( BOOL, BOOL );	// CPUơȿ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void Out92H( DWORD, BYTE data ){ CrtDisp = data&2 ? TRUE : FALSE; SetState( CrtDisp, N60Win ); }
	
public:
	cP60sche( const ID& id );		// 󥹥ȥ饯
	~cP60sche();					// ǥȥ饯
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ out92H=0 };
	// INǥХID
	enum IDIn{};
};


class cP62sche : public cP6sche, public Device {
private:
	BYTE io_F6H;
	
	void SetState( BOOL, BOOL );	// CPUơȿ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void Out92H( DWORD, BYTE data ){ CrtDisp = data&2 ? TRUE : FALSE; SetState( CrtDisp, N60Win ); }
	inline void OutC1H( DWORD, BYTE data ){ N60Win  = data&2 ? TRUE : FALSE; SetState( CrtDisp, N60Win ); }
	inline void OutF6H( DWORD, BYTE data ){ io_F6H  = data;                  SetState( CrtDisp, N60Win ); }
	
public:
	cP62sche( const ID& id );		// 󥹥ȥ饯
	~cP62sche();					// ǥȥ饯
	
	BOOL Init( int );				// 
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ out92H=0, outC1H, outF6H };
	// INǥХID
	enum IDIn{};
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// TICKER_H_INCLUDED
