#include "voice.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6voice::cP6voice( const ID& id ) : Device(id)
{
	// ե饰
	BusyFlag   = FALSE;
	ReqFlag    = TRUE;
	IntExtFlag = FALSE;
	ErrorFlag  = FALSE;
	
	Frame   = 10;
	Speed   = 0;
	Command = 0xff;
	
	Pnum    = 0;
	
	io_E0H = io_E1H = io_E2H = io_E3H = 0;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6voice::~cP6voice()
{
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6voice::Init( cRing *buf, int rate )
{
	// ȥ꡼ݥ
	Buf = buf;
	
	// 20msΥץ
	Len20ms = rate/50;
	
	Volume = DEFAULT_VOICEVOL;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ⡼ɥå
////////////////////////////////////////////////////////////////
void cP6voice::SetMode( BYTE data )
{
	PRINTD( VOI_LOG, "[VOICE][SetMode] " );
	
	// ʬϥե졼
	if( data & 0x40 ) Frame = 20;
	else              Frame = 10;
	
	// ȯ®
	Speed = data & 0x03;
	
	// ԥåνϤǤΤ?
	Pitch = 30;			// ϰϤ1-128 ͤ30餷
	
	PRINTD2( VOI_LOG, "Frame:%d Speed:%d\n", Frame, Speed );
}


////////////////////////////////////////////////////////////////
// ޥɥå
////////////////////////////////////////////////////////////////
void cP6voice::SetCommand( BYTE data )
{
	PRINTD( VOI_LOG, "[VOICE][SetCommand] " );
	
	ErrorFlag = FALSE;
	
	switch( data ){
	case 0xff:	// ȥåץޥ
		PRINTD( VOI_LOG, "Stop\n" );
		
		BusyFlag = FALSE;
		ReqFlag  = FALSE;
		Pnum     = 0;
		
		// ȯ߽
		
		break;
		
	case 0xfe:	// 򥳥ޥ
		PRINTD( VOI_LOG, "Ext\n" );
		
		BusyFlag   = TRUE;
		IntExtFlag = TRUE;
		ReqFlag    = TRUE;
		Pnum       = 7;		// ǽΥѥ᡼ɬ7
		
		// ȯϽ
		
		BusyFlag = FALSE;
		
		break;
		
	default:	// ʳ򥳥ޥ
		PRINTD1( VOI_LOG, "Int:%d\n", data );
		
		BusyFlag   = TRUE;
		IntExtFlag = FALSE;
		
		// ȯ
		
		BusyFlag = FALSE;
	}
}


////////////////////////////////////////////////////////////////
// ѥ᡼å
////////////////////////////////////////////////////////////////
void cP6voice::SetParameter( BYTE data )
{
//	PRINTD( VOI_LOG, "[VOICE][SetParameter] " );
	
	// ѥ᡼׵ե饰ΩäƤʤХ顼
	if( !ReqFlag ){
		ErrorFlag = TRUE;
		return;
	}
	
	switch( Pnum ){
	case 7:
		TIMEn = (data>>3)&0x1f;
		QMAG  = data&4 ? TRUE : FALSE;
		SI    = data&2 ? TRUE : FALSE;
		V_UV  = data&1 ? TRUE : FALSE;
		
//		PRINTD4( VOI_LOG, "[1] TIME:%d QMAG:%d S.I:%d V/UV:%d\n", TIMEn, QMAG ? 1 : 0, SI ? 1 : 0, V_UV ? 1 : 0 );
		PRINTD1( VOI_LOG, "%02X ", data );
		
		Pnum--;
		break;
		
	case 6:
	case 5:
	case 4:
	case 3:
	case 2:
		Freqn[6-Pnum] = (data>>3)&0x1f;
		Band[6-Pnum]  = data&7;
		Pnum--;
		
//		PRINTD5( VOI_LOG, "[%d] f%d:%2d b%d:%2d\n", 7-Pnum, 6-Pnum, Freqn[5-Pnum], 6-Pnum, Band[5-Pnum] );
		PRINTD1( VOI_LOG, "%02X ", data );
		
		break;
		
	case 1:
		// TIMEn0ʤ齪λ
		if( !TIMEn ){
			BusyFlag = FALSE;
			ReqFlag  = FALSE;
			Pnum     = 0;	// ǰΤ
			
			PRINTD1( VOI_LOG, "%02X\n", data );
			PRINTD( VOI_LOG, "Finish\n" );
			
		}else{
			amp   = (data>>4)&0x0f;
			FV    = data&8 ? TRUE : FALSE;
			Pitch = max( 1, min( 128, Pitch + data&4 ? (~3)|data&7 : data&7 ) );
			if( !(--TIMEn) ) Pnum = 7;
			
//			PRINTD4( VOI_LOG, "[7] amp:%2d FV:%d p:%2d(%2d)\n", amp, FV ? 1 :0, Pitch, data&4 ? (~3)|data&7 : data&7 );
			PRINTD1( VOI_LOG, "%02X\n", data );
		}
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
void cP6voice::SetVolume( int vol )
{
	Volume = min( max( vol, 0 ), 100 );
}


////////////////////////////////////////////////////////////////
// ȥ꡼๹
////////////////////////////////////////////////////////////////
void cP6voice::Update( void )
{
	PRINTD( VOI_LOG, "[VOICE][Update]\n" );
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor cP6voice::descriptor = {
	cP6voice::indef, cP6voice::outdef
};

const Device::OutFuncPtr cP6voice::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP6voice::OutE0H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6voice::OutE1H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6voice::OutE2H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6voice::OutE3H )
};

const Device::InFuncPtr cP6voice::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &cP6voice::InE0H ),
	STATIC_CAST( Device::InFuncPtr, &cP6voice::InE1H ),
	STATIC_CAST( Device::InFuncPtr, &cP6voice::InE2H ),
	STATIC_CAST( Device::InFuncPtr, &cP6voice::InE3H )
};
