#ifndef VOICE_H_INCLUDED
#define VOICE_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "sound.h"

// [OUT]
//  E0H : ѥ᡼ž
//  E1H : ?
//  E2H : ⡼ɥå : 0 0 0 0 F S1 S0
//			F     : ʬϥե졼 0: 10ms/ե졼
//									 1: 20ms/ե졼
//			S1,S0 : ȯ®BIT     00: NORMAL SPEED
//									01: SLOW SPEED
//									10: FAST SPEED
//									11: ػ

//  E3H : ޥɥå
//		򥳥ޥ : 0 0 P5 P4 P3 P2 P1 P0
//			P5-P0 : ӥå(0-63)
//		ȥåץޥ   : 1 1 1 1 1 1 1 1
//		򥳥ޥ : 1 1 1 1 1 1 1 0
//

// [IN]
//  E0H : ơ쥸 : BSY REQ ~INT/EXT ERR 0 0 0 0
//			BSY      :  1: 0:
//			REQ      : ѥ᡼ 1:׵ 0:ػ
//			~INT/EXT : åǡ 1: 0:
//			ERR      : 顼ե饰 1:顼 0:顼ʤ
//  E1H : ?
//  E2H : ?
//  E3H : ?


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cP6voice : public Device {
private:
	BOOL BusyFlag;			// ե饰 TRUE: FALSE:
	BOOL ReqFlag;			// ѥ᡼׵ե饰 TRUE:׵ FALSE:ػ
	BOOL IntExtFlag;		// åǡ⳰ե饰 TRUE: FASLE:
	BOOL ErrorFlag;			// 顼ե饰 TRUE:顼 FALSE:顼ʤ
	
	int Frame;				// ʬϥե졼(ms/ե졼)
	int Speed;				// ȯ® 0:NORMAL 1:SLOW 2:FAST
	int Command;			// ޥ
	
	int Volume;				// 
	
	// ѥ᡼Ƽ
	BOOL TIMEn;
	BOOL QMAG;
	BOOL SI;
	BOOL V_UV;
	int Freqn[5];
	int Band[5];
	int amp;
	BOOL FV;
	int Pitch;
	
	int Pnum;				// ɤ߹ѥ᡼
	
	cRing *Buf;				// ȥ꡼ݥ
	Uint32 Len20ms;			// 20msΥץ
	
	BYTE io_E0H;
	BYTE io_E1H;
	BYTE io_E2H;
	BYTE io_E3H;
	
	void SetMode( BYTE );		// ⡼ɥå
	void SetCommand( BYTE );	// ޥɥå
	void SetParameter( BYTE );	// ѥ᡼å
	
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutE0H( DWORD, BYTE data ){ SetParameter( data ); }
	inline void OutE1H( DWORD, BYTE data ){ io_E1H = data; PRINTD1( VOI_LOG, "[VOICE][OutE1H] %02X\n", data ); }
	inline void OutE2H( DWORD, BYTE data ){ SetMode( data ); }
	inline void OutE3H( DWORD, BYTE data ){ SetCommand( data ); }
	
//	inline BYTE InE0H( DWORD ){ PRINTD1( VOI_LOG, "[VOICE][InE0H] %02X\n", (BusyFlag ? 0x80 : 0)|(ReqFlag ? 0x40 : 0)|(IntExtFlag ? 0x20 : 0)|(ErrorFlag ? 0x10 : 0) ); return (BusyFlag ? 0x80 : 0)|(ReqFlag ? 0x40 : 0)|(IntExtFlag ? 0x20 : 0)|(ErrorFlag ? 0x10 : 0); }
	inline BYTE InE0H( DWORD ){ return (BusyFlag ? 0x80 : 0)|(ReqFlag ? 0x40 : 0)|(IntExtFlag ? 0x20 : 0)|(ErrorFlag ? 0x10 : 0); }
	inline BYTE InE1H( DWORD ){ PRINTD1( VOI_LOG, "[VOICE][InE1H] %02X\n", io_E1H ); return io_E1H; }
	inline BYTE InE2H( DWORD ){ PRINTD1( VOI_LOG, "[VOICE][InE2H] %02X\n", io_E2H ); return io_E2H; }
	inline BYTE InE3H( DWORD ){ PRINTD1( VOI_LOG, "[VOICE][InE3H] %02X\n", io_E3H ); return io_E3H; }
	
public:
	cP6voice( const ID& id );	// 󥹥ȥ饯
	~cP6voice();				// ǥȥ饯
	
	BOOL Init( cRing *, int );	// 
	
	void SetVolume( int );		// 
	
	void Update();				// ȥ꡼๹
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ outE0H=0, outE1H, outE2H, outE3H };
	// INǥХID
	enum IDIn{ inE0H=0, inE1H, inE2H, inE3H };
};


#endif	// VOICE_H_INCLUDED
