#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "intr.h"
#include "io.h"
#include "memory.h"

// ڥ쥸 ǡ
typedef union
{
	struct { BYTE l,h; } B;
			 WORD        W;
} PAIR;

// 쥸 ¤
struct Register {
	PAIR AF, BC, DE, HL;	// ѥ쥸
	PAIR IX, IY, PC, SP;	// ѥ쥸
	PAIR AF1,BC1,DE1,HL1;	//  ΢ 쥸
	BYTE I, R;				// ü쥸
	BYTE R_saved;			// R reg ¸
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// ⡼
	BYTE Halt;				// HALT ե饰
};


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cz80 : public IDoko {
protected:
	PAIR AF, BC, DE, HL;	// ѥ쥸
	PAIR IX, IY, PC, SP;	// ѥ쥸
	PAIR AF1,BC1,DE1,HL1;	//  ΢ 쥸
	BYTE I, R;				// ü쥸
	BYTE R_saved;			// R reg ¸
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// ⡼
	BYTE Halt;				// HALT ե饰
	
	int M1Wait;				// M1
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	void PrintfHead( char *, WORD, int );	// ɥ쥹/󥹥ȥ饯󥳡ɤɽ
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// @@@@@ڼ¸ۥꥢ @@@@@
	int mstate;		// ꥢ ơȿ
	// Ȥʤ
	virtual BYTE ReadMem( WORD )         = 0;
	virtual void WriteMem( WORD, BYTE )  = 0;
	// Ȥꥢ
	virtual BYTE ReadMemW( WORD )        = 0;
	virtual void WriteMemW( WORD, BYTE ) = 0;
	
	// I/Oݡȥ
	virtual BYTE ReadIO( BYTE )          = 0;
	virtual void WriteIO( BYTE, BYTE )   = 0;
	
	// ߥ٥
	virtual int GetIntrVector() = 0;
	
public:
	cz80();					// 󥹥ȥ饯
	virtual ~cz80();		// ǥȥ饯
	
	void Reset();			// ꥻå
	int Exec();				// 1̿¹
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	int Disasm( char *, WORD );		// 1饤ե֥
	void GetRegister( Register * );	// 쥸ͼ
	void SetRegister( Register * );	// 쥸
	WORD GetPC(){ return PC.W; }	// PC쥸ͼ
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class cP6z80 : public cz80, public Device {
private:
	cP6memory *lpcP6memory;	// ꥪ֥ȤؤΥݥ
	cP6io *lpcP6io;			// I/Oݡȥ֥ȤؤΥݥ
	cP6intr *lpcP6intr;		// ߽֥ȤؤΥݥ
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void OutF3H( DWORD, BYTE data ){ M1Wait = (data&0x80 ? 1 : 0); }
	
	
	// @@@@@ڼ¸ۥꥢ @@@@@
	// Ȥʤ
	inline BYTE ReadMem( WORD addr )            { return (lpcP6memory->Read)( addr ); }
	inline void WriteMem( WORD addr, BYTE data ){ (lpcP6memory->Write)( addr, data ); }
	// Ȥꥢ
	inline BYTE ReadMemW( WORD addr )           { mstate++; return ReadMem( addr );   }
	inline void WriteMemW( WORD addr, BYTE data){ mstate++; WriteMem( addr, data );   }
	
	// I/Oݡȥ
	inline BYTE ReadIO( BYTE addr )            { return lpcP6io->In( addr );   }
	inline void WriteIO( BYTE addr, BYTE data ){ (lpcP6io->Out)( addr, data ); }
	
	// ߥ٥
	inline int GetIntrVector(){ return lpcP6intr->IntrCheck(); }
	
public:
	cP6z80( const ID& id );	// 󥹥ȥ饯
	~cP6z80();				// ǥȥ饯
	
	BOOL Init( cP6memory *, cP6io *, cP6intr * );	// 
	
	// ǥХ
	// OUTǥХID
	enum IDOut{ outF3H=0 };
	// INǥХID
	enum IDIn{};
};

#endif		// Z80_H_INCLUDED
